mui.init();
mui.previewImage(); // 图片预览

var first = new Vue({
	i18n: vueI18n,
	el: "#main",
	data: {
		item: {
			id: '',
			ckId: '',
			ckMc: '',
			djrq: new Date().Format("yyyy-MM-dd"),
			qtrkdBh: '',
			shzt: '0',
			wldw: '',
			rkmxDataList: [],
			wldwMc: '',
			rklx: '',
			rklxMc: '',
			zzdjs: [],
			zzdjDataList: [],
			ztext1: '',
			ztext2:'',
			ztext3:'',
			ztext4:'',
			ztext5:'',
			ztext6:'',
			ztext7:'',
			ztext8:'',
			ztext9:'',
			ztext10:'',
			mxext1: '',
			mxext2:'',
			mxext3:'',
			mxext4:'',
			mxext5:'',
			mxext6:'',
			mxext7:'',
			mxext8:'',
			mxext9:'',
			mxext10:''
		},
		rkjeHj: 0.00,
		rkslHj: 0,
		isXlhBz: false,
		isPchBz: false,
		isShowXzBtn: false,
		menuList: [],
		pdMenuList: [], //盘点权限列表,
		hasSdck: false, //是否拥有锁定，解锁仓库权限
		isFinish: false,
		showAuditBtn: false,
		baseRkdExtList: [],
		baseRkmxExtList: [],
		isEnabledSplc4Rkd: '0'
	},
	methods: {
		/*锁定解锁权限判断*/
		hasSdckPermission: function() {
			if(this.pdMenuList != null) {
				for(var i = 0; i < this.pdMenuList.length; i++) {
					if(this.pdMenuList[i].permission == 'inv:invPdd:check') {
						this.hasSdck = true;
						break;
					}
				}
			}
		},
		/*判断系统参数*/
		hasXtcsPermission: function() {
			var xlhBz = localStorage.getItem("xlhBz");
			var kqpchBz = localStorage.getItem("kqpchBz");
			/*判断是否开启序列号*/
			if(xlhBz === '1') { //0停用；1启用
				this.isXlhBz = true;
			}
			/*判断是否开启批次号*/
			if(kqpchBz === '1') { //0停用；1启用
				this.isPchBz = true;
			}
		},
		//判断是否有审核权限
		hasPermission: function() {
			for(var i = 0; i < this.menuList.length; i++) {
				if(this.menuList[i].permission == 'inv:invQtrk:audit') {
					this.showAuditBtn = true;
					break;
				}
			}
		},
		//计算填写的数量
		cal: function() {
			var sum = 0,
				count = 0;
			mui.each(this.item.rkmxDataList, function(index, item) {
				if(item.rkdj == null || isNaN(item.rkdj)) {
					item.rkdj = 0;
				}
				if(item.rksl == null || isNaN(item.rksl)) {
					item.rksl = 0;
				}
				
				item.rksl = formatSl(item.rksl, item.dwYxxsBz);
				item.rkdj = Number(item.rkdj);
				item.rkje = Number(item.rksl) * Number(item.rkdj);

				sum = Number(sum) + Number(item.rkje);
				count = Number(count) + Number(item.rksl);
			});
			first.rkslHj = count;
			first.rkjeHj = sum;
		},
		//删除已选的商品
		del: function(index) {
			this.item.rkmxDataList.splice(index, 1);
			this.cal();
		},
		/*打开序列号添加页*/
		openXlh: function(el) {
			if(this.isXlhBz && el.kqxlhBz=='1') {
				if(el.xlhList == undefined) {
					el.xlhList = [];
				}
				var extras = {
					item: el,
					rkmxDataList: this.item.rkmxDataList,
					source: 'druku_xz.html'
				}
				var url = 'druku_xlhxz.html';
				/*判断是否为调拨入库*/
				if(this.item.rklx === '3') {
					url = 'druku_xlhxz_db.html';
				}
				var webview = plus.webview.create(url, url, webview_style, extras);
				webview.addEventListener("titleUpdate", function() {
					webview.show("slide-in-right", 300);
				});
			} else if(this.isPchBz && el.kqpchBz=='1') {
				if(el.phxxList == undefined) {
					el.phxxList = [];
				}

				var extras = {
					item: el,
					title: '按批号填写入库数量'
				}
				var webview = plus.webview.create('../common/select_pch4rk.html', 'select_pch4rk.html', webview_style, extras);
				webview.addEventListener("titleUpdate", function() {
					webview.show("slide-in-right", 300);
				});
			}
		},
		/*完成按钮事件*/
		save: function(shzt) {
			var params = this.item;
			params.shzt = shzt;
			
			if(params.djrq == '') {
				mui.toast('请填写入库日期！');
				return;
			}
			
			if(mustArr.length > 0){
				var flag = false;
				for (var i = 0; i < mustArr.length; i++) {
					var item = mustArr[i];
					var lable = item.lable;
					var name = item.name;
					if ($.trim(params[name]) == '') {
						if(item.dataType == '3'){
							mui.toast(lable+"不能为空，请选择！");
						} else {
							mui.toast(lable+"不能为空，请填写！");
						}
						
						flag = true;
						break;
					}
				}
				if(flag){
					return;
				}
			}
			
			var isEmpty = true;
			var isFlag = false;
			mui.each(params.rkmxDataList, function(index, item) {
				if(Number(item.rksl) > 0) {
					isEmpty = false;
				}
				
				var drksl = Number(item.drksl) - Number(item.yrksl);
				drksl = formatSl(drksl,item.dwYxxsBz);
				
				if( drksl < Number(item.rksl) ) {
					isFlag = true;
					return false;
				}
			})
			if(isFlag) {
				mui.toast('入库数量不能大于待入库数量！');
				return;
			}
			if(isEmpty) {
				mui.toast("所有商品的【本次入库数】都为【0】，不允许生成入库单！");
				return;
			}
			
			//只允许点击一次完成，避免多次生成数据
			if(first.isFinish){
				return;
			}
			first.isFinish = true;
			
			params.drkId = params.id;
			params.rkjeHj = first.rkjeHj;
			params.rkslHj = first.rkslHj;
			params.id = "";

			var url = hurl + 'qtrkmx/save';
			loafish.utils.ajax4Post(url, params, "application/json", function(returnData) {
				if(returnData.success) {
					var data = returnData.data;

					var mainPage = plus.webview.getWebviewById("chukuRuku/ruku.html");
					mui.fire(mainPage, "queryRkd", {
						ywlx: '2'
					});

					//刷新待办事项
					var dbPage = plus.webview.getWebviewById("daiban.html");
					mui.fire(dbPage, "loadDbNum", {});

					if(mainPage!==null){
						mui.back = function() {
							mainPage.show();
						}
					}

					mui.back();
					mui.toast('操作成功！');
				} else {
					if(returnData.lock) {
						var ckTips = "";
						if(first.hasSdck) {
							ckTips = '<a onclick="tzck();return false">前往解锁</a>';
						} else {
							ckTips = "<span style='color:red;'>请通知仓库管理员进行解锁</span>";
						}
						mui.alert("此仓库为盘点锁定状态，请解锁后再进行操作！\n " + ckTips, "提示", "确定", function() {}, 'div')
						return;
					} else {
						mui.toast(returnData.msg);
					}

				}
			});
		},
		//对扩展字段进行计算
		rowExtCal : function(fieldName){
			
			var isExists = false;
			mui.each(first.baseRkmxExtList, function(index, ckmxExt) {
				if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
					var jsgs = ckmxExt.jsgs;
					if(/【\w*】/.test(jsgs)){
						var tmpVarNameArr = jsgs.match(/【\w*】/g);
						var gs = jsgs;
						for(var i=0; i < tmpVarNameArr.length; i++){
							var tmpVarNameStr = tmpVarNameArr[i];
							var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
							
							if(fieldName === tmpVarName){
								isExists = true;
								break;
							}
						}
					}
				}
			});
			
			if(isExists){
				mui.each(first.item.rkmxDataList, function(i, item) {
					mui.each(first.baseRkmxExtList, function(index, ckmxExt) {
						if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
							var jsgs = ckmxExt.jsgs;
							if(/【\w*】/.test(jsgs)){
								var tmpVarNameArr = jsgs.match(/【\w*】/g);
								var gs = jsgs;
								for(var i=0; i < tmpVarNameArr.length; i++){
									var tmpVarNameStr = tmpVarNameArr[i];
									var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
									
									if(tmpVarName.indexOf("ztext") == 0){
										var tmpVal = Number(first.item[tmpVarName]);
										gs = gs.replace(tmpVarNameStr,tmpVal);
									}else{
										var tmpVal = Number(item[tmpVarName]);
										gs = gs.replace(tmpVarNameStr,tmpVal);
									}
								}
								
								var val = formatJe(eval(gs));
								item[ckmxExt.name] = val;
							} else {
								var val = formatJe(eval(jsgs));
								item[ckmxExt.name] = val;
							}
						}
					});
				});
			}
		},
		gsCal: function(item){
			mui.each(first.baseRkmxExtList, function(index, ckmxExt) {
				if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
					var jsgs = ckmxExt.jsgs;
					if(/【\w*】/.test(jsgs)){
						var tmpVarNameArr = jsgs.match(/【\w*】/g);
						var gs = jsgs;
						for(var i=0; i < tmpVarNameArr.length; i++){
							var tmpVarNameStr = tmpVarNameArr[i];
							var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
							
							if(tmpVarName.indexOf("ztext") == 0){
								var tmpVal = Number(eval("first.item."+tmpVarName));
								gs = gs.replace(tmpVarNameStr,tmpVal);
							}else{
								var tmpVal = Number(eval("item."+tmpVarName));
								gs = gs.replace(tmpVarNameStr,tmpVal);
							}
						}
						
						var val = formatJe(eval(gs));
						Vue.set(item, ckmxExt.name, val)
					} else {
						var val = formatJe(eval(jsgs));
						Vue.set(item, ckmxExt.name, val);
					}
				}
			});
		}
	}
});

/*回调函数--设置序列号值*/
window.addEventListener('setXlhList', function(e) {
	var id = e.detail.id;
	var xlhList = e.detail.xlhList;
	mui.each(first.item.rkmxDataList, function(index, item) {
		//通过商品ID定位序列号所属明细
		if(item.id == id) {
			item.xlhList = xlhList;
			item.rksl = xlhList.length;
			return false;
		}
	})
	first.cal();
})

/*回调函数--设置批次号值*/
window.addEventListener('setPhxxList', function(e) {
	var spId = e.detail.spId;
	var phxxList = e.detail.phxxList;
	var rksl = e.detail.rksl;
	mui.each(first.item.rkmxDataList, function(index, item) {
		//通过商品ID和明细id（调拨单同一商品多个批次号会生成多个明细--此时根据明细id定位唯一的明细）定位批次号所属明细
		if(item.spId == spId && e.detail.id == item.id) {
			item.phxxList = phxxList;
			item.rksl = rksl;
			return false;
		}
	})
	first.cal();
});

function getData() {
	var xlhBz = localStorage.getItem("xlhBz");
	var kqpchBz = localStorage.getItem("kqpchBz");

	var url = hurl + 'qtrkmx/drkList';
	var params = {
		drkdId: first.item.id
	};
	loafish.utils.ajax4Get(url, params, null, function(returnData) {
		
		for(var i=0; i<returnData.length; i++){
			var row = returnData[i];
            var rksl = row.drksl - row.yrksl;
            row.rksl = formatSl(rksl, row.dwYxxsBz);
            
            if (row.kqxlhBz == '1' && xlhBz === '1') {
                row.rksl = 0;
            }
            if (row.kqpchBz === '1' && kqpchBz === '1') {
            	row.rksl = 0;
            }
        }
		
		first.item.rkmxDataList = returnData;
		
		first.cal();
	});
}

//======================================================================
var mustArr = [];
mui.plusReady(function() {
	var _self = plus.webview.currentWebview();
	first.item = _self.qtrkd;
	first.item.rkmxDataList = [];
	first.item.zzdjs = [];
	first.item.zzdjDataList = [];
	first.item.djrq = new Date().Format("yyyy-MM-dd");

	first.hasXtcsPermission();
	//获取盘点权限
	first.pdMenuList = getMenuPermissions("pandian/pandian.html");
	first.hasSdckPermission();
	
	//权限获取
	first.menuList = getMenuList("chukuRuku/ruku.html");
	first.hasPermission();
	
	getData();
	
	first.baseRkdExtList = JSON.parse(localStorage.getItem('baseRkdExtList'));
	if(first.baseRkdExtList == null){
		first.baseRkdExtList = [];
	}
	first.baseRkdExtList.forEach(function(base, index){
		if(base.mustFlag != null && base.mustFlag == '1'){
			mustArr.push({ lable : base.lable, name : base.name, dataType: base.dataType });
		}
	});
	
	first.baseRkmxExtList = JSON.parse(localStorage.getItem('baseRkmxExtList'));	
	if(first.baseRkmxExtList == null){
		first.baseRkmxExtList = [];
	}
	
	first.isEnabledSplc4Rkd = localStorage.getItem("isEnabledSplc4Rkd");
});

mui('.mui-scroll-wrapper').scroll();