//页面总数
var pages;
//刷新次数--用于判断是否还有数据
var count = 1;

mui.init();

mui.previewImage(); // 图片预览

new Vue({
	i18n: vueI18n,
	el: "#avue"
});

//================================================================================
var first = new Vue({
	i18n: vueI18n,
	el: "#main",
	data: {
		item: {
			id: '',
			ckId: '',
			ckMc: '',
			djrq: new Date().Format("yyyy-MM-dd"),
			qtrkdBh: '',
			shzt: '0',
			wldw: '',
			rkmxDataList: [],
			wldwMc: '',
			rklx: '1',
			rklxMc: getMsg('采购入库'),
			ckrq: new Date().Format("yyyy-MM-dd"),
			rkjeHj: 0.00,
			rkslHj: 0,
			zzdjs: [],
			zzdjDataList: [],
			remarks: '',
			xmId: '',
			xmBh: '',
			xmMc: '',
			ztext1: '',
			ztext2:'',
			ztext3:'',
			ztext4:'',
			ztext5:'',
			ztext6:'',
			ztext7:'',
			ztext8:'',
			ztext9:'',
			ztext10:'',
			mxext1: '',
			mxext2:'',
			mxext3:'',
			mxext4:'',
			mxext5:'',
			mxext6:'',
			mxext7:'',
			mxext8:'',
			mxext9:'',
			mxext10:''
		},
		isXlhBz: false,
		isPchBz: false,
		tag: '',
		ddwArr: [],
		qhId: '',
		qhdw: '',
		zdw: '',
		showXlh:false,
		showJg: false,
		isFinish : false,
		showAuditBtn: false,
		menuList:[],
		baseRkdExtList: [],
		baseRkmxExtList: [],
		isEnabledSplc4Rkd:'0'
	},
	methods: {
		sxlh:function(){
			if(first.item.ckId == '') {
				mui.toast('请选择入库仓库！');
				return;
			}
			
			tzBarcode('ruku_xz.html',true);
		},
		xzWldwlX : function(){
			mui('#wldwlxPopover').popover('toggle');
		},
		toXzGys: function(){
			var subWebview = plus.webview.create('../common/select_gys.html', '../common/select_gys.html', webview_style, {
				enableFlag: '1',
				source: 'ruku_xz.html'
			});
			subWebview.addEventListener("titleUpdate", function() {
				subWebview.show("slide-in-right", 300);
			});
			
			mui('#wldwlxPopover').popover('toggle');
		},
		toXzKh: function(){
			var subWebview = plus.webview.create('../common/select_kh.html', '../common/select_kh.html', webview_style, {
				enableFlag: '1'
			});
			subWebview.addEventListener("titleUpdate", function() {
				subWebview.show("slide-in-right", 300);
			});
			
			mui('#wldwlxPopover').popover('toggle');
		},		
		clear: function() {
			first.item.wldw = "";
			first.item.wldwMc = "";
		},
		clearXmxx: function() {
			first.item.xmId = "";
			first.item.xmBh = "";
			first.item.xmMc = "";
		},
		/*判断系统参数*/
		hasXtcsPermission: function() {
			var xlhBz = localStorage.getItem("xlhBz");
			var kqpchBz = localStorage.getItem("kqpchBz");
			if(xlhBz === '1') { //0停用；1启用
				this.isXlhBz = true;
			}
			if(kqpchBz === '1') { //0停用；1启用
				this.isPchBz = true;
			}
		},
		/*选择商品*/
		xzsp: function(item, index) {
			item.ckId = first.item.ckId;
			mui.openWindow({
				id: 'select_rkspXq.html',
				url: 'select_rkspXq.html',
				styles: {
					background: 'transparent'
				},
				show: {
					autoShow: true,
					aniShow: 'none'
				},
				waiting: {
					autoShow: false
				},
				extras: {
					item: item,
					index: index,
					djObj: first.item
				}
			});
		},
		//计算填写的数量
		cal: function() {
			var sum = 0,
				count = 0;
			mui.each(this.item.rkmxDataList, function(index, item) {
				if(item.rkdj == null || isNaN(item.rkdj)) {
					item.rkdj = 0;
				}
				if(isNaN(item.rksl)) {
					item.rksl = 0;
				}

				item.rkdj = Number(item.rkdj);
				item.rkje = Number(item.rksl) * Number(item.rkdj);
				sum = calc.Add(Number(sum) , Number(item.rkje)) ;
				count = calc.Add(Number(count) , Number(item.rksl));
			});
			this.item.rkslHj = count;
			this.item.rkjeHj = sum;
		},
		gsCal: function(item){
			mui.each(first.baseRkmxExtList, function(index, ckmxExt) {
				if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
					var jsgs = ckmxExt.jsgs;
					if(/【\w*】/.test(jsgs)){
						var tmpVarNameArr = jsgs.match(/【\w*】/g);
						var gs = jsgs;
						for(var i=0; i < tmpVarNameArr.length; i++){
							var tmpVarNameStr = tmpVarNameArr[i];
							var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
							
							if(tmpVarName.indexOf("ztext") == 0){
								var tmpVal = Number(first.item[tmpVarName]);
								gs = gs.replace(tmpVarNameStr,tmpVal);
							}else{
								var tmpVal = Number(item[tmpVarName]);
								gs = gs.replace(tmpVarNameStr,tmpVal);
							}
						}
						
						var val = formatJe(eval(gs));
						item[ckmxExt.name] = val;
					} else {
						var val = formatJe(eval(jsgs));
						item[ckmxExt.name] = val;
					}
				}
			});
		},
		//对扩展字段进行计算
		rowExtCal : function(fieldName){
			
			var isExists = false;
			mui.each(first.baseRkmxExtList, function(index, ckmxExt) {
				if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
					var jsgs = ckmxExt.jsgs;
					if(/【\w*】/.test(jsgs)){
						var tmpVarNameArr = jsgs.match(/【\w*】/g);
						var gs = jsgs;
						for(var i=0; i < tmpVarNameArr.length; i++){
							var tmpVarNameStr = tmpVarNameArr[i];
							var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
							
							if(fieldName === tmpVarName){
								isExists = true;
								break;
							}
						}
					}
				}
			});
			
			if(isExists){
				mui.each(first.item.rkmxDataList, function(i, item) {
					mui.each(first.baseRkmxExtList, function(index, ckmxExt) {
						if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
							var jsgs = ckmxExt.jsgs;
							if(/【\w*】/.test(jsgs)){
								var tmpVarNameArr = jsgs.match(/【\w*】/g);
								var gs = jsgs;
								for(var i=0; i < tmpVarNameArr.length; i++){
									var tmpVarNameStr = tmpVarNameArr[i];
									var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
									
									if(tmpVarName.indexOf("ztext") == 0){
										var tmpVal = Number(first.item[tmpVarName]);
										gs = gs.replace(tmpVarNameStr,tmpVal);
									}else{
										var tmpVal = Number(item[tmpVarName]);
										gs = gs.replace(tmpVarNameStr,tmpVal);
									}
								}
								
								var val = formatJe(eval(gs));
								item[ckmxExt.name] = val;
							} else {
								var val = formatJe(eval(jsgs));
								item[ckmxExt.name] = val;
							}
						}
					});
				});
			}
		},
		//保存至草稿（开启审核流程时使用）
		save2lscg: function(){
			save('-1');	
		},
		//保存至草稿
		save2cg: function(){
			save('0');	
		},
		//保存并审核
		save2sh: function(){
			save('1');	
		},
		//判断是否有审核权限
		hasPermission: function() {
			for(var i = 0; i < this.menuList.length; i++) {
				if(this.menuList[i].permission == 'inv:invQtrk:audit') {
					this.showAuditBtn = true;
					break;
				}
			}
		}
	}
});

/*=================================入库类型==============================*/

var list_rklx = new Vue({
				i18n: vueI18n,
	el: "#list_rklx",
	data: {
		isIos:false,
		items: [],
	}
});

function getRklxData() {
	token = localStorage.getItem('token');
	mui.ajax(hurl + '/dict/getDictList/inv_rklx', {
		dataType: 'json', //服务器返回json格式数据
		type: 'GET', //HTTP请求类型
		headers: {
			Authorization: token
		},
		timeout: 10000, //超时时间设置为10秒；	              
		success: function(data) {
			list_rklx.items = data;

		},
		error: function(xhr, type, errorThrown) {
			//异常处理；
			console.log(type + "异常了");
		}
	});
}

//回调函数-客户赋值
window.addEventListener('setKh', function(e) {
	first.item.wldw = e.detail.khId;
	first.item.wldwMc = e.detail.khMc;
});

/*回调函数-供应商赋值*/
window.addEventListener('setGys', function(e) {
	first.item.wldw = e.detail.gysId;
	first.item.wldwMc = e.detail.gysMc;
});

/*===========================入库类型控件点击触发事件==============================*/
document.getElementById("rklxMc").addEventListener('tap', function() {
	document.getElementById("rklxModal").classList.add("mui-active");

});

document.getElementById("rklxModal_close").addEventListener("tap", function() {
	document.getElementById("rklxModal").classList.remove("mui-active");
});

//入库类型选择
document.querySelector('.mui-table-view.mui-table-view-radio.rklx').addEventListener('selected', function(e) {
	first.item.rklx = e.detail.el.id;
	first.item.rklxMc = e.detail.el.innerText;

	document.getElementById("rklxModal").classList.remove("mui-active");
});

/*===========================仓库名称控件点击触发事件==============================*/
document.getElementById("ckMc").addEventListener('tap', function() {
	var subWebview = plus.webview.create('../common/select_ck.html', '../common/select_ck.html', webview_style, {
		source: 'ruku_xz.html'
	});
	subWebview.addEventListener("titleUpdate", function() {
		subWebview.show("slide-in-right", 300);
	});
});

/*回调函数-给仓库名称赋值*/
window.addEventListener('setCk', function(e) {
	first.item.ckId = e.detail.ckId;
	first.item.ckMc = e.detail.ckMc;

});

/*选择商品按钮*/
document.getElementById("xzsp_btn").addEventListener("tap", function(e) {
	if(first.item.ckId == '') {
		mui.toast('请选择入库仓库！');
		return;
	}

	var subWebview = plus.webview.create('select_rksp.html', 'select_rksp.html', webview_style, {
		item: first.item
	});
	subWebview.addEventListener("titleUpdate", function() {
		subWebview.show(aniShow, 300);
	});
});

/*===========================归属项目名称控件点击触发事件==============================*/
document.getElementById("xmMc").addEventListener('tap', function() {
	var subWebview = plus.webview.create('../common/select_xmxx.html', '../common/select_xmxx.html', webview_style, {
		xmId: first.item.xmId
	});
	subWebview.addEventListener("titleUpdate", function() {
		subWebview.show("slide-in-right", 300);
	});
});
/*回调函数-项目名称赋值*/
window.addEventListener('setXmxx', function(e) {
	first.item.xmId = e.detail.xmId;
	first.item.xmMc = e.detail.xmMc;
});

/*===========================回调函数-选择商品===============================*/
window.addEventListener('selectedSpxx', function(e) {
	var tspljBz = localStorage.getItem("tspljBz");
	
	//开启商品累加选择商品会传数据过去，同时选好后就会把数据拼接好传回来，这时直接接收即可
	if (tspljBz === '1') {
		first.item.rkmxDataList = e.detail;
	}  else {
		//没开启，那么就会重新增加一条数据
		first.item.rkmxDataList = first.item.rkmxDataList.concat(e.detail);
	}
	
	first.cal();
});

/*单个商品回调函数*/
window.addEventListener('setSpNum', function(e) {
	var item = e.detail.item;
	var del = e.detail.del;
	var kqysBz = localStorage.getItem("kqSpysBz");
	//商品索引，跟del一样，不过条件不同，pchIndex是这里判断，传过来处理
	var pchIndex=e.detail.pchIndex;
	//已经处理标志，如果有多个相同id商品不同批号，在遍历中判断
	var isProcess=false;
	if(del != undefined) {
		first.item.rkmxDataList.splice(del, 1);
	} else {
		if( pchIndex != undefined ){
			var it = first.item.rkmxDataList[pchIndex];
			Vue.set(it, 'rksl', Number(item.rksl));
			Vue.set(it, 'rkdj', Number(item.rkdj));
			Vue.set(it, 'rkje', Number(item.rkje));
			Vue.set(it, 'dw', item.dw);
			Vue.set(it, 'dwMc', item.dwMc);
			Vue.set(it, 'xlhList', item.xlhList);
			Vue.set(it, 'remarks', item.remarks);
			if (first.isPchBz && it.kqpchBz === '1'){
				Vue.set(it, 'phId', item.phId);
				Vue.set(it, 'pch', item.pch);
				Vue.set(it, 'scrq', item.scrq);
				Vue.set(it, 'sxrq', item.sxrq);
			}
			for(var i =0;i<first.baseRkmxExtList.length;i++){
				Vue.set(it, first.baseRkmxExtList[i].name,item[first.baseRkmxExtList[i].name]);
			}
			
		} else {
			mui.each(first.item.rkmxDataList, function(i, it) {
				if(it.spId == item.spId){
					if(kqysBz == '1' && it.kqysBz=='1'){
						if(it.ys == item.ys) {
							Vue.set(it, 'rksl', Number(item.rksl));
							Vue.set(it, 'rkdj', Number(item.rkdj));
							Vue.set(it, 'rkje', Number(item.rkje));
							Vue.set(it, 'dw', item.dw);
							Vue.set(it, 'dwMc', item.dwMc);
							Vue.set(it, 'remarks', item.remarks);
							for(var i =0;i<first.baseRkmxExtList.length;i++){
								Vue.set(it, first.baseRkmxExtList[i].name,item[first.baseRkmxExtList[i].name]);
							}
							return;
						}
					} else if (first.isPchBz && it.kqpchBz === '1'){
						if(isProcess){
							return;
						}					
						//获取原来的商品
						var tmpItem=first.item.rkmxDataList[pchIndex];
						//获取原来的商品里面的批次号
						var temPch=tmpItem.pch;
						//如果是没有批次号情况下进的批次号商品详情
						if(temPch === undefined || temPch === null || temPch === ""){
							var hasEqual=false;
							var equalIndex=0;
							mui.each(first.item.rkmxDataList, function(equalI, equalIt) {
								//如果原商品中已经有同一批次号了，那么就把数据相加
								if(equalIt.pch===item.pch && item.pch!==undefined && item.pch !== null && item.pch !== "" && equalIt.spId==item.spId){
									hasEqual=true;
									equalIndex=equalI;
								}
							});
							if(hasEqual){
								//原来的商品列表有这个商品批号
								//获取已经存在相同批次号的商品,数量相加，单价，单位替换，其他在cal函数里计算
								var equalItem=first.item.rkmxDataList[equalIndex];
								Vue.set(equalItem, 'rksl', formatSl(Number(equalItem.rksl)+Number(item.rksl)));
								Vue.set(equalItem, 'rkdj', Number(item.rkdj));
								Vue.set(equalItem, 'dw', item.dw);
								Vue.set(equalItem, 'dwMc', item.dwMc);
								Vue.set(equalItem, 'remarks', item.remarks);
								//删除旧的无批号商品信息
								first.item.rkmxDataList.splice(pchIndex, 1);
							}else{
								//原来的商品列表没有这个商品批号,这时就处理原数据
								Vue.set(tmpItem, 'rksl', Number(item.rksl));
								Vue.set(tmpItem, 'rkdj', Number(item.rkdj));
								Vue.set(tmpItem, 'rkje', Number(item.rkje));
								Vue.set(tmpItem, 'dw', item.dw);
								Vue.set(tmpItem, 'dwMc', item.dwMc);
								Vue.set(tmpItem, 'remarks', item.remarks);
								Vue.set(tmpItem, 'phId', item.phId);
								Vue.set(tmpItem, 'pch', item.pch);
								Vue.set(tmpItem, 'scrq', item.scrq);
								Vue.set(tmpItem, 'sxrq', item.sxrq);
							}
							isProcess=true;
						}else{
							//有批次号情况下进的批次号商品详情并且批次号相同
							if(it.pch === item.pch) {
								Vue.set(it, 'rksl', Number(item.rksl));
								Vue.set(it, 'rkdj', Number(item.rkdj));
								Vue.set(it, 'rkje', Number(item.rkje));
								Vue.set(it, 'dw', item.dw);
								Vue.set(it, 'dwMc', item.dwMc);
								Vue.set(it, 'remarks', item.remarks);
								isProcess=true;
								for(var i =0;i<first.baseRkmxExtList.length;i++){
									Vue.set(it, first.baseRkmxExtList[i].name,item[first.baseRkmxExtList[i].name]);
								}
								return;
							}
						}
					} else{
						Vue.set(it, 'rksl', Number(item.rksl));
						Vue.set(it, 'rkdj', Number(item.rkdj));
						Vue.set(it, 'rkje', Number(item.rkje));
						Vue.set(it, 'dw', item.dw);
						Vue.set(it, 'dwMc', item.dwMc);
						Vue.set(it, 'xlhList', item.xlhList);
						Vue.set(it, 'remarks', item.remarks);
						for(var i =0;i<first.baseRkmxExtList.length;i++){
							Vue.set(it, first.baseRkmxExtList[i].name,item[first.baseRkmxExtList[i].name]);
						}
						return;
					}
				}
			});
		}
	}
	first.cal();
});

//绑定扫码添加按钮
document.getElementById("stxm_btn").addEventListener("tap", function(e) {
	if(first.item.ckId == '') {
		mui.toast('请选择入库仓库！');
		return;
	}

	tzBarcode('ruku_xz.html');
});

/*================================回调函数-扫码添加商品=================================*/
/*扫码》添加商品*/
window.addEventListener('selectSpxx4Barcode', function(e) {
	selectSpxx4Barcode(e.detail.barcode);
});

var spItem4Ys = null;
window.addEventListener('setYsList', function(e) {
	var ysList = e.detail.ysList;
	var spdata = new Array();
	mui.each(ysList, function(p, ys) {
		var row = {};
		mui.extend(row, spItem4Ys);
		row.ysId = ys.ysId;
		row.ys = ys.ysId;
		row.ysMc = ys.ysMc;
		row.rksl = ys.rksl;
		row.rkje = formatJe(Number(row.rksl) * Number(row.rkmrj));
		row.ysList = [];
		spdata.push(row);
	});
	
	var rows = new Array();
	mui.each(first.item.rkmxDataList, function(index, item) {
		rows.push(mui.extend({}, item));
	});
	
	for (var i = 0; i < spdata.length; i++) {
		var emptyFlag = true;
		for (var j = 0; j < rows.length; j++) {
			if (rows[j].spId === spdata[i].spId){
				if(rows[j].ys === spdata[i].ys){
					rows[j].rksl = calc.Add(Number(rows[j].rksl) , Number(spdata[i].rksl)) ;
					emptyFlag = false;
					break;
				}
			}
		}
		if (emptyFlag) {
			rows.push(spdata[i]); // 将被选中的行拼接进单据信息
		}
	}

	first.item.rkmxDataList = rows;
	first.cal();
});

function selectSpxx4Barcode(barcode) {
	var params = {
		sptxm: barcode
	};

	var url = hurl + 'invSpxx/findBySptxm';
	loafish.utils.ajax4Post(url, params, null, function(returnData) {
		if(returnData.id != null && returnData.id != '') {

			/*if(returnData.spId == null) {
				returnData.spId = returnData.id;
			}*/

			returnData.rksl = 1;
			if(first.isXlhBz && returnData.kqxlhBz === '1') {
				returnData.rksl = 0;
			}
			if(first.isPchBz && returnData.kqpchBz === '1') {
				returnData.rksl = 0;
			}
			//returnData.spId = returnData.id;
			returnData.dw = returnData.mrdw;
			returnData.dwMc = returnData.mrdwMc;
			returnData.rkdj = returnData.rkmrj;
			returnData.rkje = returnData.rkmrj;
			
			var kqysBz = localStorage.getItem("kqSpysBz");
			if(kqysBz == '1' && returnData.kqysBz=='1'){
				var item = returnData;
				spItem4Ys = item;
				
				if(item.ysList == undefined) {
					item.ysList = [];
				}
				var extras = { item: item }
				var webview = plus.webview.create('../common/select_ys.html', 'select_ys.html', webview_style, extras);
				webview.addEventListener("titleUpdate", function() {
					webview.show("slide-in-right", 300);
				});
				
				return;
			}

			var list = [returnData];

			if(first.item.rkmxDataList.length == 0) {
				first.item.rkmxDataList = list;
				mui.each(first.item.rkmxDataList, function(i, item) {
					item.rkje = Number(item.rksl) * Number(item.jycgj);
					
					//对扩展字段进行计算
					first.gsCal(item);
				});
			} else {
				if(first.isPchBz && returnData.kqpchBz === '1') {
					returnData.rksl = 0;
					
					//对扩展字段进行计算
					first.gsCal(returnData);
					
					first.item.rkmxDataList.push(returnData);
				} else {
					
					var rkmxDataList = new Array();
					var flag = true; //同商品多批次时判断只增加一个数量

					//同商品累加标志
					var tspljBz = localStorage.getItem("tspljBz");
					if (tspljBz === '1') {
						//已经存的商品，只需要增加数量，并更新各种合计金额
						for(var i = 0; i < first.item.rkmxDataList.length; i++) {
							var item = first.item.rkmxDataList[i];
							var item2 = null;

							for(var j = 0; j < list.length; j++) {
								item2 = list[j];

								if(item.spId == item2.spId && flag) {
									item.rksl = calc.Add(Number(item.rksl) , Number(item2.rksl)) ;
									item.rkje = Number(item.rksl) * Number(item.rkdj);
									
									//对扩展字段进行计算
									first.gsCal(item);
									
									flag = false;
									break;
								}
							}
							rkmxDataList.push(item);
						}
						
						//不存在的商品，追加在原商品之后
						for(var i = 0; i < list.length; i++) {
							var item2 = list[i];
							var item = null;
							var isExist = false;
						
							for(var j = 0; j < first.item.rkmxDataList.length; j++) {
								var item = first.item.rkmxDataList[j];
						
								if(item.spId == item2.spId) {
									isExist = true;
									break;
								}
							}
						
							if(!isExist) {
								item2.rkje = Number(item2.xssl) * Number(item2.jyxsj);
								
								//对扩展字段进行计算
								first.gsCal(item2);
								
								var pxfs = localStorage.getItem('djspPxfs');
								if(pxfs=='2'){
									rkmxDataList.unshift(item2);
								}else{
									rkmxDataList.push(item2);
								}
							}
						}
						
					} else {
						for (var i = 0; i < first.item.rkmxDataList.length; i++) {
							var item = first.item.rkmxDataList[i];
							
							//对扩展字段进行计算
							first.gsCal(item);
							
							rkmxDataList.push(item);
						}
						
						var pxfs = localStorage.getItem('djspPxfs');
						if(pxfs=='2'){
							rkmxDataList.unshift(returnData);
						}else{
							rkmxDataList.push(returnData);
						}
					}
					
					first.item.rkmxDataList = rkmxDataList;
				}
			}
			first.cal();
		} else {
			mui.toast("未在商品列表中找到此条码！");
			playWarn();
		}
	});
}

window.addEventListener('selectSpxx4Xlh', function(e) {
	
	var xlh = e.detail.xlh;
	var params = {
		xlh: xlh
	};
	
	loafish.utils.ajax4Post(hurl + "xlh/isUsed", {xlh:xlh}, null, function(ret) {
		if(ret.isUsed){
			mui.toast("序列号【" + xlh + "】已被其他单据使用、锁定或者入库！");
			playWarn();
		}else{
			var url = hurl + 'invSpxx/findBySpxlh';
			loafish.utils.ajax4Post(url, params, null, function(returnData) {
				if(returnData.id != null && returnData.id != '') {
					returnData.rksl = 1;
					returnData.sptxUrl = returnData.tpdz;
					returnData.dw = returnData.mrdw;
					returnData.dwMc = returnData.mrdwMc;
					returnData.rkdj = returnData.rkmrj;
					returnData.rkje = returnData.rkmrj;
					
					var xlhObj = {
						xlh : xlh, 
						kcmxId : returnData.kcmxId 
					}
		
					if(first.item.rkmxDataList.length == 0) {
						returnData.xlhList = [xlhObj];
						
						//对扩展字段进行计算
						first.gsCal(returnData);
						
						first.item.rkmxDataList = [returnData];
					} else {
						var list = [returnData];
						var rkmxDataList = new Array();
						var isExist4Spxx = false;
						var isExist4Xlh = false; 
						
						//已经存的商品，只需要增加数量，并更新各种合计金额
						for(var i = 0; i < first.item.rkmxDataList.length; i++) {
							var item = first.item.rkmxDataList[i];
							var item2  = returnData;
		
							if(item.spId === item2.spId) {
								isExist4Spxx = true;
								
								mui.each(item.xlhList, function(ii, xlhItem) {
									if(xlhItem.xlh === xlh){
										isExist4Xlh = true;
										return;
									}
								});
								
								if(!isExist4Xlh){
									if(item.xlhList==null){
										item.xlhList = [];
									}
									item.xlhList.push(xlhObj);
									item.rksl = Number(item.rksl) + 1;
									item.rkje = Number(item.rksl) * Number(item.rkdj);
									
									//对扩展字段进行计算
									first.gsCal(item);
								}
							}
							
							rkmxDataList.push(item);
						}
						
						if(isExist4Xlh){
							mui.toast("该序列号已被扫入（商品编号：" + returnData.spBh + "，名称：" + returnData.spMc + "），请核实！");
							playWarn();
							return;
						}
						
						if(!isExist4Spxx){
							returnData.xlhList = [xlhObj];
							
							//对扩展字段进行计算
							first.gsCal(returnData);
							
							var pxfs = localStorage.getItem('djspPxfs');
							if(pxfs=='2'){
								rkmxDataList.unshift(returnData);
							}else{
								rkmxDataList.push(returnData);
							}
						}
						
						first.item.rkmxDataList = rkmxDataList;
					}
		
					first.cal();
				}else{
					mui.toast("未找到相应商品，请核实！");
					playWarn();
				}
			});
		}
	});

	
});

//绑定完成按钮
function save(shzt){
	var params = {};
	mui.extend(params, first.item);
	params.rkmxDataList = first.item.rkmxDataList;
	params.shzt = shzt;

	if(params.rklx == '') {
		mui.toast('请选择入库类型！');
		return;
	}

	if(params.djrq == '') {
		mui.toast('请填写入库日期！');
		return;
	}
	var djrq = document.getElementById("djrq").validity;
	if(!djrq.valid) {
		mui.toast('请填写正确的入库日期！');
		return;
	}
	if(params.ckMc == '') {
		mui.toast('请选择入库仓库！');
		return;
	}
	
	if(mustArr.length > 0){
		var flag = false;
		for (var i = 0; i < mustArr.length; i++) {
			var item = mustArr[i];
			var lable = item.lable;
			var name = item.name;
			if ($.trim(params[name]) == '') {
				if(item.dataType == '3'){
					mui.toast(lable+"不能为空，请选择！");
				} else {
					mui.toast(lable+"不能为空，请填写！");
				}
				
				flag = true;
				break;
			}
		}
		if(flag){
			return;
		}
	}
	
	if(params.rkmxDataList ==null || params.rkmxDataList.length == 0){
		mui.toast('请添加入库商品！');
		return;
	}
	
	var isFlag = false;
	mui.each(params.rkmxDataList, function(index, item) {
		/*if(item.rksl == '' || item.rksl == 0) {
			isFlag = true;
			mui.toast('存在数量为0的商品，请修改后提交！');
			return false;
		}*/
		if(first.isPchBz && item.kqpchBz === '1'){
			if(item.pch===undefined||item.pch===""||item.pch===null){
				isFlag = true;
				mui.toast('商品【' + item.spMc + '】批次号为空，请填写！');
				return false;
			}
		}
	})
	
	if(isFlag) {
		return false;
	}
	
	//只允许点击一次完成，避免多次生成数据
	if(first.isFinish){
		return;
	}
	first.isFinish = true;
	
	if(first.tag == "copy") {
		var url = hurl + 'qtrkmx/save?tag=' + first.tag;
	} else {
		var url = hurl + 'qtrkmx/save';
	}
	var zzdj = [];
	mui.each(first.item.zzdjs, function(index, item) {
		zzdj.push(item.tpId)
	});
	params.zzdjs = zzdj.join('&');
	loafish.utils.ajax4Post(url, params, "application/json", function(returnData) {
		if(returnData.success) {
			var data = returnData.data;

			first.item.id = data.id;
			first.item.qtrkdBh = data.qtrkdBh;
			var mainPage = plus.webview.getWebviewById("chukuRuku/ruku.html");
			mui.fire(mainPage, "queryRkd", {
				ywlx: '2'
			});

			//刷新待办事项
			var dbPage = plus.webview.getWebviewById("daiban.html");
			mui.fire(dbPage, "loadDbNum", {});
			if(isUpdate) {
				mui.back = function() {
					mainPage.show();
				}
			}
			mui.back();
			mui.toast('操作成功！');
		} else {
			mui.toast(returnData.msg);
			first.isFinish = false;
		}
	});
}

function getCk() {
	var url = hurl + '/invCk/list';
	var params = {
		page: 1,
		rows: 1,
		kjckfw: '0',
		isLock:'0'
	};
	var kjckfwBz = localStorage.getItem('kjckfw');
	params.kjckfw = kjckfwBz;

	loafish.utils.ajax4Get(url, params, null, function(returnData) {
		var list = returnData.rows;
		if(list!=null && list.length > 0 ) {
			var ck = list[0];
			first.item.ckId = ck.id;
			first.item.ckMc = ck.ckMc;
		}
	});
}

function getData(){
	var url = hurl + 'qtrkmx/query';
	var params = {
		qtrkdId: first.item.id
	};

	loafish.utils.ajax4Get(url, params, null, function(data) {
		first.item.rkmxDataList = data.mxData;
		first.item.zzdjs = data.zzdjData;
	}, false);
}

var isUpdate = false;
var mustArr = [];
mui.plusReady(function() {
	var _self = plus.webview.currentWebview();
	list_rklx.isIos = mui.os.ios;
	
	mui.extend(first.item, _self.item);
	first.hasXtcsPermission();
	first.tag = _self.tag;
	var showJg = localStorage.getItem('crkxsJgBz');
	if(showJg == '1') {
		first.showJg = true;
	}
	
	first.showXlh = (localStorage.getItem('xlhBz') == '1' && scanModel=='PHONE');

	if(first.item.id != null && first.item.id != '') {
		if(first.tag == "copy") {
			document.getElementById("title").innerText = getMsg("复制入库单");
			first.item.djrq = new Date().Format("yyyy-MM-dd");
			first.item.ckrq = new Date().Format("yyyy-MM-dd");
			first.item.shDate = null;
			
		} else {
			document.getElementById("title").innerText = getMsg("修改入库单");
		}
		isUpdate = true;
		
		getData();
	}else{
		getCk();
	}
	getRklxData();
	
	if(scanModel == 'PDA'){
		pageInit()  
	    setTimeout(function(){  
	        pdaScan(function(barcode){  
	        		selectSpxx4Barcode(barcode);
	        })  
	    },300);
    }
	
		//权限获取
	first.menuList = getMenuList("chukuRuku/ruku.html");
	first.hasPermission();
	
	first.baseRkdExtList = JSON.parse(localStorage.getItem('baseRkdExtList'));
	if(first.baseRkdExtList == null){
		first.baseRkdExtList = [];
	}
	first.baseRkdExtList.forEach(function(base, index){
		if(base.mustFlag != null && base.mustFlag == '1'){
			mustArr.push({ lable : base.lable, name : base.name, dataType: base.dataType });
		}
	});
	
	first.baseRkmxExtList = JSON.parse(localStorage.getItem('baseRkmxExtList'));	
	if(first.baseRkmxExtList == null){
		first.baseRkmxExtList = [];
	}
	
	if(first.showJg){
		var tmpShowJg = false;
		for(var i = 0; i < first.menuList.length; i++) {
			if(first.menuList[i].permission == 'inv:invQtrk:money') {
				tmpShowJg = true;
				break;
			}
		}
		first.showJg = tmpShowJg;
	}	
	
	first.isEnabledSplc4Rkd = localStorage.getItem("isEnabledSplc4Rkd");
});

mui('.mui-scroll-wrapper').scroll({});