//==============================侧滑打开筛选页面====================================	

/* 在引入的页面 需要注意 menu, _self变量 */
var mask = mui.createMask(_closeMenu);
var showMenu = false,mode = 'main-move';


/**
 * 关闭侧滑菜单(业务部分)
 */
function _closeMenu() {
	if (showMenu) {
		//解决android 4.4以下版本webview移动时，导致fixed定位元素错乱的bug;
		if (mui.os.android && parseFloat(mui.os.version) < 4.4) {
			document.querySelector("header.mui-bar").style.position = "fixed";
			//同时需要修改以下.mui-contnt的padding-top，否则会多出空白；
			document.querySelector(".mui-bar-nav~.mui-content").style.paddingTop = "44px";
		}

		//主窗体开始侧滑；
		menu.setStyle({
			left: '100%',
			transition: {
				duration: 150
			}
		});

		//等窗体动画结束后，隐藏菜单webview，节省资源；
		setTimeout(function() {
			menu.hide();
		}, 300);

		showMenu = false;

		mui.fire(_self, "openMask", {
			isMask: false
		});
	}
}

/*
 * 显示菜单
 */
function openMenu() {
	if (!showMenu) {
		//解决android 4.4以下版本webview移动时，导致fixed定位元素错乱的bug;
		if (mui.os.android && parseFloat(mui.os.version) < 4.4) {
			document.querySelector("header.mui-bar").style.position = "static";
			//同时需要修改以下.mui-contnt的padding-top，否则会多出空白；
			document.querySelector(".mui-bar-nav~.mui-content").style.paddingTop = "0px";
		}

		//侧滑菜单处于隐藏状态，则立即显示出来；
		//显示完毕后，根据不同动画效果移动窗体；
		menu.show('none', 0, function() {
			menu.setStyle({
				render: "always", //一直渲染
				left: '10%',
				transition: {
					duration: 150
				}
			});
		});


		//显示主窗体遮罩
		mask.show();			
		showMenu = true;
		
	}
}

function closeMenu() {
	//窗体移动
	_closeMenu();
	//关闭遮罩
	mask.close();
}

//主界面向左滑动，若菜单未显示，则显示菜单；否则不做任何操作；
//window.addEventListener("swipeleft", openMenu);
//主界面向右滑动，若菜单已显示，则关闭菜单；否则，不做任何操作；
window.addEventListener("swiperight", closeMenu);
//menu页面向右滑动，关闭菜单；
window.addEventListener("menu:swiperight", closeMenu);

//重写mui.menu方法，Android版本menu按键按下可自动打开、关闭侧滑菜单；
mui.menu = function() {
	if (showMenu) {
		closeMenu();
	} else {
		openMenu();
	}
}
window.addEventListener("closeMask", function() {
	closeMenu();
});
window.addEventListener('_closeMenuAll', function(e) {
	mask.close();
	mui.fire(_self, 'closeMask', {});
})
