mui.previewImage(); // 图片预览

//================================================================================
new Vue({
	i18n: vueI18n,
	el: "#header"
});
var first = new Vue({
	i18n: vueI18n,
	el: "#first",
	data: {
		item: {
			id: '',
			bhdId: '',
			ckId: '',
			ckMc: '',
			djrq: new Date().Format("yyyy-MM-dd"),
			djBh: '',
			shzt: '0',
			gysId: '',
			gysYfk:'',
			ywlb: '1',
			spmxDataList: [],
			gysMc: '',
			rkrq: new Date().Format("yyyy-MM-dd"),
			cgjeHj: 0.00,
			seHj: 0.00,
			sjhj: 0.00,
			cgslHj: 0,
			ysk: null,
			yshqk: null,
			qtfyje: null,
			cgfyje: null,
			yhje: null,
			xmId: '',
			xmmc: '',
			remarks: '',
			zzdjs: [],
			zzdjDataList: [],
			jszh: '',
			jszhMc: '',
			ddBh: '',
			gysDdh:'',
			ztext1: '',
			ztext2: '',
			ztext3: '',
			ztext4: '',
			ztext5: '',
			ztext6: '',
			ztext7: '',
			ztext8: '',
			ztext9: '',
			ztext10: '',
			mxext1: '',
			mxext2:'',
			mxext3:'',
			mxext4:'',
			mxext5:'',
			mxext6:'',
			mxext7:'',
			mxext8:'',
			mxext9:'',
			mxext10:''
		},
		isJhSlBz: false,
		isXlhBz: false,
		isPchBz: false,
		isXjBz: false,
		tag: '',
		ddwArr: [],
		qhId: '',
		qhdw: '',
		zdw: '',
		showXlh:false,
		isFinish : false,
		showAuditBtn: false,
		menuList:[],
		baseCgdExtList:[],
		baseCgdmxExtList: [],
		isEnabledSplc4Cgd: '0',
		cgfyjeList:[],
		isFirst: true
	},
	methods: {
		qtfytc: function() {
			var extras = {
				dgdId: first.item.id,
				cgfyjeList: first.cgfyjeList,
				isFirst: first.item.isFirst
			};
			
			var webview = plus.webview.create('cgd_xz_cgfy.html', 'cgd_xz_cgfy.html', webview_style,
				extras);
			webview.addEventListener("titleUpdate", function() {
				webview.show(aniShow, 300);
			});
		},
		//判断是否有审核权限
		hasPermission: function() {
			for(var i = 0; i < this.menuList.length; i++) {
				if(this.menuList[i].permission == 'inv:invCgd:audit') {
					this.showAuditBtn = true;
					break;
				}
			}
		},
		sxlh:function(){
			//验证供应商是否有选择
			if(first.item.gysId == '') {
				mui.toast(getMsg('供应商不能为空，请选择！'));
				return;
			}
			if(first.item.ckId == '') {
				mui.toast(getMsg('仓库不能为空，请选择！'));
				return;
			}
			
			tzBarcode('caigou_xz.html',true);
		},
		/*判断系统参数*/
		hasXtcsPermission: function() {
			var jhSlBz = localStorage.getItem("jhSlBz");
			var xlhBz = localStorage.getItem("xlhBz");
			var kqpchBz = localStorage.getItem("kqpchBz");
			var crkBz = localStorage.getItem("crkBz");
			var xjBz = localStorage.getItem("xjBz");
			/*判断销货税率*/
			if(jhSlBz === '1') { //0停用；1启用
				this.isJhSlBz = true;
			}
			/*判断是否显示序列号*/
			if(xlhBz === '1' && crkBz === '0') { //0停用；1启用
				this.isXlhBz = true;
			}
			if(kqpchBz === '1') { //0停用；1启用
				this.isPchBz = true;
			}
			/*判断是否现结*/
			if(xjBz === '1') { //0停用；1启用
				this.isXjBz = true;
			}
            first.crkBz = crkBz;
		},
		/*选择商品*/
		xzsp: function(item, index) {
			item.gysId = first.item.gysId;
			item.ckId = first.item.ckId;
			mui.openWindow({
				id: 'select_cgspXq.html',
				url: 'select_cgspXq.html',
				styles: {
					background: 'transparent'
				},
				show: {
					autoShow: true,
					aniShow: 'none'
				},
				waiting: {
					autoShow: false
				},
				extras: {
					item: item,
					index: index,
					djObj: first.item
				}
			});
		},
		clearXmxx: function() {
			first.item.xmId = '';
			first.item.xmbh = '';
			first.item.xmmc = '';
		},
		//计算填写的数量
		cal: function() {
			var sum = 0,
				seHj = 0,
				count = 0;
			var sjhj=0;
			mui.each(this.item.spmxDataList, function(index, item) {
				if(item.cgdj == null || isNaN(item.cgdj)) {
					item.cgdj = 0;
				}
				if(isNaN(item.cgsl)) {
					item.cgsl = 0;
				}

				item.cgdj = formatDj(item.cgdj);
				//item.cgje = formatJe(Number(item.cgsl) * Number(item.cgdj));

				sum = Number(sum) + Number(item.cgje);
				count = Number(count) + Number(item.cgsl);

				//增加税率判断
				if(first.isJhSlBz) {
					if(item.sl === '' || item.sl == null) {
						item.se = '';
					} else {
						item.se = formatJe(Number(item.cgje) * Number(item.sl) / 100);
					}
					if(item.hsdj === '' || item.hsdj === null || item.hsdj === undefined){
						item.hsdj=formatDj(Number(item.cgdj)* ((Number(item.sl)+100) / 100))
					}
					//item.sjhj=formatJe(Number(item.hsdj) * Number(item.cgsl));
					seHj += Number(item.se);
					sjhj += Number(item.sjhj);
				}else{
					item.se=null;
					item.hsdj=null;
					item.sjhj=null;
				}
			});

			this.item.cgslHj = count;
			this.item.cgjeHj = sum;
			this.item.seHj = seHj;
			first.item.yhhje = (first.isJhSlBz?Number(sjhj):Number(this.item.cgjeHj)) +
				Number((this.item.qtfyje == '' || this.item.qtfyje == null) ? 0 : this.item.qtfyje) -
				Number((this.item.yhje == '' || this.item.yhje == null) ? 0 : this.item.yhje);
			
			first.item.yhhje = formatJe(first.item.yhhje);		
				
			if(this.item.ysk != null && this.item.ysk != '') {
				this.item.yshqk = Number(first.item.yhhje) - Number(this.item.ysk);
			}
		},
		gsCal: function(item){
			mui.each(first.baseCgdmxExtList, function(index, ckmxExt) {
				if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
					var jsgs = ckmxExt.jsgs;
					if(/【\w*】/.test(jsgs)){
						var tmpVarNameArr = jsgs.match(/【\w*】/g);
						var gs = jsgs;
						for(var i=0; i < tmpVarNameArr.length; i++){
							var tmpVarNameStr = tmpVarNameArr[i];
							var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
							
							if(tmpVarName.indexOf("ztext") == 0){
								var tmpVal = Number(first.item[tmpVarName]);
								gs = gs.replace(tmpVarNameStr,tmpVal);
							}else{
								var tmpVal = Number(item[tmpVarName]);
								gs = gs.replace(tmpVarNameStr,tmpVal);
							}
						}
						
						var val = formatJe(eval(gs));
						item[ckmxExt.name] = val;
					} else {
						var val = formatJe(eval(jsgs));
						item[ckmxExt.name] = val;
					}
				}
			});
		},
		//对扩展字段进行计算
		rowExtCal : function(fieldName){
			
			var isExists = false;
			mui.each(first.baseCgdmxExtList, function(index, ckmxExt) {
				if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
					var jsgs = ckmxExt.jsgs;
					if(/【\w*】/.test(jsgs)){
						var tmpVarNameArr = jsgs.match(/【\w*】/g);
						var gs = jsgs;
						for(var i=0; i < tmpVarNameArr.length; i++){
							var tmpVarNameStr = tmpVarNameArr[i];
							var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
							
							if(fieldName === tmpVarName){
								isExists = true;
								break;
							}
						}
					}
				}
			});
			
			if(isExists){
				mui.each(first.item.spmxDataList, function(i, item) {
					mui.each(first.baseCgdmxExtList, function(index, ckmxExt) {
						if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
							var jsgs = ckmxExt.jsgs;
							if(/【\w*】/.test(jsgs)){
								var tmpVarNameArr = jsgs.match(/【\w*】/g);
								var gs = jsgs;
								for(var i=0; i < tmpVarNameArr.length; i++){
									var tmpVarNameStr = tmpVarNameArr[i];
									var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
									
									if(tmpVarName.indexOf("ztext") == 0){
										var tmpVal = Number(first.item[tmpVarName]);
										gs = gs.replace(tmpVarNameStr,tmpVal);
									}else{
										var tmpVal = Number(item[tmpVarName]);
										gs = gs.replace(tmpVarNameStr,tmpVal);
									}
								}
								
								var val = formatJe(eval(gs));
								item[ckmxExt.name] = val;
							} else {
								var val = formatJe(eval(jsgs));
								item[ckmxExt.name] = val;
							}
						}
					});
				});
			}
		},
		/*选择结算账户*/
		xzJszh: function() {
			var extras = {
				source: 'caigou_xz.html',
				gysId: first.item.gysId,
				gysYfk: first.item.gysYfk
			}
			var webview = plus.webview.create('../common/select_jszh.html', '../common/select_jszh.html', webview_style,
				extras);
			webview.addEventListener("titleUpdate", function() {
				webview.show(aniShow, 300);
			});
		}
	}
});

/*供应商名称控件点击触发事件*/
document.getElementById("gysMc").addEventListener('tap', function() {
	var subWebview = plus.webview.create('../common/select_gys.html', 'select_gys.html', webview_style, {
		source: 'caigou_xz.html'
	});
	subWebview.addEventListener("titleUpdate", function() {
		subWebview.show(aniShow, 300);
	});
});
/*回调函数-供应商赋值*/
window.addEventListener('setGys', function(e) {
	first.item.gysId = e.detail.gysId;
	first.item.gysMc = e.detail.gysMc;
	first.item.gysYfk = e.detail.yfk;
});

/*仓库名称控件点击触发事件*/
document.getElementById("ckMc").addEventListener('tap', function() {
	var webview = plus.webview.create('../common/select_ck.html', 'select_ck.html', webview_style, {});

	webview.addEventListener("titleUpdate", function() {
		webview.show("slide-in-right", 300);
	});
});
/*回调函数-仓库赋值*/
window.addEventListener('setCk', function(e) {
	first.item.ckId = e.detail.ckId;
	first.item.ckMc = e.detail.ckMc;
});

/*选择商品按钮*/
document.getElementById("xzsp_btn").addEventListener("tap", function(e) {
	//验证供应商是否有选择
	if(first.item.gysId == '') {
		mui.toast(getMsg('供应商不能为空，请选择！'));
		return;
	}
	if(first.item.ckId == '') {
		mui.toast(getMsg('仓库不能为空，请选择！'));
		return;
	}

	var subWebview = plus.webview.create('select_cgsp.html', 'select_cgsp.html', webview_style, {
		item: first.item
	});
	subWebview.addEventListener("titleUpdate", function() {
		subWebview.show(aniShow, 300);
	});

});

/*===========================回调函数-选择商品===============================*/
window.addEventListener('selectedSpxx', function(e) {
	var tspljBz = localStorage.getItem("tspljBz");
	
	//开启商品累加选择商品会传数据过去，同时选好后就会把数据拼接好传回来，这时直接接收即可
	if (tspljBz === '1') {
		first.item.spmxDataList = e.detail;
	}  else {
		//没开启，那么就会重新增加一条数据
		first.item.spmxDataList = first.item.spmxDataList.concat(e.detail);
	}
	
	first.cal();
});

/*单个商品回调函数*/
window.addEventListener('setSpNum', function(e) {
	var item = e.detail.item;
	var del = e.detail.del;
	
	//商品索引，跟del一样，不过条件不同，pchIndex是这里判断，传过来处理
	var pchIndex = e.detail.pchIndex;
	//已经处理标志，如果有多个相同id商品不同批号，在遍历中判断
	var isProcess=false;
	var kqysBz = localStorage.getItem("kqSpysBz");
	var crkBz = localStorage.getItem("crkBz");

	if(del != undefined) {
		first.item.spmxDataList.splice(del, 1);
	} else {
		if( pchIndex != undefined ){
			var it = first.item.spmxDataList[pchIndex];
			Vue.set(it, 'cgsl', Number(item.cgsl));
			Vue.set(it, 'cgdj', Number(item.cgdj));
			Vue.set(it, 'cgje', Number(item.cgje));
			Vue.set(it, 'dw', item.dw);
			Vue.set(it, 'dwMc', item.dwMc);
			Vue.set(it, 'xlhList', item.xlhList);
			Vue.set(it, 'remarks', item.remarks);
			Vue.set(it, 'sl', item.sl);
			Vue.set(it, 'hsdj', item.hsdj);
			Vue.set(it, 'sjhj', item.sjhj);
			Vue.set(it, 'se', item.se);
			
			if (first.crkBz != '1' && first.isPchBz && it.kqpchBz === '1'){
				Vue.set(it, 'phId', item.phId);
				Vue.set(it, 'pch', item.pch);
				Vue.set(it, 'scrq', item.scrq);
				Vue.set(it, 'sxrq', item.sxrq);
			}
			
			for (var i = 0; i < first.baseCgdmxExtList.length; i++) {
				Vue.set(it, first.baseCgdmxExtList[i].name, item[first.baseCgdmxExtList[i].name]);
			}
		}else{
			mui.each(first.item.spmxDataList, function(i, it) {
				if(it.spId == item.spId){
					if(kqysBz == '1' && it.kqysBz=='1'){
						if(it.ys == item.ys) {
							Vue.set(it, 'cgsl', Number(item.cgsl));
							Vue.set(it, 'cgdj', Number(item.cgdj));
							Vue.set(it, 'cgje', Number(item.cgje));
							Vue.set(it, 'dw', item.dw);
							Vue.set(it, 'dwMc', item.dwMc);
							Vue.set(it, 'remarks', item.remarks);
							Vue.set(it, 'sl', item.sl);
							Vue.set(it, 'hsdj', item.hsdj);
							Vue.set(it, 'sjhj', item.sjhj);
							Vue.set(it, 'se', item.se);
							for (var i = 0; i < first.baseCgdmxExtList.length; i++) {
								Vue.set(it, first.baseCgdmxExtList[i].name, item[first.baseCgdmxExtList[i].name]);
							}
							return;
						}
					} else if (first.crkBz != '1' && first.isPchBz && it.kqpchBz === '1'){
						if(isProcess){
							return;
						}	
						//获取原来的商品
						var tmpItem=first.item.spmxDataList[pchIndex];
						//获取原来的商品里面的批次号
						var temPch=tmpItem.pch;
						//如果是没有批次号情况下进的批次号商品详情
						if(temPch === undefined || temPch === null || temPch === ""){
							var hasEqual=false;
							var equalIndex=0;
							mui.each(first.item.spmxDataList, function(equalI, equalIt) {
								//如果原商品中已经有同一批次号了，那么就把数据相加
								if(equalIt.pch===item.pch && item.pch!==undefined && item.pch !== null && item.pch !== "" && equalIt.spId==item.spId){
									hasEqual=true;
									equalIndex=equalI;
								}
							});
							if(hasEqual){
								//原来的商品列表有这个商品批号
								//获取已经存在相同批次号的商品,数量相加，单价，单位替换，其他在cal函数里计算
								var equalItem=first.item.spmxDataList[equalIndex];
								Vue.set(equalItem, 'cgsl', formatSl(Number(equalItem.cgsl)+Number(item.cgsl)));
								Vue.set(equalItem, 'cgdj', Number(item.cgdj));
								Vue.set(equalItem, 'dw', item.dw);
								Vue.set(equalItem, 'dwMc', item.dwMc);
								Vue.set(equalItem, 'remarks', item.remarks);
								Vue.set(equalItem, 'sl', item.sl);
								Vue.set(equalItem, 'hsdj', item.hsdj);
								//删除旧的无批号商品信息
								first.item.spmxDataList.splice(pchIndex, 1);
							}else{
								//原来的商品列表没有这个商品批号,这时就处理原数据
								Vue.set(tmpItem, 'cgsl', Number(item.cgsl));
								Vue.set(tmpItem, 'cgdj', Number(item.cgdj));
								Vue.set(tmpItem, 'cgje', Number(item.cgje));
								Vue.set(tmpItem, 'dw', item.dw);
								Vue.set(tmpItem, 'dwMc', item.dwMc);
								Vue.set(tmpItem, 'remarks', item.remarks);
								Vue.set(tmpItem, 'sl', item.sl);
								Vue.set(tmpItem, 'hsdj', item.hsdj);
								Vue.set(tmpItem, 'phId', item.phId);
								Vue.set(tmpItem, 'pch', item.pch);
								Vue.set(tmpItem, 'scrq', item.scrq);
								Vue.set(tmpItem, 'sxrq', item.sxrq);
							}
							isProcess=true;
						}else{
							//有批次号情况下进的批次号商品详情
							if(it.pch === item.pch) {
								Vue.set(it, 'cgsl', Number(item.cgsl));
								Vue.set(it, 'cgdj', Number(item.cgdj));
								Vue.set(it, 'cgje', Number(item.cgje));
								Vue.set(it, 'dw', item.dw);
								Vue.set(it, 'dwMc', item.dwMc);
								Vue.set(it, 'remarks', item.remarks);
								Vue.set(it, 'sl', item.sl);
								Vue.set(it, 'hsdj', item.hsdj);
								Vue.set(it, 'sjhj', item.sjhj);
								Vue.set(it, 'se', item.se);
								for (var i = 0; i < first.baseCgdmxExtList.length; i++) {
									Vue.set(it, first.baseCgdmxExtList[i].name, item[first.baseCgdmxExtList[i].name]);
								}
								isProcess=true;
								return;
							}
						}

					} else {
						Vue.set(it, 'cgsl', Number(item.cgsl));
						Vue.set(it, 'cgdj', Number(item.cgdj));
						Vue.set(it, 'cgje', Number(item.cgje));
						Vue.set(it, 'dw', item.dw);
						Vue.set(it, 'dwMc', item.dwMc);
						Vue.set(it, 'xlhList', item.xlhList);
						Vue.set(it, 'remarks', item.remarks);
						Vue.set(it, 'sl', item.sl);
						Vue.set(it, 'hsdj', item.hsdj);
						Vue.set(it, 'sjhj', item.sjhj);
						Vue.set(it, 'se', item.se);
						for (var i = 0; i < first.baseCgdmxExtList.length; i++) {
							Vue.set(it, first.baseCgdmxExtList[i].name, item[first.baseCgdmxExtList[i].name]);
						}
						return;
					}
				}
			});
		}
	}
	
	first.cal();
});

//绑定扫码添加按钮
document.getElementById("stxm_btn").addEventListener("tap", function(e) {
	//验证供应商是否有选择
	if(first.item.gysId == '') {
		mui.toast(getMsg('供应商不能为空，请选择！'));
		return;
	}
	if(first.item.ckId == '') {
		mui.toast(getMsg('仓库不能为空，请选择！'));
		return;
	}
	
	tzBarcode('caigou_xz.html');
});

var spItem4Ys = null;
window.addEventListener('setYsList', function(e) {
	var ysList = e.detail.ysList;
	var spdata = new Array();
	mui.each(ysList, function(p, ys) {
		var row = {};
		mui.extend(row, spItem4Ys);
		row.ysId = ys.ysId;
		row.ys = ys.ysId;
		row.ysMc = ys.ysMc;
		row.cgsl = ys.cgsl;
		row.cgje = formatJe(Number(row.cgsl) * Number(row.cgdj));
		row.ysList = [];
		spdata.push(row);
	});
	
	var rows = new Array();
	mui.each(first.item.spmxDataList, function(index, item) {
		rows.push(mui.extend({}, item));
	});
	
	for (var i = 0; i < spdata.length; i++) {
		var emptyFlag = true;
		for (var j = 0; j < rows.length; j++) {
			if (rows[j].spId === spdata[i].spId){
				if(rows[j].ys === spdata[i].ys){
					rows[j].cgsl = Number(rows[j].cgsl) + Number(spdata[i].cgsl);
					emptyFlag = false;
					break;
				}
			}
		}
		if (emptyFlag) {
			rows.push(spdata[i]); // 将被选中的行拼接进单据信息
		}
	}

	first.item.spmxDataList = rows;
	first.cal();
});

function selectSpxx4Barcode(barcode){
	var url = hurl + 'invSpxx/findBySptxm';
	loafish.utils.ajax4Post(url, {sptxm: barcode}, null, function(returnData) {
		if(returnData.id != null && returnData.id != '') {
			returnData.cgsl = 1;
			if(first.isXlhBz && returnData.kqxlhBz === '1') {
				returnData.cgsl = 0;
			}
			if(first.isPchBz && returnData.kqpchBz === '1') {
				returnData.cgsl = 0;
			}
			//returnData.spId = returnData.id;
			returnData.dw = returnData.mrdw;
			returnData.dwMc = returnData.mrdwMc;
			returnData.cgdj = returnData.mrJycgj;
			returnData.cgje = returnData.mrJycgj;
			//增加税率判断
			if(first.isJhSlBz) {
				var jhSl = localStorage.getItem("jhSl");
				returnData.sl = jhSl;
				returnData.hsdj=formatDj(Number(returnData.cgdj) * (100+Number(returnData.sl)) / 100);
			}
			
			var kqysBz = localStorage.getItem("kqSpysBz");
			if(kqysBz == '1' && returnData.kqysBz=='1'){
				var item = returnData;
				spItem4Ys = item;
				
				if(item.ysList == undefined) {
					item.ysList = [];
				}
				var extras = { item: item }
				var webview = plus.webview.create('../common/select_ys.html', 'select_ys.html', webview_style, extras);
				webview.addEventListener("titleUpdate", function() {
					webview.show("slide-in-right", 300);
				});
				
				return;
			}

			var list = [returnData];
			if(first.item.spmxDataList.length == 0) {
				first.item.spmxDataList = list;
				mui.each(first.item.spmxDataList, function(i, item) {
					item.cgje = Number(item.cgsl) * Number(item.cgdj);
				
					//对扩展字段进行计算
					first.gsCal(item);
				});
			} else {
				if(first.crkBz != '1' && first.isPchBz && returnData.kqpchBz === '1') {
					returnData.cgsl = 0;
					
					//对扩展字段进行计算
					first.gsCal(returnData);
					
					first.item.spmxDataList.push(returnData);
				} else {
					var spmxDataList = new Array();
					var flag = true; //同商品多批次时判断只增加一个数量
					
					//同商品累加标志
					var tspljBz = localStorage.getItem("tspljBz");
					if (tspljBz === '1') {
						//已经存的商品，只需要增加数量，并更新各种合计金额
						for(var i = 0; i < first.item.spmxDataList.length; i++) {
							var item = first.item.spmxDataList[i];
							var item2 = null;

							for(var j = 0; j < list.length; j++) {
								item2 = list[j];
								if(item.spId == item2.spId && flag) {
									item.cgsl = Number(item.cgsl) + Number(item2.cgsl);
									item.cgje = Number(item.cgsl) * Number(item.cgdj);
									
									//对扩展字段进行计算
									first.gsCal(item);
									
									flag = false;
									break;
								}
							}
							
							spmxDataList.push(item);
						}
						
						//不存在的商品，追加在原商品之后
						for(var i = 0; i < list.length; i++) {
							var item2 = list[i];
							var item = null;
							var isExist = false;
						
							for(var j = 0; j < first.item.spmxDataList.length; j++) {
								var item = first.item.spmxDataList[j];
						
								if(item.spId == item2.spId) {
									isExist = true;
									break;
								}
							}
						
							if(!isExist) {
								item2.cgje = Number(item2.cgsl) * Number(item2.jycgj);
								
								//对扩展字段进行计算
								first.gsCal(item2);
								
								var pxfs = localStorage.getItem('djspPxfs');
								if(pxfs=='2'){
									spmxDataList.unshift(item2);
								}else{
									spmxDataList.push(item2);
								}
							}
						}
					} else {
						for(var i = 0; i < first.item.spmxDataList.length; i++) {
							var item = first.item.spmxDataList[i];
							
							//对扩展字段进行计算
							first.gsCal(item);
							
							spmxDataList.push(item);
						}
						
						var pxfs = localStorage.getItem('djspPxfs');
						if(pxfs=='2'){
							spmxDataList.unshift(returnData);
						}else{
							spmxDataList.push(returnData);
						}
					}

					first.item.spmxDataList = spmxDataList;
				}
			}

			first.cal();

		} else {
			mui.toast("未在商品列表中找到此条码！");
			playWarn();
		}
	});
}

/*扫码》添加商品*/
window.addEventListener('selectSpxx4Barcode', function(e) {
	var barcode = e.detail.barcode;
	selectSpxx4Barcode(barcode);
});

window.addEventListener('selectSpxx4Xlh', function(e) {
	
	var jhSl = localStorage.getItem("jhSl");
	var xlh = e.detail.xlh;
	var params = {
		xlh: xlh
	};

	loafish.utils.ajax4Post(hurl + "xlh/isUsed", {xlh:xlh}, null, function(ret) {
		if(ret.isUsed){
			mui.toast("序列号【" + xlh + "】已被其他单据使用、锁定或者入库！");
			playWarn();
		}else{
			var url = hurl + 'invSpxx/findBySpxlh';
			loafish.utils.ajax4Post(url, params, null, function(returnData) {
				if(returnData.id != null && returnData.id != '') {
					returnData.cgsl = 1;
					returnData.sptxUrl = returnData.tpdz;
					returnData.dw = returnData.mrdw;
					returnData.dwMc = returnData.mrdwMc;
					returnData.cgdj = Number(returnData.mrJycgj);
					returnData.cgje = Number(returnData.mrJycgj);
					if(first.isJhSlBz) {
						returnData.sl = jhSl; //税率
						returnData.hsdj=formatDj(Number(returnData.cgdj) * (100+Number(returnData.sl)) / 100);
					}
					
					var xlhObj = {
						xlh : xlh, 
						kcmxId : returnData.kcmxId 
					}
		
					if(first.item.spmxDataList.length == 0) {
						returnData.xlhList = [xlhObj];
						
						//对扩展字段进行计算
						first.gsCal(returnData);
						
						first.item.spmxDataList = [returnData];
					} else {
						var list = [returnData];
						var spmxDataList = new Array();
						var isExist4Spxx = false;
						var isExist4Xlh = false; 
						
						//已经存的商品，只需要增加数量，并更新各种合计金额
						for(var i = 0; i < first.item.spmxDataList.length; i++) {
							var item = first.item.spmxDataList[i];
							var item2  = returnData;
		
							if(item.spId == item2.spId) {
								isExist4Spxx = true;
								
								mui.each(item.xlhList, function(ii, xlhItem) {
									if(xlhItem.xlh === xlh){
										isExist4Xlh = true;
										return;
									}
								});
								
								if(!isExist4Xlh){
									item.xlhList.push(xlhObj);
									item.cgsl = Number(item.cgsl) + 1;
									item.cgje = Number(item.cgsl) * Number(item.cgdj);
									
									//对扩展字段进行计算
									first.gsCal(item);
								}
							}
							
							spmxDataList.push(item);
						}
						
						if(isExist4Xlh){
							mui.toast("该序列号已被扫入（商品编号：" + returnData.spBh + "，名称：" + returnData.spMc + "），请核实！");
							playWarn();
							return;
						}
						
						if(!isExist4Spxx){
							returnData.xlhList = [xlhObj];
							
							//对扩展字段进行计算
							first.gsCal(returnData);
							
							var pxfs = localStorage.getItem('djspPxfs');
							if(pxfs=='2'){
								spmxDataList.unshift(returnData);
							}else{
								spmxDataList.push(returnData);
							}
						}
						
						first.item.spmxDataList = spmxDataList;
					}
		
					first.cal();
				}else{
					mui.toast("未找到相应商品，请核实！");
					playWarn();
				}
			});
		}
	});
});

/*回调函数--设置结算账户*/
window.addEventListener('setJszh', function(e) {
	first.item.jszh = e.detail.jszhId;
	first.item.jszhMc = e.detail.jszhMc;
})

//绑定完成按钮
function save(shzt) {

	var params = {};
	mui.extend(params, first.item);
	params.spmxDataList = first.item.spmxDataList;
	params.remarks = first.item.remarks;
	params.yhhje = first.item.yhhje;
	params.shzt = shzt;

	var zzdj = [];
	mui.each(first.item.zzdjs, function(index, item) {
		zzdj.push(item.tpId)
	});
	params.zzdjs = zzdj.join('&');

	//1、表单验证
	if(params.gysMc == '') {
		mui.toast('请选择供应商！');
		return;
	}

	if(params.djrq == '') {
		mui.toast('请填写采购日期！');
		return;
	}
	var djrq = document.getElementById("djrq").validity;
	if(!djrq.valid) {
		mui.toast('请填写正确的采购日期！');
		return;
	}
	if(params.ckMc == '') {
		mui.toast('请选择入货仓库！');
		return;
	}

	if(params.rkrq == '') {
		mui.toast('请填写入库日期！');
		return;
	}
	var rkrq = document.getElementById("rkrq").validity;
	if(!rkrq.valid) {
		mui.toast('请填写正确的入库日期！');
		return;
	}
	
	if(mustArr.length > 0){
		var flag = false;
		for (var i = 0; i < mustArr.length; i++) {
			var item = mustArr[i];
			var lable = item.lable;
			var name = item.name;
			if ($.trim(params[name]) == '') {
				if(item.dataType == '3'){
					mui.toast(lable+"不能为空，请选择！");
				} else {
					mui.toast(lable+"不能为空，请填写！");
				}
				
				flag = true;
				break;
			}
		}
		if(flag){
			return;
		}
	}

	if(first.item.spmxDataList.length == 0) {
		mui.toast('请选择要采购的商品！');
		return;
	}

	var cgfyjeHj = 0;
	var isFlag = false;
	mui.each(first.item.spmxDataList, function(index, item) {
		if(item.cgsl == '' || item.cgsl == 0) {
			isFlag = true;
			mui.toast('商品【' + item.spMc + '】采购数量为0，请修改后提交');
			return false;
		} else if(item.xlhList != undefined && item.cgsl != item.xlhList.length && first.isXlhBz && item.kqxlhBz == '1') {
			isFlag = true;
			mui.toast('商品【' + item.spMc + '】采购数量与序列号数量不符，请修改后提交');
			return false;
		}
		if(first.crkBz !== '1' && first.isPchBz && item.kqpchBz === '1'){
			if(item.pch===undefined||item.pch===""||item.pch===null){
				isFlag = true;
				mui.toast('商品【' + item.spMc + '】批次号为空，请选择批次号后提交');
				return false;
			}
		}
		if(item.cgfyje == null){
			item.cgfyje = 0;
		}
		cgfyjeHj += Number(item.cgfyje);
	})
	
	if(cgfyjeHj != Number(first.item.cgfyje)){
		mui.toast("分摊费用合计和待分摊费用不相等，请修正！");
		return;
	}

	if(isFlag) {
		return false;
	}

	if(first.item.ysk != '' && first.item.ysk != null && (first.item.jszh == '' || first.item.jszh == null)) {
		mui.toast('现结时请选择结算账户！')
		return false;
	}
	if(first.item.ysk != '' && first.item.ysk != null && !(first.item.jszh == '' || first.item.jszh == null) && Number(
			first.item.yshqk) < 0) {
		mui.toast("现结(预付)款不能大于总计，请确认！");
		return false;
	}
	if(first.tag == "copy") {
		params.id = null;
		params.ddBh = null;
	}
	
	//只允许点击一次完成，避免多次生成数据
	if(first.isFinish){
		return;
	}
	first.isFinish = true;
	
	params.cgfyList = first.cgfyjeList;
	
	var url = hurl + 'cgdmx/save';
	loafish.utils.ajax4Post(url, params, "application/json", function(returnData) {

		if(returnData.success) {
			var data = returnData.data;

			first.item.id = data.id;
			first.item.djBh = data.djBh;

			var mainPage = plus.webview.getWebviewById("guanhuo/caigou.html");
			mui.fire(mainPage, "queryCgd", {});
			
			//从补货单页面进来的就发送个通知,关闭
			var bhdPage = plus.webview.getWebviewById("bhdXg.html");
			mui.fire(bhdPage, "close", {});

			var mainPageB = plus.webview.getWebviewById("guanhuo/cgdd.html");
			mui.fire(mainPageB, "queryCgdd", {});

			//刷新待办事项
			var dbPage = plus.webview.getWebviewById("daiban.html");
			mui.fire(dbPage, "loadDbNum", {});

			if(isUpdate) {
				mui.back = function() {
					if(mainPage!=null){
						mainPage.show();
					}else{
						plus.webview.currentWebview().close();
					}
				}
			}
			mui.back();
			mui.toast('操作成功！');
		} else {
			mui.toast(returnData.msg);
			first.isFinish = false;
		}
	});
}

function getCk() {
	var url = hurl + '/invCk/list';
	var params = {
		page: 1,
		rows: 1,
		kjckfw: '0',
		isLock:'0'
	};
	
	var kjckfwBz = localStorage.getItem('kjckfw');
	params.kjckfw = kjckfwBz;

	loafish.utils.ajax4Get(url, params, null, function(returnData) {
		var list = returnData.rows;
		if(list!=null && list.length > 0 ) {
			var ck = list[0];
			first.item.ckId = ck.id;
			first.item.ckMc = ck.ckMc;
		}
	});
}
function getJszh() {
	var url = hurl + '/invJszh/queryAll';
	var params = {
		page: 1,
		rows: 1,
		khId: first.item.khId,
		khYsk:first.item.khYsk
	};

	loafish.utils.ajax4Get(url, params, null, function(returnData) {
		var list = returnData;
		if(list!=null && list.length > 0 ) {
			var jszh = list[0];
			first.item.jszh = jszh.id;
			first.item.jszhMc = jszh.zhmc
		}
	});
}

var isUpdate = false;
var mustArr = [];
mui.plusReady(function() {
	var _self = plus.webview.currentWebview();
	
	mui.extend(first.item, _self.item);
	first.hasXtcsPermission();
	first.tag = _self.tag;
	first.showXlh = (localStorage.getItem('xlhBz') == '1' && scanModel=='PHONE');
	if(first.item.id != null && first.item.id != '') {
		if(first.tag == "copy") {
			first.item.djrq = new Date().Format("yyyy-MM-dd");
			first.item.rkrq = new Date().Format("yyyy-MM-dd");
			first.item.shDate = null;
			
			document.getElementById("title").innerText = getMsg("复制采购单");
		} else {
			document.getElementById("title").innerText = getMsg("修改采购单");
		}
		isUpdate = true;
	}else{
		//从补货单里面跳转过来的有仓库名称
		if(first.item.ckMc!==''){
			
		}else{
			//没有仓库名称才选择仓库
			getCk();
		}
		
	}
	
	//没有jszh
	if(first.item.jszh == ''){
		getJszh();
	}
	
	if(scanModel == 'PDA'){
		pageInit()  
	    setTimeout(function(){  
	        pdaScan(function(barcode){  
	        		selectSpxx4Barcode(barcode);
	        })  
	    },300);
    }
	first.menuList = getMenuList("guanhuo/caigou.html");
	first.hasPermission();
	first.cal();
	//如果是采购订单过来的,初始化纸质单据，编辑或者生成采购单
	if(first.item.zzdjs!==null&&first.item.zzdjs.length!==0){
		initZzdj(first.item.zzdjs);
	}
	first.baseCgdExtList = JSON.parse(localStorage.getItem('baseCgdExtList'));
	if(first.baseCgdExtList == null){
		first.baseCgdExtList = [];
	}
	first.baseCgdExtList.forEach(function(base, index){
		if(base.mustFlag != null && base.mustFlag == '1'){
			mustArr.push({ lable : base.lable, name : base.name, dataType: base.dataType });
		}
	});
	
	first.baseCgdmxExtList = JSON.parse(localStorage.getItem('baseCgdmxExtList'));
	if(first.baseCgdmxExtList == null){
		first.baseCgdmxExtList = [];
	}
	
	first.isEnabledSplc4Cgd = localStorage.getItem("isEnabledSplc4Cgd");
});

//项目名称控件点击触发事件
document.getElementById("xmmc").addEventListener('tap', function() {
	var subWebview = plus.webview.create('../common/select_xmxx.html', '../common/select_xmxx.html', webview_style, {
		xmId: first.item.xmId
	});
	subWebview.addEventListener("titleUpdate", function() {
		subWebview.show(aniShow, 300);
	});
});
/*回调函数-项目名称赋值*/
window.addEventListener('setXmxx', function(e) {
	first.item.xmId = e.detail.xmId;
	first.item.xmmc = e.detail.xmMc;
});

window.addEventListener('setCgfyjeList', function(e) {
	var list = e.detail.cgfyjeList;
	if(list == null){
		first.cgfyjeList = [];
		first.item.cgfyje = 0;
	} else {
		first.cgfyjeList = list;
		
		var cgjeHj = Number(first.item.cgjeHj) + Number(first.item.seHj);
		
		var cgfyjeHj = 0;
		for (var i = 0; i < list.length; i++) {
			var je = Number(list[i].je);
			cgfyjeHj += je;
		}
		first.item.cgfyje = formatJe(cgfyjeHj);
		
		for(var i = 0; i < first.item.spmxDataList.length; i++) {
			var item = first.item.spmxDataList[i];
			var cgje = Number(item.cgje);
			if (first.isJhSlBz) {
				cgje = Number(item.sjhj);
			}
			
			var cgfyje = Number(cgje) / Number(cgjeHj) * Number(cgfyjeHj);
			item.cgfyje = formatJe(cgfyje);
		}
	}
});

mui('.mui-scroll-wrapper').scroll({})