/*图片上传开始*/
var tipTitle = '上传商品图片';
var tipMsg = '图片最多允许上传5张！！';
var size = 5;
document.getElementById("img_btn").addEventListener("tap", function(e) {
	var spxcs = (first.item.spxcs).length + (first.item.spxcDataList).length;
	if(spxcs >= size) {
		mui.toast(tipMsg);
		return;
	}

	if(mui.os.plus) {
		var a = [{
			title: "拍照"
		}, {
			title: "从相册选择"
		}];

		plus.nativeUI.actionSheet({
			title: tipTitle,
			cancel: "取消",
			buttons: a
		}, function(b) { /*actionSheet 按钮点击事件*/
			switch(b.index) {
				case 0:
					break;
				case 1:
					getImage(); /*拍照*/
					break;
				case 2:
					galleryImg(); /*打开相册*/
					break;
				default:
					break;
			}
		})
	}
});

//拍照
function getImage() {
	var c = plus.camera.getCamera();
	c.captureImage(function(e) {
		plus.io.resolveLocalFileSystemURL(e, function(entry) {
			var s = entry.toLocalURL();
			var index = (first.item.spxcDataList).length;
			var id = uuid(32, 32);
			var str = '<li id="'+id+'" style="display: inline-block;  width:auto; padding-right: 0px;" class="drag-handle">' +
				'<span class="mui-icon iconfont icon-shanchu1" onclick="del_spImgxz(' + index + ')"></span>' +
				'<img src="' + s + '" data-preview-src="" data-preview-group="1" style="object-fit: contain;"/></li>';
			$("#spImg").append(str);

			var tpmc = s.substring(s.lastIndexOf("/") + 1);
			
			first.item.spxcDataList.push({
				id : id,
				path : s,
				tpmc: tpmc
			});

			/*var image = new Image();
			image.src = s;
			image.onload = function() {
				var imgData = getBase64Image(image);
				first.item.spxcDataList.push({
					id : id,
					tpmc: tpmc,
					tp4Base64: imgData,
					img: s
				});
			}*/

		}, function(e) {
			console.log("读取拍照文件错误：" + e.message);
		});
	}, function(s) {
		console.log("error" + s);
	})
}

//本地相册选择
function galleryImg() {
	plus.gallery.pick(
		function(e) {
			for(var i in e.files){
				
				var id = uuid(32, 32);
				var path = e.files[i];
				
				var index = (first.item.spxcDataList).length;
				var str = '<li id="'+id+'" style="display: inline-block;  width:auto; padding-right: 0px;" class="drag-handle">' +
					'<span class="mui-icon iconfont icon-shanchu1" onclick="del_spImgxz(' + index + ')"></span>' +
					'<img src="' + path + '" data-preview-src="" data-preview-group="1" style="object-fit: contain;" /></li>';
				$("#spImg").append(str);
				var tpmc = path.substring(path.lastIndexOf("/") + 1);
				
				first.item.spxcDataList.push({
					id : id,
					path : path,
					tpmc: tpmc
				});
				
				/*var image = new Image();
				image.src = e;
				image.onload = function() {
					var imgData = getBase64Image(image);
					first.item.spxcDataList.push({
						id : id,
						tpmc: tpmc,
						tp4Base64: imgData,
						img: e
					});
				}*/
			}
		},
		function(e) {
			//mui.toast('取消了选择');
		}, {
			filter: "image",multiple:true,maximum:3,system:false
		}
	);
}

//将图片压缩转成base64
function getBase64Image(img) {
	var canvas = document.createElement("canvas");
	var width = img.width;
	var height = img.height;
	var screenWidth = 800;
	var quality = 0.9; // 默认图片质量为0.7

	if(width > screenWidth) {
		height = Math.round(height / width * screenWidth);
		width = screenWidth;
	}

	var ctx = canvas.getContext('2d');
	// 创建属性节点
	var anw = document.createAttribute("width");
	anw.nodeValue = width;
	var anh = document.createAttribute("height");
	anh.nodeValue = height;
	canvas.setAttributeNode(anw);
	canvas.setAttributeNode(anh);
	ctx.drawImage(img, 0, 0, width, height);
	
	var dataURL = canvas.toDataURL("image/png", 0.9);
	return dataURL.replace("data:image/png;base64,", "");
}

/*初始化图片*/
function initSptp(spxcs) {
	var str = "";
	mui.each(spxcs, function(index, spxc) {
		var id = spxc.id;
		str += '<li id="'+id+'" style="display: inline-block;  width:auto; padding-right: 0px;" class="drag-handle">' +
			'<span class="mui-icon iconfont icon-shanchu1" onclick="del_spImgjz(' + index + ')"></span>' +
			'<img src="' + spxc.tpdz + '" data-preview-src="" data-preview-group="1" style="object-fit: contain;" /></li>';
	});
	var spxcDataList = first.item.spxcDataList;
	mui.each(spxcDataList, function(index, item) {
		var id = item.id;
		str += '<li id="'+id+'" style="display: inline-block;  width:auto; padding-right: 0px;" class="drag-handle">' +
			'<span class="mui-icon iconfont icon-shanchu1" onclick="del_spImgxz(' + index + ')"></span>' +
			'<img src="' + item.path + '" data-preview-src="" data-preview-group="1"  style="object-fit: contain;"/></li>';
	});
	$("#spImg").html(str);
}

/*删除加载图片*/
function del_spImgjz(index) {
	first.item.spxcs.splice(index, 1);
	initSptp(first.item.spxcs);
}
//删除选择的图片
function del_spImgxz(index) {
	first.item.spxcDataList.splice(index, 1);
	initSptp(first.item.spxcs);
}