var tipMsg = '';
//标题 可修改动态
var tipTitle = '上传附件';
//参数加载先，后面可在外面的mui.plus中动态赋值，外面的mui.plus加载比这里慢
//描述 可修改动态
var describe = '附件';
//图片数量默认为3，可修改动态
var tpSl = 3;
//图片大小默认为4096-4M，可修改动态
var limitSize = 4096;
//mainvue的引用，用于动态可修改引用
var directVue;
/*上传纸质单据*/
document.getElementById("zzdj_btn").addEventListener("tap", function(e) {
	//动态修改标题
	tipMsg = describe+'最多允许上传'+tpSl+'份！';
	var zzdjs = (directVue.zzdjs).length + (directVue.zzdjDataList).length;
	if(zzdjs >= tpSl) {
			mui.toast(tipMsg);
		return;
	}

	if(mui.os.plus) {
		var a = [{
			title: "拍照"
		}, {
			title: "从相册选择"
		}];

		plus.nativeUI.actionSheet({
			title: tipTitle,
			cancel: "取消",
			buttons: a
		}, function(b) { /*actionSheet 按钮点击事件*/
			switch(b.index) {
				case 0:
					break;
				case 1:
					getImage(); /*拍照*/
					break;
				case 2:
					galleryImg(); /*打开相册*/
					break;
				default:
					break;
			}
		})
	}
});

//拍照
function getImage() {
	var c = plus.camera.getCamera();
	c.captureImage(function(e) {
		plus.io.resolveLocalFileSystemURL(e, function(entry) {
			entry.getMetadata(function (metaData) {
				var imgSize = metaData.size / 1024;
				var size4M=	limitSize/1024;
				if(imgSize > limitSize){           
					//判断图片大小是否大于设定的值 
				    mui.toast(describe+'图片大小应小于'+size4M+'M！');
				}else{
					var s = entry.toLocalURL();
					var index = (directVue.zzdjDataList).length;
					var str = '<div style="height: 64px; width: auto; float: left; margin-right: 15px;margin-top: -5px;">' +
						'<div style="height: 10px;margin-right: -10px;position: relative;float: right;">' +
						'<span class="mui-icon iconfont icon-shanchu1" style="font-size: 20px;color: red;background-color: #FFFFFF;' +
						'border-radius: 10px;" onclick="del_xzzzdj(' + index + ')"></span></div><div style="height: 64px;">' +
						'<img src="' + s + '" data-preview-src="" data-preview-group="1" /></div></div>';
					$("#xzzzdj").append(str);
					
					var tpmc = s.substring(s.lastIndexOf("/") + 1);
					
					var bitmap = new plus.nativeObj.Bitmap("test");
					bitmap.load(s,function(){
						var imgData = bitmap.toBase64Data();
						
						imgData = imgData.replace("data:image/png;base64,", "");
						imgData = imgData.replace("data:image/jpeg;base64,", "");
						imgData = imgData.replace("data:image/jepg;base64,", "");
						imgData = imgData.replace("data:image/x-icon;base64,", "");
						imgData = imgData.replace("data:image/gif;base64,", "");
						
						directVue.zzdjDataList.push({
							tpmc: tpmc,
							tp4Base64: imgData,
							//img:s
						});
						
						bitmap.clear();
					},function(ex){
						console.log('加载图片失败：'+JSON.stringify(ex));
					});
					
					/*var image = new Image();
					image.src = s;
					image.onload = function() {
						var imgData = getBase64Image(image);
						directVue.zzdjDataList.push({
							tpmc: tpmc,
							tp4Base64: imgData,
							img: s
						});
						image=null;
					}*/
				}
			});


		}, function(e) {
			console.log("读取拍照文件错误：" + e.message);
		});
	}, function(s) {
		console.log("error" + s);
	})
}

//本地相册选择
function galleryImg() {
	// e为文件路径
	plus.gallery.pick(function(e) {
		plus.io.resolveLocalFileSystemURL(e, function(entry) {
			entry.getMetadata(function (metaData) {
			    var imgSize = metaData.size / 1024;
				var size4M=	limitSize/1024;
			    if(imgSize > limitSize){           
					//判断图片大小是否大于设定的值 
			        mui.toast(describe+'图片大小应小于'+size4M+'M！');
			    }else{
					var index = (directVue.zzdjDataList).length;
					var str = '<div style="height: 64px; width: auto; float: left; margin-right: 15px;margin-top: -5px;">' +
						'<div style="height: 10px;margin-right: -10px;position: relative;float: right;">' +
						'<span class="mui-icon iconfont icon-shanchu1" style="font-size: 20px;color: red;background-color: #FFFFFF;' +
						'border-radius: 10px;" onclick="del_xzzzdj(' + index + ')"></span></div><div style="height: 64px;">' +
						'<img src="' + e + '" data-preview-src="" data-preview-group="1" /></div></div>';
					$("#xzzzdj").append(str);
					var tpmc = e.substring(e.lastIndexOf("/") + 1);
					
					var bitmap = new plus.nativeObj.Bitmap("test");
					bitmap.load(e,function(){
						var imgData = bitmap.toBase64Data();
						
						imgData = imgData.replace("data:image/png;base64,", "");
						imgData = imgData.replace("data:image/jpeg;base64,", "");
						imgData = imgData.replace("data:image/jepg;base64,", "");
						imgData = imgData.replace("data:image/x-icon;base64,", "");
						imgData = imgData.replace("data:image/gif;base64,", "");
						
						directVue.zzdjDataList.push({
							tpmc: tpmc,
							tp4Base64: imgData,
							//img: e
						});
						
						bitmap.clear();
					},function(ex){
						console.log('加载图片失败：'+JSON.stringify(ex));
					});
					
					/*var image = new Image();
					image.src = e;
					image.onload = function() {
						var imgData = getBase64Image(image);
						directVue.zzdjDataList.push({
							tpmc: tpmc,
							tp4Base64: imgData,
							img: e
						});
						image = null;
					}*/ 
			    }           
			}, function () {
			   mui.toast('获取图片大小失败！');
			});
		})

	}, function(e) {
		//outSet( "取消选择图片" );
	}, {
		filter: "image"
	});

}

//将图片压缩转成base64
function getBase64Image(img) {
	var canvas = document.createElement("canvas");
	var width = img.width;
	var height = img.height;
	/*var screenWidth = plus.screen.resolutionWidth; //屏幕宽度
	
	if(width > screenWidth) {
		height = Math.round(height / width * screenWidth);
		width = screenWidth;
	}*/
	
	canvas.width = width; /*设置新的图片的宽度*/
	canvas.height = height; /*设置新的图片的长度*/
	var ctx = canvas.getContext("2d");
	ctx.drawImage(img, 0, 0, width, height); /*绘图*/
	var dataURL = canvas.toDataURL("image/png", 0.9);
	return dataURL.replace("data:image/png;base64,", "");
}

mui.plusReady(function() {
	// var _self = plus.webview.currentWebview();
	// var zzdjs = null;
	// if(first.item.id != null && first.item.id != '') {
	// 	if(_self.item !=null && _self.item.zzdjs!=null){
	// 		zzdjs = _self.item.zzdjs
	// 	}
	// }
	// if(zzdjs!==null&&zzdjs.length!==0){
	// 	initZzdj(zzdjs);
	// }
})

function initZzdj(zzdjs) {

	var str = "";
	mui.each(zzdjs, function(index, zzdj) {
		
		var fileName = zzdj.tpmc;
		var fileType = fileName.substring(fileName.lastIndexOf("."));
		
		if ( ".JPG" == fileType || ".PNG" == fileType || ".jpg" == fileType || ".png" == fileType) {
			var tpUrl = zzdj.tpdz;
			if(tpUrl.indexOf("imageView2") == -1){
				tpUrl += "?imageView2/0/w/120";
			}else{
				tpUrl += "|imageView2/0/w/120";
			}
			
			str += '<div style="height: 64px; width: auto; float: left; margin-right: 15px;margin-top: -5px;">' +
				'<div style="height: 10px;margin-right: -10px;position: relative;float: right;">' +
				'<span class="mui-icon iconfont icon-shanchu1" style="font-size: 20px;color: red;background-color: #FFFFFF;' +
				'border-radius: 10px;" onclick="del_zzdj(' + index + ')"></span></div><div style="height: 64px;">' +
				'<img src="' + tpUrl + '" data-preview-src="' + zzdj.tpdz + '" data-preview-group="1" /></div></div>';
		} else {
			
			var iconPath = "";
			if(".pdf" == fileType){
				iconPath = "http://img.loafish.com/icon/pdf.png";
			} else if(".doc" == fileType || ".docx" == fileType){
				iconPath = "http://img.loafish.com/icon/word.png";
			} else if(".xls" == fileType || ".xlsx" == fileType){
				iconPath = "http://img.loafish.com/icon/excel.png";
			}
			
			str += '<div style="height: 64px; width: auto; float: left; margin-right: 15px;margin-top: -5px;">' +
				'<div style="height: 10px;margin-right: -10px;position: relative;float: right;">' +
				'<span class="mui-icon iconfont icon-shanchu1" style="font-size: 20px;color: red;background-color: #FFFFFF;' +
				'border-radius: 10px;" onclick="del_zzdj(' + index + ')"></span></div><div style="height: 64px;">' +
				'<img src="' + iconPath + '" onclick="openFile_zzdj(\'' + zzdj.tpdz + '\')"/></div></div>';
			
		}
	});
	
	var zzdjDataList = directVue.zzdjDataList;
	mui.each(zzdjDataList, function(index, item) {
		var fileName = item.tpmc;
		var fileType = fileName.substring(fileName.lastIndexOf("."));
		var prefix = "";
		if ( ".JPG" == fileType || ".jpg" == fileType) {
			prefix = "data:image/jpeg;base64,";
		} else if (".PNG" == fileType || ".png" == fileType){
			prefix = "data:image/png;base64,";
		} else if (".GIF" == fileType || ".gif" == fileType){
			prefix = "data:image/gif;base64,";
		} else if (".JPEG" == fileType || ".jpeg" == fileType){
			prefix = "data:image/jpeg;base64,";
		}
		
		var tp4Base64 = prefix + item.tp4Base64 ;
		
		str += '<div style="height: 64px; width: auto; float: left; margin-right: 15px;margin-top: -5px;">' +
			'<div style="height: 10px;margin-right: -10px;position: relative;float: right;">' +
			'<span class="mui-icon iconfont icon-shanchu1" style="font-size: 20px;color: red;background-color: #FFFFFF;' +
			'border-radius: 10px;" onclick="del_xzzzdj(' + index + ')"></span></div><div style="height: 64px;">' +
			'<img src="' + tp4Base64 + '" data-preview-src="" data-preview-group="1" /></div></div>';
	});
	$("#xzzzdj").html(str);
}
/*删除加载图片*/
function del_zzdj(index) {
	directVue.zzdjs.splice(index, 1);
	initZzdj(directVue.zzdjs)
}
//删除选择的图片
function del_xzzzdj(index) {
	directVue.zzdjDataList.splice(index, 1);
	initZzdj(directVue.zzdjs)
}