//页面总数
var pages;
//刷新次数--用于判断是否还有数据
var count = 1;

mui.init();

mui.previewImage(); // 图片预览

new Vue({
	i18n: vueI18n,
	el: "#avue"
});

//================================================================================
var first = new Vue({
	i18n: vueI18n,
	el: "#main",
	data: {
		item: {
			id: '',
			ckId: '',
			ckMc: '',
			djrq: new Date().Format("yyyy-MM-dd"),
			qtckdBh: '',
			shzt: '0',
			wldw: '',
			ckmxDataList: [],
			wldwMc: '',
			cklx: '1',
			cklxMc: getMsg('销售出库'),
			ckrq: new Date().Format("yyyy-MM-dd"),
			ckjeHj: 0.00,
			ckslHj: 0,
			shfs: '2',
			shlxr: '',
			shlxdh: '',
			shdz: '',
			shsj: new Date().Format("yyyy-MM-dd"),
			wlgsmc: '',
			shdh: '',
			zzdjs: [],
			zzdjDataList: [],
			remarks: '',
			xmId: '',
			xmBh: '',
			xmMc: '',
			ztext1: '',
			ztext2:'',
			ztext3:'',
			ztext4:'',
			ztext5:'',
			ztext6:'',
			ztext7:'',
			ztext8:'',
			ztext9:'',
			ztext10:'',
			mxext1: '',
			mxext2:'',
			mxext3:'',
			mxext4:'',
			mxext5:'',
			mxext6:'',
			mxext7:'',
			mxext8:'',
			mxext9:'',
			mxext10:''
		},
		isXlhBz: false,
		isPchBz: false,
		npIsShow: false,
		showXlh:false,
		tag: '',
		ddwArr: [],
		qhId: '',
		qhdw: '',
		zdw: '',
		showJg: false,
		isFinish : false,
		showAuditBtn: false,
		menuList:[],
		baseCkdExtList: [],
		baseCkmxExtList: [],
		isEnabledSplc4Ckd: '0'
	},
	methods: {
		sxlh:function(){
			if(first.item.ckId == '') {
				mui.toast('请选择出货仓库！');
				return;
			}
			
			tzBarcode('cuku_xz.html',true);
		},
		xzWldwlX : function(){
			mui('#wldwlxPopover').popover('toggle');
		},
		toXzGys: function(){
			var subWebview = plus.webview.create('../common/select_gys.html', '../common/select_gys.html', webview_style, {
				enableFlag: '1',
				source: 'cuku_xz.html'
			});
			subWebview.addEventListener("titleUpdate", function() {
				subWebview.show("slide-in-right", 300);
			});
			
			mui('#wldwlxPopover').popover('toggle');
		},
		toXzKh: function(){
			var subWebview = plus.webview.create('../common/select_kh.html', '../common/select_kh.html', webview_style, {
				enableFlag: '1'
			});
			subWebview.addEventListener("titleUpdate", function() {
				subWebview.show("slide-in-right", 300);
			});
			
			mui('#wldwlxPopover').popover('toggle');
		},
		clear: function() {
			first.item.wldw = "";
			first.item.wldwMc = "";
		},
		clearXmxx: function() {
			first.item.xmId = "";
			first.item.xmBh = "";
			first.item.xmMc = "";
		},
		/*判断系统参数*/
		hasXtcsPermission: function() {
			var xlhBz = localStorage.getItem("xlhBz");
			var kqpchBz = localStorage.getItem("kqpchBz");
			/*判断是否显示序列号*/
			if(xlhBz === '1') { //0停用；1启用
				this.isXlhBz = true;
			}
			if(kqpchBz === '1') { //0停用；1启用
				this.isPchBz = true;
			}
		},
		moreWlxx: function(){
			var extras = {};
			var webview = plus.webview.create('../common/select_wlxx.html', 'select_wlxx.html', webview_style, extras);
			
			webview.addEventListener("titleUpdate", function() {
				webview.show(aniShow, 300);
			}); 
		},
		/*选择商品*/
		xzsp: function(item, index) {
			item.ckId = first.item.ckId;
			item.baseCkmxExtList =  first.baseCkmxExtList;
			mui.openWindow({
				id: 'select_ckspXq.html',
				url: 'select_ckspXq.html',
				styles: {
					background: 'transparent'
				},
				show: {
					autoShow: true,
					aniShow: 'none'
				},
				waiting: {
					autoShow: false
				},
				extras: {
					item: item,
					index: index,
					djObj: first.item
				}
			});
		},
		//计算填写的数量
		cal: function() {
			var sum = 0,
				count = 0;
			mui.each(this.item.ckmxDataList, function(index, item) {
				if(item.ckdj == null || isNaN(item.ckdj)) {
					item.ckdj = 0;
				}
				if(isNaN(item.cksl)) {
					item.cksl = 0;
				}

				item.ckdj = Number(item.ckdj);
				item.ckje = Number(item.cksl) * Number(item.ckdj);
				sum =  calc.Add(Number(sum),Number(item.ckje))  ;
				count = calc.Add(Number(count) , Number(item.cksl));
			});
			this.item.ckslHj = count;
			this.item.ckjeHj = sum;
		},
		gsCal: function(item){
			mui.each(first.baseCkmxExtList, function(index, ckmxExt) {
				if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
					var jsgs = ckmxExt.jsgs;
					if(/【\w*】/.test(jsgs)){
						var tmpVarNameArr = jsgs.match(/【\w*】/g);
						var gs = jsgs;
						for(var i=0; i < tmpVarNameArr.length; i++){
							var tmpVarNameStr = tmpVarNameArr[i];
							var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
							
							if(tmpVarName.indexOf("ztext") == 0){
								var tmpVal = Number(first.item[tmpVarName]);
								gs = gs.replace(tmpVarNameStr,tmpVal);
							}else{
								var tmpVal = Number(item[tmpVarName]);
								gs = gs.replace(tmpVarNameStr,tmpVal);
							}
						}
						
						var val = formatJe(eval(gs));
						item[ckmxExt.name] = val;
					} else {
						var val = formatJe(eval(jsgs));
						item[ckmxExt.name] = val;
					}
				}
			});
		},
		//对扩展字段进行计算
		rowExtCal : function(fieldName){
			
			var isExists = false;
			mui.each(first.baseCkmxExtList, function(index, ckmxExt) {
				if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
					var jsgs = ckmxExt.jsgs;
					if(/【\w*】/.test(jsgs)){
						var tmpVarNameArr = jsgs.match(/【\w*】/g);
						var gs = jsgs;
						for(var i=0; i < tmpVarNameArr.length; i++){
							var tmpVarNameStr = tmpVarNameArr[i];
							var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
							
							if(fieldName === tmpVarName){
								isExists = true;
								break;
							}
						}
					}
				}
			});
			
			if(isExists){
				mui.each(first.item.ckmxDataList, function(i, item) {
					mui.each(first.baseCkmxExtList, function(index, ckmxExt) {
						if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
							var jsgs = ckmxExt.jsgs;
							if(/【\w*】/.test(jsgs)){
								var tmpVarNameArr = jsgs.match(/【\w*】/g);
								var gs = jsgs;
								for(var i=0; i < tmpVarNameArr.length; i++){
									var tmpVarNameStr = tmpVarNameArr[i];
									var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
									
									if(tmpVarName.indexOf("ztext") == 0){
										var tmpVal = Number(first.item[tmpVarName]);
										gs = gs.replace(tmpVarNameStr,tmpVal);
									}else{
										var tmpVal = Number(item[tmpVarName]);
										gs = gs.replace(tmpVarNameStr,tmpVal);
									}
								}
								
								var val = formatJe(eval(gs));
								item[ckmxExt.name] = val;
							} else {
								var val = formatJe(eval(jsgs));
								item[ckmxExt.name] = val;
							}
						}
					});
				});
			}
		},
		//删除已选的商品
		/*下一步*/
		next_: function() {
			this.npIsShow = true;
		},
		/*上一步*/
		pre_: function() {
			this.npIsShow = false;
		},
		//保存至草稿（开启审核流程时使用）
		save2lscg: function(){
			save('-1');	
		},
		//保存至草稿
		save2cg: function(){
			save('0');	
		},
		//保存并审核
		save2sh: function(){
			save('1');	
		},
		//判断是否有审核权限
		hasPermission: function() {
			for(var i = 0; i < this.menuList.length; i++) {
				if(this.menuList[i].permission == 'inv:invQtck:audit') {
					this.showAuditBtn = true;
					break;
				}
			}
		}
	}
});

//================================出库类型===============================

var list_cklx = new Vue({
				i18n: vueI18n,
	el: "#list_cklx",
	data: {
		isIos:false,
		items: []
	}
});

function getCklxData() {
	token = localStorage.getItem('token');
	mui.ajax(hurl + '/dict/getDictList/inv_cklx', {
		dataType: 'json', //服务器返回json格式数据
		type: 'GET', //HTTP请求类型
		headers: {
			Authorization: token
		},
		timeout: 10000, //超时时间设置为10秒；	              
		success: function(data) {
			list_cklx.items = data;

		},
		error: function(xhr, type, errorThrown) {
			//异常处理；
			console.log(type + "异常了");
		}
	});
}

//回调函数-客户赋值
window.addEventListener('setKh', function(e) {
	
	first.item.wldw = e.detail.khId;
	first.item.wldwMc = e.detail.khMc;
	first.item.shdz = e.detail.khDz;
	first.item.shlxr = e.detail.syLxr;
	first.item.shlxdh = e.detail.syPhone;
	first.item.wlgsmc = e.detail.khWlgs;
});
window.addEventListener('setWlxx', function(e) {
	first.item.wlgsmc = e.detail.wlgsmc;  
})
/*回调函数-供应商赋值*/
window.addEventListener('setGys', function(e) {
	first.item.wldw = e.detail.gysId;
	first.item.wldwMc = e.detail.gysMc;
});

/*===========================出库类型控件点击触发事件==============================*/
document.getElementById("cklxMc").addEventListener('tap', function() {
	document.getElementById("cklxModal").classList.add("mui-active");

});
document.getElementById("cklxModal_close").addEventListener("tap", function() {
	document.getElementById("cklxModal").classList.remove("mui-active");
});
//出库类型选择
document.querySelector('.mui-table-view.mui-table-view-radio.cklx').addEventListener('selected', function(e) {
	first.item.cklx = e.detail.el.id;
	first.item.cklxMc = e.detail.el.innerText;

	document.getElementById("cklxModal").classList.remove("mui-active");
});

/*===========================仓库名称控件点击触发事件==============================*/
document.getElementById("ckMc").addEventListener('tap', function() {
	var subWebview = plus.webview.create('../common/select_ck.html', '../common/select_ck.html', webview_style, {
		source: 'chuku_xz.html'
	});
	subWebview.addEventListener("titleUpdate", function() {
		subWebview.show("slide-in-right", 300);
	});
});
/*回调函数-给仓库名称赋值*/
window.addEventListener('setCk', function(e) {
	var xlhBz = false;
	if(first.isXlhBz) {
		$.each(first.item.ckmxDataList, function(index, row) {
			if(row.kqxlhBz == '1') {
				xlhBz = true;
				return;
			}
		})
	}
	if(xlhBz && first.item.ckmxDataList.length > 0) {
		if(e.detail.ckId != first.item.ckId) {
			mui.confirm('切换仓库，商品序列号将被清空，确认要切换吗?', '温馨提示', ['取消', '确认'], function(event) {
				if(event.index == 1) {
					//确认
					$.each(first.item.ckmxDataList, function(index, row) {
						if(row.kqxlhBz == '1') {
							if(item.scXlhList == undefined) {
								item.scXlhList = item.xlhList;
							}
							row.xlhList = [];
							row.cksl = 0;
							return;
						}
					})
					first.item.ckId = e.detail.ckId;
					first.item.ckMc = e.detail.ckMc;
					first.cal();
				}
			}, 'div');
		}
	} else {
		first.item.ckId = e.detail.ckId;
		first.item.ckMc = e.detail.ckMc;
	}
});

/*===========================归属项目名称控件点击触发事件==============================*/
document.getElementById("xmMc").addEventListener('tap', function() {
	var subWebview = plus.webview.create('../common/select_xmxx.html', '../common/select_xmxx.html', webview_style, {
		xmId: first.item.xmId
	});
	subWebview.addEventListener("titleUpdate", function() {
		subWebview.show("slide-in-right", 300);
	});
});
/*回调函数-项目名称赋值*/
window.addEventListener('setXmxx', function(e) {
	first.item.xmId = e.detail.xmId;
	first.item.xmMc = e.detail.xmMc;
});

/*选择商品按钮*/
document.getElementById("xzsp_btn").addEventListener("tap", function(e) {
	if(first.item.ckId == '') {
		mui.toast('请选择出货仓库！');
		return;
	}

	var subWebview = plus.webview.create('select_cksp.html', 'select_cksp.html', webview_style, {
		item: first.item
	});
	subWebview.addEventListener("titleUpdate", function() {
		subWebview.show("slide-in-right", 300);
	});

});

/*回调函数-选择商品*/
window.addEventListener('selectedSpxx', function(e) {
	var tspljBz = localStorage.getItem("tspljBz");
	if (tspljBz === '1') {
		first.item.ckmxDataList = e.detail;
	}else {
		first.item.ckmxDataList = first.item.ckmxDataList.concat(e.detail);
	}
	
	first.cal();
	mui('.mui-switch')['switch']()
});

/*单个商品回调函数*/
window.addEventListener('setSpNum', function(e) {
	var item = e.detail.item;
	var del = e.detail.del;
	
	var kqysBz = localStorage.getItem("kqSpysBz");	
	//商品索引，跟del一样，不过条件不同，pchIndex是这里判断，传过来处理
	var pchIndex=e.detail.pchIndex;
	//已经处理标志，如果有多个相同id商品不同批号，在遍历中判断
	var isProcess=false;
	if(del != undefined) {
		first.item.ckmxDataList.splice(del, 1);
	} else {
		if( pchIndex != undefined ){
			var it = first.item.ckmxDataList[pchIndex];
			Vue.set(it, 'cksl', Number(item.cksl));
			Vue.set(it, 'ckdj', Number(item.ckdj));
			Vue.set(it, 'ckje', Number(item.ckje));
			Vue.set(it, 'dw', item.dw);
			Vue.set(it, 'dwMc', item.dwMc);
			Vue.set(it, 'xlhList', item.xlhList);
			Vue.set(it, 'scXlhList', item.scXlhList);
			Vue.set(it, 'remarks', item.remarks);
			
			if (first.isPchBz && it.kqpchBz === '1'){
				Vue.set(it, 'phId', item.phId);
				Vue.set(it, 'pch', item.pch);
				Vue.set(it, 'scrq', item.scrq);
				Vue.set(it, 'sxrq', item.sxrq);
			}
			
			for(var i =0;i<first.baseCkmxExtList.length;i++){
				Vue.set(it, first.baseCkmxExtList[i].name,item[first.baseCkmxExtList[i].name]);
			}
		} else {
			mui.each(first.item.ckmxDataList, function(i, it) {
				if(it.spId == item.spId) {
					if(kqysBz == '1' && it.kqysBz=='1'){
						if(it.ys == item.ys) {
							Vue.set(it, 'cksl', Number(item.cksl));
							Vue.set(it, 'ckdj', Number(item.ckdj));
							Vue.set(it, 'ckje', Number(item.ckje));
							Vue.set(it, 'dw', item.dw);
							Vue.set(it, 'dwMc', item.dwMc);
							Vue.set(it, 'xlhList', item.xlhList);
							Vue.set(it, 'scXlhList', item.scXlhList);
							Vue.set(it, 'remarks', item.remarks);
							for(var i =0;i<first.baseCkmxExtList.length;i++){
								Vue.set(it, first.baseCkmxExtList[i].name,item[first.baseCkmxExtList[i].name]);
							}
							return;
						}
					}
					else if (first.isPchBz && it.kqpchBz === '1'){
						if(isProcess){
							return;
						}					
						//获取原来的商品
						var tmpItem=first.item.ckmxDataList[pchIndex];
						//获取原来的商品里面的批次号
						var temPch=tmpItem.pch;
						//如果是没有批次号情况下进的批次号商品详情
						if(temPch === undefined || temPch === null || temPch === ""){
							var hasEqual=false;
							var equalIndex=0;
							mui.each(first.item.ckmxDataList, function(equalI, equalIt) {
								//如果原商品中已经有同一批次号了，那么就把数据相加
								if(equalIt.pch===item.pch && item.pch!==undefined && item.pch !== null && item.pch !== "" && equalIt.spId == item.spId){
									hasEqual=true;
									equalIndex=equalI;
								}
							});
							if(hasEqual){
								//原来的商品列表有这个商品批号
								//获取已经存在相同批次号的商品,数量相加，单价，单位替换，其他在cal函数里计算
								var equalItem=first.item.ckmxDataList[equalIndex];
								Vue.set(equalItem, 'cksl', formatSl(Number(equalItem.cksl)+Number(item.cksl)));
								Vue.set(equalItem, 'ckdj', Number(item.ckdj));
								Vue.set(equalItem, 'dw', item.dw);
								Vue.set(equalItem, 'dwMc', item.dwMc);
								Vue.set(equalItem, 'remarks', item.remarks);
								//删除旧的无批号商品信息
								first.item.ckmxDataList.splice(pchIndex, 1);
							}else{
								//原来的商品列表没有这个商品批号,这时就处理原数据
								Vue.set(tmpItem, 'cksl', Number(item.cksl));
								Vue.set(tmpItem, 'ckdj', Number(item.ckdj));
								Vue.set(tmpItem, 'ckje', Number(item.ckje));
								Vue.set(tmpItem, 'dw', item.dw);
								Vue.set(tmpItem, 'dwMc', item.dwMc);
								Vue.set(tmpItem, 'remarks', item.remarks);
								Vue.set(tmpItem, 'phId', item.phId);
								Vue.set(tmpItem, 'pch', item.pch);
								Vue.set(tmpItem, 'scrq', item.scrq);
								Vue.set(tmpItem, 'sxrq', item.sxrq);
							}
							isProcess=true;
						}else{
							//有批次号情况下进的批次号商品详情并且批次号相同,批次号相同就是刚好遍历到相同的
							//其实可以直接拿批次号索引处理
							if(it.pch === item.pch) {
								Vue.set(it, 'cksl', Number(item.cksl));
								Vue.set(it, 'ckdj', Number(item.ckdj));
								Vue.set(it, 'ckje', Number(item.ckje));
								Vue.set(it, 'dw', item.dw);
								Vue.set(it, 'dwMc', item.dwMc);
								Vue.set(it, 'remarks', item.remarks);
								isProcess=true;
								for(var i =0;i<first.baseCkmxExtList.length;i++){
									Vue.set(it, first.baseCkmxExtList[i].name,item[first.baseCkmxExtList[i].name]);
								}
								return;
							}
						}
					}else{
						Vue.set(it, 'cksl', Number(item.cksl));
						Vue.set(it, 'ckdj', Number(item.ckdj));
						Vue.set(it, 'ckje', Number(item.ckje));
						Vue.set(it, 'dw', item.dw);
						Vue.set(it, 'dwMc', item.dwMc);
						Vue.set(it, 'xlhList', item.xlhList);
						Vue.set(it, 'scXlhList', item.scXlhList);
						Vue.set(it, 'remarks', item.remarks);
						for(var i =0;i<first.baseCkmxExtList.length;i++){
							Vue.set(it, first.baseCkmxExtList[i].name,item[first.baseCkmxExtList[i].name]);
						}
						return;
					}
				}
			});
		}
	}
	first.cal();
});

/*绑定扫码添加按钮*/
document.getElementById("stxm_btn").addEventListener("tap", function(e) {
	if(first.item.ckId == '') {
		mui.toast('请选择出货仓库！');
		return;
	}

	tzBarcode('chuku_xz.html');
});

window.addEventListener('selectSpxx4Barcode', function(e) {
	selectSpxx4Barcode(e.detail.barcode);
});

var spItem4Ys = null;
window.addEventListener('setYsList', function(e) {
	var ysList = e.detail.ysList;
	var spdata = new Array();
	mui.each(ysList, function(p, ys) {
		var row = {};
		mui.extend(row, spItem4Ys);
		row.ysId = ys.ysId;
		row.ys = ys.ysId;
		row.ysMc = ys.ysMc;
		row.cksl = ys.cksl;
		row.ckje = formatJe(Number(row.cksl) * Number(row.ckdj));
		row.ysList = [];
		spdata.push(row);
	});
	
	var rows = new Array();
	mui.each(first.item.ckmxDataList, function(index, item) {
		rows.push(mui.extend({}, item));
	});
	
	for (var i = 0; i < spdata.length; i++) {
		var emptyFlag = true;
		for (var j = 0; j < rows.length; j++) {
			if (rows[j].spId === spdata[i].spId){
				if(rows[j].ys === spdata[i].ys){
					rows[j].cksl = calc.Add(Number(rows[j].cksl) , Number(spdata[i].cksl)) ;
					emptyFlag = false;
					break;
				}
			}
		}
		if (emptyFlag) {
			rows.push(spdata[i]); // 将被选中的行拼接进单据信息
		}
	}

	first.item.ckmxDataList = rows;
	first.cal();
});

/*扫码》添加商品*/
function selectSpxx4Barcode(barcode) {
	var params = {
		sptxm: barcode,
		ckId: first.item.ckId
	};

	var url = hurl + 'kcxx/findBySptxm';
	var yxfkcBz = localStorage.getItem("yxfkcBz");
	if(yxfkcBz === '1') {
		url = hurl + 'invSpxx/findBySptxm';
	}

	loafish.utils.ajax4Post(url, params, null, function(returnData) {
		if(returnData.id != null && returnData.id != '') {

			if(returnData.spId == null) {
				returnData.spId = returnData.id;
			}

			returnData.cksl = 1;
			if(first.isXlhBz && returnData.kqxlhBz === '1') {
				returnData.cksl = 0;
			}
			if(first.isPchBz && returnData.kqpchBz === '1') {
				returnData.cksl = 0;
			}
			returnData.dw = returnData.mrdw;
			returnData.dwMc = returnData.mrdwMc;
			returnData.ckdj = returnData.ckmrj;
			returnData.ckje = returnData.ckmrj;
			
			var kqysBz = localStorage.getItem("kqSpysBz");
			if(kqysBz == '1' && returnData.kqysBz=='1'){
				var item = returnData;
				spItem4Ys = item;
				
				if(item.ysList == undefined) {
					item.ysList = [];
				}
				var extras = { item: item }
				var webview = plus.webview.create('../common/select_ys.html', 'select_ys.html', webview_style, extras);
				webview.addEventListener("titleUpdate", function() {
					webview.show("slide-in-right", 300);
				});
				
				return;
			}

			var list = [returnData];

			if(first.item.ckmxDataList.length == 0) {
				first.item.ckmxDataList = list;
				mui.each(first.item.ckmxDataList, function(i, item) {
					item.ckje = Number(item.cksl) * Number(item.ckdj);
					item.spzhje = Number(item.ckje) * Number(item.spzk) / 100;
					
					//对扩展字段进行计算
					first.gsCal(item);
				});
			} else {
				if(first.isPchBz && returnData.kqpchBz === '1') {
					returnData.cksl = 0;
					
					//对扩展字段进行计算
					first.gsCal(returnData);
					
					first.item.ckmxDataList.unshift(returnData);
				} else {
					
					var ckmxDataList = new Array();
					var flag = true; //同商品多批次时判断只增加一个数量

					//同商品累加标志
					var tspljBz = localStorage.getItem("tspljBz");
					if (tspljBz === '1') {
						//已经存的商品，只需要增加数量，并更新各种合计金额
						for(var i = 0; i < first.item.ckmxDataList.length; i++) {
							var item = first.item.ckmxDataList[i];
							var item2 = null;
							for(var j = 0; j < list.length; j++) {
								item2 = list[j];
								if(item.spId == item2.spId && flag) {
									item.cksl = calc.Add( Number(item.cksl) , Number(item2.cksl));
									item.ckje = Number(item.cksl) * Number(item.jyxsj);
									
									//对扩展字段进行计算
									first.gsCal(item);
									
									flag = false;
									break;
								}
							}
							ckmxDataList.push(item);
						}
						
						//不存在的商品，追加在原商品之后
						for(var i = 0; i < list.length; i++) {
							var item2 = list[i];
							var item = null;
							var isExist = false;
						
							for(var j = 0; j < first.item.ckmxDataList.length; j++) {
								var item = first.item.ckmxDataList[j];
						
								if(item.spId == item2.spId) {
									isExist = true;
									break;
								}
							}
						
							if(!isExist) {
								item2.ckje =  Number(item2.cksl) * Number(item2.jyxsj);
								
								//对扩展字段进行计算
								first.gsCal(item2);
								
								var pxfs = localStorage.getItem('djspPxfs');
								if(pxfs=='2'){
									ckmxDataList.unshift(item2);
								}else{
									ckmxDataList.push(item2);
								}
								
							}
						}
						
					} else {
						for (var i = 0; i < first.item.ckmxDataList.length; i++) {
							var item = first.item.ckmxDataList[i];
							
							//对扩展字段进行计算
							first.gsCal(item);
							
							ckmxDataList.push(item);
						}
						
						var pxfs = localStorage.getItem('djspPxfs');
						if(pxfs=='2'){
							ckmxDataList.unshift(returnData);
						}else{
							ckmxDataList.push(returnData);
						}
					}

					first.item.ckmxDataList = ckmxDataList;
				}
			}

			first.cal();

		} else {
			mui.toast("未在库存中找到此条码！");
			playWarn();
		}
	});
}

window.addEventListener('selectSpxx4Xlh', function(e) {
	
	var xlh = e.detail.xlh;
	var params = {
		xlh: xlh,
		ckId : first.item.ckId
	};
	
	var url = hurl + 'kcxx/findBySpxlh';
	loafish.utils.ajax4Post(url, params, null, function(returnData) {
		if(returnData.id != null && returnData.id != '') {
			returnData.cksl = 1;
			returnData.sptxUrl = returnData.tpdz;
			returnData.dw = returnData.mrdw;
			returnData.dwMc = returnData.mrdwMc;
			returnData.ckdj = returnData.ckmrj;
			returnData.ckje = returnData.ckmrj;
			
			var xlhObj = {
				xlh : xlh, 
				kcmxId : returnData.kcmxId,
				remarks : returnData.xlhRemarks
			}

			if(first.item.ckmxDataList.length == 0) {
				returnData.xlhList = [xlhObj];
				
				//对扩展字段进行计算
				first.gsCal(returnData);
				
				first.item.ckmxDataList = [returnData];
			} else {
				var list = [returnData];
				var ckmxDataList = new Array();
				var isExist4Spxx = false;
				var isExist4Xlh = false; 
				
				//已经存的商品，只需要增加数量，并更新各种合计金额
				for(var i = 0; i < first.item.ckmxDataList.length; i++) {
					var item = first.item.ckmxDataList[i];
					var item2  = returnData;

					if(item.spId == item2.spId) {
						isExist4Spxx = true;
						
						mui.each(item.xlhList, function(ii, xlhItem) {
							if(xlhItem.xlh === xlh){
								isExist4Xlh = true;
								return;
							}
						});
						
						if(!isExist4Xlh){
							item.xlhList.push(xlhObj);
							item.cksl = Number(item.cksl) + 1;
							item.ckje = Number(item.cksl) * Number(item.ckdj);
							
							//对扩展字段进行计算
							first.gsCal(item);
						}
					}
					
					ckmxDataList.push(item);
				}
				
				if(isExist4Xlh){
					mui.toast("该序列号已被扫入（商品编号：" + returnData.spBh + "，名称：" + returnData.spMc + "），请核实！");
					playWarn();
					return;
				}
				
				if(!isExist4Spxx){
					returnData.xlhList = [xlhObj];
					
					//对扩展字段进行计算
					first.gsCal(returnData);
					
					var pxfs = localStorage.getItem('djspPxfs');
					if(pxfs=='2'){
						ckmxDataList.unshift(returnData);
					}else{
						ckmxDataList.push(returnData);
					}
					
				}
				
				first.item.ckmxDataList = ckmxDataList;
			}

			first.cal();
						
		} else {
			mui.toast("未找到相应商品，请核实！");
			playWarn();
		}
	});
	
});

//绑定完成按钮
function save(shzt){
	var params = {};
	mui.extend(params, first.item);
	params.ckmxDataList = first.item.ckmxDataList;
	params.shzt = shzt;
	params.ckslHj = first.item.ckslHj;
	/*送货方式*/
	if(params.shfs == '1') { //如果送货方式为自提，清空送货信息
		params.shsj = '';
		params.shlxr = '';
		params.shlxdh = '';
		params.shdz = '';
		params.wlgsmc = '';
		params.shdh = '';
	}
	//1、表单验证
	if(params.cklx == '') {
		mui.toast('请选择出库类型！');
		return;
	}

	if(params.djrq == '') {
		mui.toast('请填写出库日期！');
		return;
	}
	var djrq = document.getElementById("djrq").validity;
	if(!djrq.valid) {
		mui.toast('请填写正确的出库日期！');
		return;
	}
	if(params.ckMc == '') {
		mui.toast('请选择出货仓库！');
		return;
	}
	
	if(mustArr.length > 0){
		var flag = false;
		for (var i = 0; i < mustArr.length; i++) {
			var item = mustArr[i];
			var lable = item.lable;
			var name = item.name;
			if ($.trim(params[name]) == '') {
				if(item.dataType == '3'){
					mui.toast(lable+"不能为空，请选择！");
				} else {
					mui.toast(lable+"不能为空，请填写！");
				}
				
				flag = true;
				break;
			}
		}
		if(flag){
			return;
		}
	}
	
	if(params.ckmxDataList ==null || params.ckmxDataList.length == 0){
		mui.toast('请添加出库商品！');
		return;
	}
	
	//只允许点击一次完成，避免多次生成数据
	if(first.isFinish){
		return;
	}
	first.isFinish = true;
	
	
	//表单内容数据
	if(first.tag == "copy") {
		var url = hurl + 'qtckmx/save?tag=' + first.tag;
	} else {
		var url = hurl + 'qtckmx/save';
	}
	var zzdj = [];
	mui.each(first.item.zzdjs, function(index, item) {
		zzdj.push(item.tpId)
	});
	params.zzdjs = zzdj.join('&');
	loafish.utils.ajax4Post(url, params, "application/json", function(returnData) {
		if(returnData.success) {
			var data = returnData.data;

			first.item.id = data.id;
			first.item.qtckdBh = data.qtckdBh;
			var mainPage = plus.webview.getWebviewById("chukuRuku/chuku.html");
			mui.fire(mainPage, "queryCkd", {
				ywlx: '2'
			});

			//刷新待办事项
			var dbPage = plus.webview.getWebviewById("daiban.html");
			mui.fire(dbPage, "loadDbNum", {});

			if(isUpdate) {
				mui.back = function() {
					mainPage.show();
				}
			}
			mui.back();
			mui.toast('操作成功！');
		} else {
			mui.toast(returnData.msg);
			first.isFinish = false;
		}
	});
}

function getCk() {
	var url = hurl + '/invCk/list';
	var params = {
		page: 1,
		rows: 1,
		kjckfw: '0',
		isLock:'0'
	};
	var kjckfwBz = localStorage.getItem('kjckfw');
	params.kjckfw = kjckfwBz;

	loafish.utils.ajax4Get(url, params, null, function(returnData) {
		var list = returnData.rows;
		if(list!=null && list.length > 0 ) {
			var ck = list[0];
			first.item.ckId = ck.id;
			first.item.ckMc = ck.ckMc;
		}
	});
}

function getData(){
	var id = first.item.id;
	var url = hurl + 'qtckmx/query';
	var params = {
		qtckdId: id
	};

	loafish.utils.ajax4Get(url, params, null, function(data) {
		first.item.ckmxDataList = data.mxData;
		first.item.zzdjs = data.zzdjData;
	}, false);
}

var isUpdate = false;
var mustArr = [];
mui.plusReady(function() {
	var _self = plus.webview.currentWebview();
	list_cklx.isIos = mui.os.ios;
	
	mui.extend(first.item, _self.item);
	first.tag = _self.tag;
	if(first.item.shfs == '') {
		first.item.shfs = '2';
	}
	first.hasXtcsPermission();
	var showJg = localStorage.getItem('crkxsJgBz');
	if(showJg == '1') {
		first.showJg = true;
	}
	
	first.showXlh = (localStorage.getItem('xlhBz') == '1' && scanModel=='PHONE');

	if(first.item.id != null && first.item.id != '') {
		if(first.tag == "copy") {
			document.getElementById("title").innerText = getMsg("复制出库单");
			first.item.djrq = new Date().Format("yyyy-MM-dd");
			first.item.ckrq = new Date().Format("yyyy-MM-dd");
			first.item.shsj = new Date().Format("yyyy-MM-dd");
			first.item.shDate = null;
			
		} else {
			document.getElementById("title").innerText = getMsg("修改出库单");
		}
		isUpdate = true;
		
		getData();
	}else{
		getCk();
	}
	getCklxData();
	
	if(scanModel == 'PDA'){
		pageInit()  
	    setTimeout(function(){  
	        pdaScan(function(barcode){  
	        		selectSpxx4Barcode(barcode);
	        })  
	    },300);
    }
	
	//权限获取
	first.menuList = getMenuList("chukuRuku/chuku.html");
	first.baseCkdExtList = JSON.parse(localStorage.getItem('baseCkdExtList'));
	if(first.baseCkdExtList == null){
		first.baseCkdExtList = [];
	}
	first.baseCkdExtList.forEach(function(base, index){
		if(base.mustFlag != null && base.mustFlag == '1'){
			mustArr.push({ lable : base.lable, name : base.name, dataType: base.dataType });
		}
	});
	
	first.baseCkmxExtList = JSON.parse(localStorage.getItem('baseCkmxExtList'));
	if(first.baseCkmxExtList == null){
		first.baseCkmxExtList = [];
	}
	
	first.hasPermission();

	if(first.showJg){
		var tmpShowJg = false;
		for(var i = 0; i < first.menuList.length; i++) {
			if(first.menuList[i].permission == 'inv:invQtck:money') {
				tmpShowJg = true;
				break;
			}
		}
		first.showJg = tmpShowJg;
	}	
	
	first.isEnabledSplc4Ckd = localStorage.getItem("isEnabledSplc4Ckd");
	
});

mui('.mui-scroll-wrapper').scroll({});