mui.init();
mui.previewImage(); // 图片预览

var first = new Vue({
				i18n: vueI18n,
	el: "#main",
	data: {
		menuList: [],
		item:{
			id: '',
			ckId: '',
			ckMc: '',
			djrq: new Date().Format("yyyy-MM-dd"),
			qtckdBh: '',
			shzt: '0',
			wldw: '',
			ckmxDataList: [],
			wldwMc: '',
			cklx: '',
			cklxMc: '',
			zzdjs: [],
			mrKykcsl:'',
			zzdjDataList: [],
			
			shfs:'',
			shsj:'',
			shlxr:'',
			shlxdh:'',
			shgddh:'',
			shdz:'',
			wlgsmc:'',
			shdh:'',
			ztext1: '',
			ztext2:'',
			ztext3:'',
			ztext4:'',
			ztext5:'',
			ztext6:'',
			ztext7:'',
			ztext8:'',
			ztext9:'',
			ztext10:'',
			mxext1: '',
			mxext2:'',
			mxext3:'',
			mxext4:'',
			mxext5:'',
			mxext6:'',
			mxext7:'',
			mxext8:'',
			mxext9:'',
			mxext10:''
		},
		ckjeHj: 0.00,
		ckslHj: 0,
		isXlhBz: false,
		isPchBz: false,
		pdMenuList: [], //盘点权限列表,
		hasSdck: false //是否拥有锁定，解锁仓库权限
		,isFinish: false,
		showAuditBtn: false,
		menuList:[],
		baseCkdExtList: [],
		baseCkmxExtList: [],
		showXlh:false,
		isEnabledSplc4Ckd: '0'
	},
	methods: {
		stxm:function(){
			tzBarcode('dchuku_xz.html');
		},
		sxlh:function(){
			tzBarcode('dcuku_xz.html',true);
		},
		/*锁定解锁权限判断*/
		hasSdckPermission: function() {
			if(this.pdMenuList != null) {
				for(var i = 0; i < this.pdMenuList.length; i++) {
					if(this.pdMenuList[i].permission == 'inv:invPdd:check') {
						this.hasSdck = true;
						break;
					}
				}
			}
		},
		/*判断系统参数*/
		hasXtcsPermission: function() {
			var xlhBz = localStorage.getItem("xlhBz");
			var kqpchBz = localStorage.getItem("kqpchBz");
			/*判断是否开启序列号*/
			if(xlhBz === '1') { //0停用；1启用
				this.isXlhBz = true;
			}
			/*判断是否开启批次号*/
			if(kqpchBz === '1') { //0停用；1启用
				this.isPchBz = true;
			}
		},
		//计算填写的数量
		cal: function() {
			var sum = 0,
				count = 0;
			mui.each(this.item.ckmxDataList, function(index, item) {
				if(item.ckdj == null || isNaN(item.ckdj)) {
					item.ckdj = 0;
				}
				if(isNaN(item.cksl)) {
					item.cksl = 0;
				}
				
				item.cksl = formatSl(item.cksl, item.dwYxxsBz);
				item.ckdj = Number(item.ckdj);
				item.ckje = Number(item.cksl) * Number(item.ckdj);

				sum = Number(sum) + Number(item.ckje);
				count = Number(count) + Number(item.cksl);
			});
			first.ckslHj = count;
			first.ckjeHj = sum;
		},
		moreWlxx: function(){
			var extras = {};
			var webview = plus.webview.create('../common/select_wlxx.html', 'select_wlxx.html', webview_style, extras);
			
			webview.addEventListener("titleUpdate", function() {
				webview.show(aniShow, 300);
			}); 
		},
		//删除已选的商品
		del: function(index) {
			this.item.ckmxDataList.splice(index, 1);
			this.cal();
		},
		/*打开序列号添加页*/
		openXlh: function(el) {
			if(this.isXlhBz && el.kqxlhBz=='1') {
				if(el.xlhList == undefined) {
					el.xlhList = [];
				}
				if(el.scXlhList == undefined) {
					el.scXlhList = el.xlhList;
				}
				var extras = {
					item: el,
					ckId: this.item.ckId,
					ckmxDataList: this.item.ckmxDataList,
					source: 'dchuku_xz.html'
				}
				var url = 'dchuku_xlhxz.html';
				var webview = plus.webview.create(url, url, webview_style, extras);
				webview.addEventListener("titleUpdate", function() {
					webview.show("slide-in-right", 300);
				});
			} else if(this.isPchBz && el.kqpchBz=='1') {
				if(el.phxxList == undefined) {
					el.phxxList = [];
				}
				el.ckId = this.item.ckId;
				var extras = {
					item: el,
					title: '按批号填写出库数量'
				}
				var webview = plus.webview.create('../common/select_pch4ck.html', 'select_pch4ck.html', webview_style, extras);
				webview.addEventListener("titleUpdate", function() {
					webview.show("slide-in-right", 300);
				});
			}
		},
		//判断是否有审核权限
		hasPermission: function() {
			for(var i = 0; i < this.menuList.length; i++) {
				if(this.menuList[i].permission == 'inv:invQtck:audit') {
					this.showAuditBtn = true;
					break;
				}
			}
		},
		/*完成按钮事件*/
		save: function(shzt) {
			var params = this.item;
			params.shzt = shzt;
			
			if(params.djrq == '') {
				mui.toast('请填写入库日期！');
				return;
			}
			
			if(mustArr.length > 0){
				var flag = false;
				for (var i = 0; i < mustArr.length; i++) {
					var item = mustArr[i];
					var lable = item.lable;
					var name = item.name;
					if ($.trim(params[name]) == '') {
						if(item.dataType == '3'){
							mui.toast(lable+"不能为空，请选择！");
						} else {
							mui.toast(lable+"不能为空，请填写！");
						}
						
						flag = true;
						break;
					}
				}
				if(flag){
					return;
				}
			}
			
			var isEmpty = true;
			var isFlag = false;
			mui.each(params.ckmxDataList, function(index, item) {
				if(parseFloat(item.cksl) > 0) {
					isEmpty = false;
				}
				
				var dcksl = Number(item.dcksl) - Number(item.ycksl);
				dcksl = formatSl(dcksl,item.dwYxxsBz);
				
				if(dcksl < parseFloat(item.cksl)) {
					isFlag = true;
					return false;
				}
			})
			if(isFlag) {
				mui.toast('出库数量不能大于未出库数量！');
				return;
			}
			if(isEmpty) {
				mui.toast("所有商品的【本次出库数】都为【0】，不允许生成出库单！");
				return;
			}
			
			//只允许点击一次完成，避免多次生成数据
			if(first.isFinish){
				return;
			}
			first.isFinish = true;
			
			params.dckId = first.item.id;
			params.ckjeHj = first.ckjeHj;
			params.ckslHj = first.ckslHj;
			params.id = "";

			var url = hurl + 'qtckmx/save';
			
			var zzdj = [];
			mui.each(first.item.zzdjs, function(index, item) {
				zzdj.push(item.tpId)
			});
			params.zzdjs = zzdj.join('&');
			params.zzdjDataList = first.item.zzdjDataList;
			
			loafish.utils.ajax4Post(url, params, "application/json", function(returnData) {
				if(returnData.success) {
					var mainPage = plus.webview.getWebviewById("chukuRuku/chuku.html");
					mui.fire(mainPage, "queryCkd", {
						ywlx: '2'
					});

					//刷新待办事项
					var dbPage = plus.webview.getWebviewById("daiban.html");
					mui.fire(dbPage, "loadDbNum", {});

					if(mainPage!==null){
						mui.back = function() {
							mainPage.show();
						}
					}

					mui.back();
					mui.toast('操作成功！');
				} else {
					if(returnData.lock) {
						var ckTips = "";
						if(first.hasSdck) {
							ckTips = '<a onclick="tzck();return false">前往解锁</a>';
						} else {
							ckTips = "<span style='color:red;'>请通知仓库管理员进行解锁</span>";
						}
						mui.alert("此仓库为盘点锁定状态，请解锁后再进行操作！\n " + ckTips, "提示", "确定", function() {}, 'div')
						return;
					} else {
						mui.toast(returnData.msg);
					}

				}
			});
		},
		gsCal: function(item){
			mui.each(first.baseCkmxExtList, function(index, ckmxExt) {
				if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
					var jsgs = ckmxExt.jsgs;
					if(/【\w*】/.test(jsgs)){
						var tmpVarNameArr = jsgs.match(/【\w*】/g);
						var gs = jsgs;
						for(var i=0; i < tmpVarNameArr.length; i++){
							var tmpVarNameStr = tmpVarNameArr[i];
							var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
							
							if(tmpVarName.indexOf("ztext") == 0){
								var tmpVal = Number(first.item[tmpVarName]);
								gs = gs.replace(tmpVarNameStr,tmpVal);
							}else{
								var tmpVal = Number(item[tmpVarName]);
								gs = gs.replace(tmpVarNameStr,tmpVal);
							}
						}
						
						var val = formatJe(eval(gs));
						item[ckmxExt.name] = val;
					} else {
						var val = formatJe(eval(jsgs));
						item[ckmxExt.name] = val;
					}
				}
			});
		},
		//对扩展字段进行计算
		rowExtCal : function(fieldName){
			
			var isExists = false;
			mui.each(first.baseCkmxExtList, function(index, ckmxExt) {
				if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
					var jsgs = ckmxExt.jsgs;
					if(/【\w*】/.test(jsgs)){
						var tmpVarNameArr = jsgs.match(/【\w*】/g);
						var gs = jsgs;
						for(var i=0; i < tmpVarNameArr.length; i++){
							var tmpVarNameStr = tmpVarNameArr[i];
							var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
							
							if(fieldName === tmpVarName){
								isExists = true;
								break;
							}
						}
					}
				}
			});
			
			if(isExists){
				mui.each(first.item.ckmxDataList, function(i, item) {
					mui.each(first.baseCkmxExtList, function(index, ckmxExt) {
						if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
							var jsgs = ckmxExt.jsgs;
							
							if(/【\w*】/.test(jsgs)){
								var tmpVarNameArr = jsgs.match(/【\w*】/g);
								var gs = jsgs;
								for(var i=0; i < tmpVarNameArr.length; i++){
									var tmpVarNameStr = tmpVarNameArr[i];
									var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
									
									if(tmpVarName.indexOf("ztext") == 0){
										var tmpVal = Number(first.item[tmpVarName]);
										gs = gs.replace(tmpVarNameStr,tmpVal);
									}else{
										var tmpVal = Number(item[tmpVarName]);
										gs = gs.replace(tmpVarNameStr,tmpVal);
									}
								}
								
								var val = formatJe(eval(gs));
								item[ckmxExt.name] = val;
								//Vue.set(item, ckmxExt.name, val);
							} else {
								var val = formatJe(eval(jsgs));
								item[ckmxExt.name] = val;
								//Vue.set(item, ckmxExt.name, val)
							}
						}
					});
				});
			}
		}
	}
});

/*回调函数--设置序列号值*/
window.addEventListener('setXlhList', function(e) {
	var spId = e.detail.spId;
	var xlhList = e.detail.xlhList;
	mui.each(first.item.ckmxDataList, function(index, item) {
		//通过商品ID定位序列号所属明细
		if(item.spId == spId) {
			item.xlhList = xlhList;
			item.cksl = xlhList.length;
			return false;
		}
	})
	first.cal();
}) 
/*回调函数--设置批次号值*/
window.addEventListener('setPhxxList', function(e) {
	var spId = e.detail.spId;
	var phxxList = e.detail.phxxList;
	var cksl = e.detail.cksl;
	mui.each(first.item.ckmxDataList, function(index, item) {
		//通过商品ID定位批次号所属明细
		if(item.spId == spId) {
			item.phxxList = phxxList;
			item.cksl = cksl;
			return false;
		}
	})
	first.cal();
});

window.addEventListener('setWlxx', function(e) {
	Vue.set(first.item, 'wlgsmc', e.detail.wlgsmc); 
})

function getData() {
	var xlhBz = localStorage.getItem("xlhBz");
	var kqpchBz = localStorage.getItem("kqpchBz");
	
	var url = hurl + 'qtckmx/dckMap';
	var params = {
		dckdId: first.item.id,
		ydjId: first.item.ydjId,
		cklx : first.item.cklx,
	};
	loafish.utils.ajax4Get(url, params, null, function(data) {
		
		if(data.invDsd!==null && data.invDsd!==undefined && data.invDsd!==""){
			first.item.shfs = data.invDsd.shfs ;
			first.item.shsj = data.invDsd.shsj ;
			first.item.shlxr = data.invDsd.shlxr ;
			first.item.shlxdh = data.invDsd.shlxdh ;
			first.item.shgddh = data.invDsd.shgddh ;
			first.item.shdz = data.invDsd.shdz ;
			first.item.wlgsmc = data.invDsd.wlgsmc ;
			first.item.shdh = data.invDsd.shdh ;
		}
		var data = data.mxList;
		for(var i=0; i<data.length; i++){
			var row = data[i];
			
			var cksl = row.dcksl - row.ycksl;
			row.cksl = formatSl(cksl, row.dwYxxsBz);
			
			if (row.kqxlhBz === '1' && xlhBz === '1') {
				row.cksl = 0;
			}
			if (row.kqpchBz === '1' && kqpchBz === '1') {
					row.cksl = 0;
			}
		}
		first.item.ckmxDataList = data;
		
		first.cal();
	});
}

//======================================================================
var isUpdate = false;
var mustArr = [];
mui.plusReady(function() {
	var _self = plus.webview.currentWebview();

	first.item = _self.qtckd;
	first.item.zzdjs = [];
	first.item.zzdjDataList = [];
	first.item.djrq = new Date().Format("yyyy-MM-dd");

	first.hasXtcsPermission();
	//获取盘点权限
	first.pdMenuList = getMenuPermissions("pandian/pandian.html");
	first.hasSdckPermission();

	//权限获取
	first.menuList = getMenuList("chukuRuku/chuku.html");
	first.hasPermission();
	first.baseCkdExtList = JSON.parse(localStorage.getItem('baseCkdExtList'));
	first.baseCkmxExtList = JSON.parse(localStorage.getItem('baseCkmxExtList'));
	
	first.showXlh = (localStorage.getItem('xlhBz') == '1' && scanModel=='PHONE');
	
	getData();
	
	first.baseCkdExtList = JSON.parse(localStorage.getItem('baseCkdExtList'));
	if(first.baseCkdExtList == null){
		first.baseCkdExtList = [];
	}
	first.baseCkdExtList.forEach(function(base, index){
		if(base.mustFlag != null && base.mustFlag == '1'){
			mustArr.push({ lable : base.lable, name : base.name, dataType: base.dataType });
		}
	});
	
	first.baseCkmxExtList = JSON.parse(localStorage.getItem('baseCkmxExtList'));
	if(first.baseCkmxExtList == null){
		first.baseCkmxExtList = [];
	}
	
	first.isEnabledSplc4Ckd = localStorage.getItem("isEnabledSplc4Ckd");
});


window.addEventListener('selectSpxx4Barcode', function(e) {
	selectSpxx4Barcode(e.detail.barcode);
});

/*扫码》添加商品*/
function selectSpxx4Barcode(barcode) {
	var params = {
		sptxm: barcode,
		ckId: first.item.ckId
	};

	var url = hurl + 'kcxx/findBySptxm';
	var yxfkcBz = localStorage.getItem("yxfkcBz");
	if(yxfkcBz === '1') {
		url = hurl + 'invSpxx/findBySptxm';
	}

	loafish.utils.ajax4Post(url, params, null, function(returnData) {
		if(returnData.id != null && returnData.id != '') {

			returnData.cksl = 1;
			
			var emptyFlag = true;
			var isExist = false;
			mui.each(first.item.ckmxDataList, function(index, item) {
				if(item.spId == returnData.spId){
					isExist = true;
					return false;
				}
			});
			
			if(!isExist){
				mui.toast("该商品不在此次出库单范围内！");
				playWarn();
				return;
			}
			
			if(returnData.kqysBz=='1' || returnData.kqpchBz === '1'
				|| returnData.kqxlhBz === '1'){
				mui.toast("扫入无效：该商品有开启颜色/批号/序列号管理！");
				playWarn();
				return;
			}
			
			var rows = first.item.ckmxDataList;
			for (var j = 0; j < rows.length; j++) {
				var row = rows[j];
				if (row.spId == returnData.spId) {
					if(row.cksl == (row.dcksl - row.ycksl)){
						mui.toast("扫入无效：出库数已超待出库数！");
						playWarn();
						break;
					}
					
					row.cksl = Number(row.cksl) + Number(returnData.cksl);
					
					break;
				}
			}

		} else {
			mui.toast("未在库存中找到此条码！");
			playWarn();
		}
	});
}


window.addEventListener('selectSpxx4Xlh', function(e) {
	
	var xlh = e.detail.xlh;
	var params = {
		xlh: xlh,
		ckId : first.item.ckId
	};
	
	var url = hurl + 'kcxx/findBySpxlh';
	loafish.utils.ajax4Post(url, params, null, function(returnData) {
		if(returnData.id != null && returnData.id != '') {
			returnData.cksl = 1;
			returnData.sptxUrl = returnData.tpdz;
			returnData.dw = returnData.mrdw;
			returnData.dwMc = returnData.mrdwMc;
			returnData.ckdj = returnData.ckmrj;
			returnData.ckje = returnData.ckmrj;
			
			var xlhObj = {
				xlh : xlh, 
				kcmxId : returnData.kcmxId 
			}

			if(first.item.ckmxDataList.length == 0) {
				returnData.xlhList = [xlhObj];
				first.item.ckmxDataList = [returnData];
			} else {
				var list = [returnData];
				var ckmxDataList = new Array();
				var isExist4Spxx = false;
				var isExist4Xlh = false; 
				
				//已经存的商品，只需要增加数量，并更新各种合计金额
				for(var i = 0; i < first.item.ckmxDataList.length; i++) {
					var item = first.item.ckmxDataList[i];
					var item2  = returnData;

					if(item.spId == item2.spId) {
						isExist4Spxx = true;
						
						mui.each(item.xlhList, function(ii, xlhItem) {
							if(xlhItem.xlh === xlh){
								isExist4Xlh = true;
								return;
							}
						});
						
						if(!isExist4Xlh){
							item.xlhList.push(xlhObj);
							item.cksl = Number(item.cksl) + 1;
							item.ckje = Number(item.cksl) * Number(item.ckdj);
							//ckmxDataList.unshift(item);
							
							var pxfs = localStorage.getItem('djspPxfs');
							if(pxfs=='2'){
								ckmxDataList.unshift(item);
							}else{
								ckmxDataList.push(item);
							}
							
							break;
						}
					}
				}
				
				if(isExist4Xlh){
					mui.toast("该序列号已被扫入（商品编号：" + returnData.spBh + "，名称：" + returnData.spMc + "），请核实！");
					playWarn();
					return;
				}
				
				if(!isExist4Spxx){
					returnData.xlhList = [xlhObj];
					//ckmxDataList.unshift(returnData);
					
					var pxfs = localStorage.getItem('djspPxfs');
					if(pxfs=='2'){
						ckmxDataList.unshift(returnData);
					}else{
						ckmxDataList.push(returnData);
					}
				}
				
				first.item.ckmxDataList = ckmxDataList;
			}

			first.cal();
						
		} else {
			mui.toast("未找到相应商品，请核实！");
			playWarn();
		}
	});
	
});

mui('.mui-scroll-wrapper').scroll();