mui.init();
mui.previewImage(); // 图片预览

//================================================================================
new Vue({
	i18n: vueI18n,
	el: "#header"
});

new Vue({
	i18n: vueI18n,
	el: "#headerxsr"
});

var footer = new Vue({
	i18n: vueI18n,
	el: "#footer",
	data: {
		item: {
			yhhje: 0
		},
		showAuditBtn: false,
		menuList: [],
		showPrintBtn:false,
		isTxjgBz:false,
		isEnabledSplc4Xsd:'0'
	},
	methods: {
		//判断是否有审核权限
		hasPermission: function() {
			for (var i = 0; i < this.menuList.length; i++) {
				if (this.menuList[i].permission == 'inv:invXsd:audit') {
					this.showAuditBtn = true;
					continue;
				}
				if(this.menuList[i].permission == 'inv:invXsd:print') {
					this.showPrintBtn = true;
					continue;
				}
			}
		}
	}
});



var first = new Vue({
	i18n: vueI18n,
	el: "#first",
	data: {
		item: {
			id: '',
			ckId: '',
			ckMc: '',
			djrq: new Date().Format("yyyy-MM-dd"),
			djBh: '',
			ddId: '',
			ddBh: '',
			shzt: '0',
			khId: '',
			khMc: '',
			khYsk: '',
			ywlb: '1',
			spmxDataList: [],
			ckrq: new Date().Format("yyyy-MM-dd"),
			xsjeHj: 0.00,
			xsslHj: 0,
			qtfylx: '',
			qtfylxMc: '',
			qtfyje: null,
			yhje: null,
			yfk: null,
			yfhqk: null,
			xscbje: 0.00,
			zzdjs: [],
			zzdjDataList: [],
			jszh: '',
			jszhMc: '',
			orgId: '',
			orgMc: '',
			xmId: '',
			xmmc: '',
			khddh: '',
			qtfyList: [],
			isFirst: true,
			ztext1: '',
			ztext2: '',
			ztext3: '',
			ztext4: '',
			ztext5: '',
			ztext6: '',
			ztext7: '',
			ztext8: '',
			ztext9: '',
			ztext10: '',
			mxext1: '',
			mxext2:'',
			mxext3:'',
			mxext4:'',
			mxext5:'',
			mxext6:'',
			mxext7:'',
			mxext8:'',
			mxext9:'',
			mxext10:'',
			khHydj: ''
		},
		isXhSlBz: false,
		isXlhBz: false,
		isXjBz: false,
		isTxjgBz:false,
		tag: '',
		ddwArr: [],
		qhId: '',
		qhdw: '',
		zdw: '',
		showCbj: false, //显示成本价标识,
		xsjcBz: false,
		showXsbm: false,
		showXlh: false,
		isFinish: false,
		npIsShow: false,
		crkBz: '0',
		zqglBz: '0',
		baseXsdExtList: [],
		baseXsmxExtList: [],
		isEnabledSplc4Xsd: '0'
	},
	methods: {
		batchZk : function(){
			var btnArray = [getMsg("取消"),getMsg("确定")];
			mui.prompt('请输入折扣(%)','',getMsg('批量设置折扣'),btnArray, function(e){
				if(e.index == 1){
					var tmp = document.querySelector('.mui-popup-input input').value.trim();
					var spzk = Number(tmp);
					if(spzk == null || spzk == ''){
						spzk = 100;
					}
					
					mui.each(first.item.spmxDataList, function(index, item) {
						item.spzk = spzk;
					});
					
					first.cal();
				}
			},"div");
			
			var tt = document.querySelector('.mui-popup-input');
			tt.innerHTML = "<input type='number'/>";
		}, 
		sxlh: function() {
			//验证供应商是否有选择
			if (first.item.khId == '') {
				mui.toast(getMsg('客户不能为空，请选择！'));
				return;
			}
			if (first.item.ckId == '') {
				mui.toast(getMsg('仓库不能为空，请选择！'));
				return;
			}

			tzBarcode('xiaoshou_xz.html', true);
		},
		clearXmxx: function() {
			first.item.xmId = '';
			first.item.xmbh = '';
			first.item.xmmc = '';
		},
		//其它费用弹窗
		qtfytc: function() {
			var extras = {
				dsdId: first.item.id,
				qtfyList: first.item.qtfyList,
				isFirst: first.item.isFirst
			};

			var webview = plus.webview.create('../common/select_dsd_qtfy.html', 'select_dsd_qtfy.html',
				webview_style, extras);

			webview.addEventListener("titleUpdate", function() {
				webview.show(aniShow, 300);
			});
		},
		/*判断系统参数*/
		hasXtcsPermission: function() {
			var xhSlBz = localStorage.getItem("xhSlBz");
			var xlhBz = localStorage.getItem("xlhBz");
			var crkBz = localStorage.getItem("crkBz");
			var kqpchBz = localStorage.getItem("kqpchBz");
			var xjBz = localStorage.getItem("xjBz");
			/*判断销货税率*/
			if (xhSlBz === '1') { //0停用；1启用
				this.isXhSlBz = true;
			}
			/*判断是否显示序列号*/
			if (xlhBz === '1' && crkBz === '0') { //0停用；1启用
				this.isXlhBz = true;
			}
			/*判断是否现结*/
			if (xjBz === '1') { //0停用；1启用
				this.isXjBz = true;
			}
			if (kqpchBz === '1') { //0停用；1启用
				this.isPchBz = true;
			}
			first.crkBz = crkBz;
		},
		/*选择商品*/
		xzsp: function(item, index) {
			item.khId = first.item.khId;
			item.ckId = first.item.ckId;
			item.khHydj = first.item.khHydj;
			
			mui.openWindow({
				id: 'select_xsspXq.html',
				url: 'select_xsspXq.html',
				styles: {
					background: 'transparent'
				},
				show: {
					autoShow: true,
					aniShow: 'none'
				},
				waiting: {
					autoShow: false
				},
				extras: {
					item: item,
					index: index,
					djObj: first.item
				}
			});
		},
		//计算填写的数量
		cal: function() {
			var sum = 0,
				count = 0,
				seHj = 0,
				xscbje = 0.00;
			var sjhj = 0;
			mui.each(this.item.spmxDataList, function(index, item) {
				if (item.xsdj == null || isNaN(item.xsdj)) {
					item.xsdj = 0;
				}
				if (item.spzk == null || isNaN(item.spzk)) {
					item.spzk = 100;
				}
				if (isNaN(item.xssl)) {
					item.xssl = 0;
				}
				if (isNaN(item.spzk)) {
					item.spzk = 100;
				}
				if (isNaN(item.xscbdj)) {
					item.xscbdj = 0;
				}

				item.xsdj = formatDj(item.xsdj);
				item.xsje = formatJe(Number(item.xssl) * Number(item.xsdj));
				item.spzhdj = formatDj(Number(item.spzk) / 100 * Number(item.xsdj));
				//item.spzhje = formatJe(Number(item.xsje) * Number(item.spzk) / 100);

				xscbje = formatJe(Number(xscbje) + Number(item.xscbdj) * Number(item.xssl));

				//计算销售提成
				if (item.xstcfs == "1" && item.zpbz != '1') {
					if (item.ddwFlag == '1') {
						var ddwStr = JSON.parse(item.ddwStr);
						mui.each(ddwStr, function(i, dwStr) {
							if (item.dw == dwStr.dw) {
								var fdwNum = dwStr.fdwNum;
								if (fdwNum == undefined) {
									fdwNum = 1;
								}

								item.xstc = formatJe(Number(item.xssl) * Number(item
									.xstcsz) * Number(fdwNum));
							}
						})
					} else {
						item.xstc = formatJe(Number(item.xssl) * Number(item.xstcsz));
					}
				}
				if (item.xstcfs == "2" && item.zpbz != '1') {
					item.xstc = formatJe(Number(item.spzhje) * Number(item.xstcsz) / 100);
				}

				sum = Number(sum) + Number(item.spzhje);
				count = Number(count) + Number(item.xssl);

				//增加税率判断
				if (first.isXhSlBz) {
					if (item.sl === '' || item.sl == null) {
						item.se = '';
					} else {
						item.se = formatJe(Number(item.spzhje) * Number(item.sl) / 100);
					}
					if (item.hsdj === '' || item.hsdj === null || item.hsdj === undefined) {
						item.hsdj = formatDj(Number(item.xsdj) * ((Number(item.sl) + 100) / 100))
					}
					//item.sjhj = formatJe(Number(item.hsdj) * Number(item.xssl) * Number(item.spzk) / 100);
					seHj += Number(item.se);
					sjhj += Number(item.sjhj);
				} else {
					item.se = null;
					item.hsdj = null;
					item.sjhj = null;
				}
			});

			this.item.xscbje = xscbje;
			this.item.xsslHj = count;
			this.item.xsjeHj = sum;
			this.item.seHj = Number(seHj);
			// this.item.sjhj = Number(seHj) + Number(sum);

			footer.item.yhhje = (first.isXhSlBz ? sjhj : Number(this.item.xsjeHj)) +
				Number((this.item.qtfyje == '' || this.item.qtfyje == null) ? 0 : this.item.qtfyje) -
				Number((this.item.yhje == '' || this.item.yhje == null) ? 0 : this.item.yhje);
			
			footer.item.yhhje = formatJe(footer.item.yhhje);	
				
			if (this.item.yfk != null && this.item.yfk != null) {
				this.item.yfhqk = Number(footer.item.yhhje) - Number(this.item.yfk);
			}
		},
		gsCal: function(item){
			mui.each(first.baseXsmxExtList, function(index, ckmxExt) {
				if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
					var jsgs = ckmxExt.jsgs;
					if(/【\w*】/.test(jsgs)){
						var tmpVarNameArr = jsgs.match(/【\w*】/g);
						var gs = jsgs;
						for(var i=0; i < tmpVarNameArr.length; i++){
							var tmpVarNameStr = tmpVarNameArr[i];
							var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
							
							if(tmpVarName.indexOf("ztext") == 0){
								var tmpVal = Number(first.item[tmpVarName]);
								gs = gs.replace(tmpVarNameStr,tmpVal);
							}else{
								var tmpVal = Number(item[tmpVarName]);
								gs = gs.replace(tmpVarNameStr,tmpVal);
							}
						}
						
						var val = formatJe(eval(gs));
						item[ckmxExt.name] = val;
					} else {
						var val = formatJe(eval(jsgs));
						item[ckmxExt.name] = val;
					}
				}
			});
		},
		//对扩展字段进行计算
		rowExtCal : function(fieldName){
			
			var isExists = false;
			mui.each(first.baseXsmxExtList, function(index, ckmxExt) {
				if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
					var jsgs = ckmxExt.jsgs;
					if(/【\w*】/.test(jsgs)){
						var tmpVarNameArr = jsgs.match(/【\w*】/g);
						var gs = jsgs;
						for(var i=0; i < tmpVarNameArr.length; i++){
							var tmpVarNameStr = tmpVarNameArr[i];
							var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
							
							if(fieldName === tmpVarName){
								isExists = true;
								break;
							}
						}
					}
				}
			});
			
			if(isExists){
				mui.each(first.item.spmxDataList, function(i, item) {
					mui.each(first.baseXsmxExtList, function(index, ckmxExt) {
						if(ckmxExt.dataType == '2' && ckmxExt.jsgs!='') {
							var jsgs = ckmxExt.jsgs;
							if(/【\w*】/.test(jsgs)){
								var tmpVarNameArr = jsgs.match(/【\w*】/g);
								var gs = jsgs;
								for(var i=0; i < tmpVarNameArr.length; i++){
									var tmpVarNameStr = tmpVarNameArr[i];
									var tmpVarName = tmpVarNameStr.replace("【","").replace("】","");
									
									if(tmpVarName.indexOf("ztext") == 0){
										var tmpVal = Number(first.item[tmpVarName]);
										gs = gs.replace(tmpVarNameStr,tmpVal);
									}else{
										var tmpVal = Number(item[tmpVarName]);
										gs = gs.replace(tmpVarNameStr,tmpVal);
									}
								}
								
								var val = formatJe(eval(gs));
								item[ckmxExt.name] = val;
							} else {
								var val = formatJe(eval(jsgs));
								item[ckmxExt.name] = val;
							}
						}
					});
				});
			}
		},
		/*选择结算账户*/
		xzJszh: function() {
			var extras = {
				khId: first.item.khId,
				khYsk: first.item.khYsk
			}
			var webview = plus.webview.create('../common/select_jszh.html', '../common/select_jszh.html',
				webview_style, extras);
			webview.addEventListener("titleUpdate", function() {
				webview.show(aniShow, 300);
			});
		},
		selectOrg: function() {
			var webview = plus.webview.create('../common/search_org.html', 'search_org.html',
			webview_style, {});
			webview.addEventListener("titleUpdate", function() {
				webview.show(aniShow, 300);
			});
		}
	}
});

var second = new Vue({
	i18n: vueI18n,
	el: "#second",
	data: {
		item: {
			shfs: '1',
			xmbh: '',
			xmmc: '',
			shsj: new Date().Format("yyyy-MM-dd"),
			shlxr: '',
			shlxdh: '',
			shdz: '',
			wlgsmc: '',
			shdh: '',
			xsr: '',
			xsrMc: getMsg('请选择'),
			remarks: '',
			spbz: '0'
		}
	}
});

//==========================================================
var list_xsr = new Vue({
	i18n: vueI18n,
	el: "#list_xsr",
	data: {
		isIos: false,
		items: [],
	}
});

mui.plusReady(function() {
	getYgData(1, pageSize);
});

function getYgData(pageNo, pageSize) {

	var url = hurl + 'sys/user/queryAllYgxx';
	var params = {
		page: pageNo,
		rows: pageSize
	};

	loafish.utils.ajax4Get(url, params, null, function(data) {
		list_xsr.items = data;
	});

}

function toKhLxr() {
	var extras = {
		khId: first.item.khId,
	};
	var webview = plus.webview.create('../common/select_khLxr.html', 'select_khLxr.html', webview_style, extras);

	webview.addEventListener("titleUpdate", function() {
		webview.show(aniShow, 300);
	});
}

function moreWlxx() {
	var extras = {};
	var webview = plus.webview.create('../common/select_wlxx.html', 'select_wlxx.html', webview_style, extras);

	webview.addEventListener("titleUpdate", function() {
		webview.show(aniShow, 300);
	});
}
//====================================================================================

//客户名称控件点击触发事件
document.getElementById("khMc").addEventListener('tap', function() {
	var subWebview = plus.webview.create('../common/select_kh.html', '../common/select_kh.html',
	webview_style, {
		enableFlag: '1'
	});
	subWebview.addEventListener("titleUpdate", function() {
		subWebview.show(aniShow, 300);
	});
});
/*回调函数-给客户名称赋值*/
window.addEventListener('setKh', function(e) {
	first.item.khId = e.detail.khId;
	first.item.khMc = e.detail.khMc;
	first.item.khYsk = e.detail.ysk;
	first.item.qyZqglBz = e.detail.qyZqglBz;
	first.item.xyEd = e.detail.xyEd;
	first.item.ljqk = e.detail.qkje;
	first.item.khHydj = e.detail.khHydj;

	second.item.shlxr = e.detail.syLxr;
	second.item.shlxdh = e.detail.syPhone;
	second.item.shdz = e.detail.khDz;
	second.item.wlgsmc = e.detail.khWlgs;

	if (e.detail.xsr) {
		second.item.xsr = e.detail.xsr;
		second.item.xsrMc = e.detail.xsrMc;
	} else {
		second.item.xsr = loafish.utils.getUserId();
		second.item.xsrMc = loafish.utils.getUserName();
	}

	if (first.item.spmxDataList.length > 0) {
		first.item.spmxDataList.forEach(function(row, index) {

			var mrscxsjBz = localStorage.getItem("mrscxsjBz");
			if (mrscxsjBz == '1') {
				var data = JSON.parse(row.ddwStr);
				for (var i = 0; i < data.length; i++) {
					var item = data[i];
					if (row.dw == item.dw) {
						var jgObj = getScXsdj(row.spId, row.dw, item.jyxsj, item.jylsj);
						Vue.set(row, 'xsdj', jgObj.spjg);
						break;
					}
				}
			} else {
				var data = JSON.parse(row.ddwStr);
				for (var i = 0; i < data.length; i++) {
					var item = data[i];
					if (row.dw == item.dw) {
						Vue.set(row, 'xsdj', item.jyxsj);
						break;
					}
				}
			}

			var hydj = first.item.khHydj;
			if (row.hyFlag === '1' && hydj != null && hydj != '') {
				var hyStr = JSON.parse(row.hyStr);
				for (var i = 0; i < hyStr.length; i++) {
					if (hyStr[i].djId === hydj) {
						if (hyStr[i].hypfj == null || hyStr[i].hypfj == '' || hyStr[i].hypfj ==
							'null') {
							var hyzk = hyStr[i].hyzk;
							if (hyzk == null || hyzk == '' || hyzk == 'null') {
								hyzk = "100";
							}
							Vue.set(row, 'spzk', hyzk);
							break;
						} else {
							Vue.set(row, 'spzk', Number(100));
							Vue.set(row, 'xsdj', Number(hyStr[i].hypfj) * Number(row.fdwNum));
							break;
						}
						break;
					}
				}
			} else {
				Vue.set(row, 'spzk', Number(100));
			}

			Vue.set(row, 'xsje', formatJe(Number(row.xssl) * Number(row.xsdj)));
			Vue.set(row, 'spzhdj', formatJe(Number(row.spzk) / 100 * Number(row.xsdj)));
			Vue.set(row, 'spzhje', formatJe(Number(row.xsje) * Number(row.spzk) / 100));

			if (first.isXhSlBz) {
				Vue.set(row, 'se', formatJe(Number(row.spzhje) * Number(row.sl) / 100));
				Vue.set(row, 'hsdj', formatJe(Number(row.xsdj) * (Number(row.sl) + 100) / 100));
				Vue.set(row, 'sjhj', formatJe(Number(row.hsdj) * Number(row.xssl) * Number(row.spzk) /
					100));
			}

		})
		first.cal();
	}

});
// 回调函数 - 给客户联系人
window.addEventListener("setKhLxr", function(e) {
	second.item.shlxr = e.detail.lxr;
	second.item.shlxdh = e.detail.phone;
	second.item.shdz = e.detail.dz;
});


/*回调函数-给其他费用赋值*/
window.addEventListener('setQtfyList', function(e) {
	first.item.qtfyList = e.detail.qtfyList;
	first.item.isFirst = e.detail.isFirst;
	var qtfy = 0;
	mui.each(first.item.qtfyList, function(index, item) {
		qtfy = Number(qtfy) + Number(item.je);
	})
	first.item.qtfyje = qtfy;
	first.cal();
});


//项目名称控件点击触发事件
document.getElementById("xmmc").addEventListener('tap', function() {
	var subWebview = plus.webview.create('../common/select_xmxx.html', '../common/select_xmxx.html',
		webview_style, {
			xmId: first.item.xmId
		});
	subWebview.addEventListener("titleUpdate", function() {
		subWebview.show(aniShow, 300);
	});
});
/*回调函数-项目名称赋值*/
window.addEventListener('setXmxx', function(e) {
	first.item.xmId = e.detail.xmId;
	first.item.xmmc = e.detail.xmMc;
});
window.addEventListener('setWlxx', function(e) {
	second.item.wlgsmc = e.detail.wlgsmc;
});


/*回调函数--设置其他费用*/
/* window.addEventListener('setQtfy', function(e) {
	first.item.qtfylx = e.detail.qtfylx;
	first.item.qtfylxMc = e.detail.qtfylxMc;
	first.item.qtfyje = e.detail.qtfyje;
	first.cal();
}) */

//仓库名称控件点击触发事件
document.getElementById("ckMc").addEventListener('tap', function() {
	var webview = plus.webview.create('../common/select_ck.html', 'select_ck.html', webview_style, {});

	webview.addEventListener("titleUpdate", function() {
		webview.show(aniShow, 300);
	});
});

/*回调函数-给仓库名称赋值*/
window.addEventListener('setCk', function(e) {
	if (first.item.ckId == '') {
		first.item.ckId = e.detail.ckId;
		first.item.ckMc = e.detail.ckMc;
	} else {
		var xlhBz = false;
		if (first.isXlhBz) {
			$.each(first.item.spmxDataList, function(index, row) {
				if (row.kqxlhBz == '1') {
					xlhBz = true;
					return;
				}
			})
		}
		if (xlhBz && first.item.spmxDataList.length > 0) {
			if (e.detail.ckId != first.item.ckId) {
				mui.confirm('切换仓库，商品序列号将被清空，确认要切换吗?', '温馨提示', ['取消', '确认'], function(event) {
					if (event.index == 1) {
						//确认
						$.each(first.item.spmxDataList, function(index, row) {
							if (row.kqxlhBz == '1') {
								if (item.scXlhList == undefined) {
									item.scXlhList = item.xlhList;
								}
								row.xlhList = [];
								row.xssl = 0;
								return;
							}
						})
						first.item.ckId = e.detail.ckId;
						first.item.ckMc = e.detail.ckMc;
						first.cal();
					}
				}, 'div');
			}
		} else {
			first.item.ckId = e.detail.ckId;
			first.item.ckMc = e.detail.ckMc;
		}
	}

});

//销售人名称控件点击触发事件
document.getElementById("xsrMc").addEventListener('tap', function() {
	document.getElementById("xsrModal").classList.add("mui-active");

});
//销售人选择
document.querySelector('.mui-table-view.mui-table-view-radio.xsr').addEventListener('selected', function(e) {
	second.item.xsr = e.detail.el.id;
	second.item.xsrMc = e.detail.el.innerText;

	document.getElementById("xsrModal").classList.remove("mui-active");
});
document.getElementById("xsrModal_close").addEventListener("tap", function() {
	document.getElementById("xsrModal").classList.remove("mui-active");
});

//下一步按钮
document.getElementById("next").addEventListener('tap', function() {
	document.getElementById("first").classList.add("mui-hidden");
	document.getElementById("second").classList.remove("mui-hidden");

	document.getElementById("next").classList.add("mui-hidden");
	document.getElementById("pre").classList.remove("mui-hidden");
}, false);

//上一步按钮
document.getElementById("pre").addEventListener('tap', function() {
	document.getElementById("first").classList.remove("mui-hidden");
	document.getElementById("second").classList.add("mui-hidden");

	document.getElementById("next").classList.remove("mui-hidden");
	document.getElementById("pre").classList.add("mui-hidden");
}, false);

/*选择商品按钮*/
document.getElementById("xzsp_btn").addEventListener("tap", function(e) {
	if (first.item.khId == '') {
		mui.toast(getMsg('客户不能为空，请选择！'));
		return;
	}
	if (first.item.ckId == '') {
		mui.toast(getMsg('仓库不能为空，请选择！'));
		return;
	}
	var subWebview = plus.webview.create('select_xssp.html', 'select_xssp.html', webview_style, {
		item: first.item
	});
	subWebview.addEventListener("titleUpdate", function() {
		subWebview.show(aniShow, 300);
	});

});

/*回调函数-选择商品*/
window.addEventListener('selectedSpxx', function(e) {
	//商品累加，如果开启则同一商品累加
	var tspljBz = localStorage.getItem("tspljBz");
	//开启商品累加选择商品会传数据过去，同时选好后就会把数据拼接好传回来，这时直接接收即可
	if (tspljBz === '1') {
		first.item.spmxDataList = e.detail;
	} else {
		//没开启，那么就会重新增加一条数据
		first.item.spmxDataList = first.item.spmxDataList.concat(e.detail);
	}

	first.cal();
	mui('.mui-switch')['switch']()
});

/*单个商品回调函数*/
window.addEventListener('setSpNum', function(e) {
	var item = e.detail.item;
	var del = e.detail.del;
	
	//商品索引，跟del一样，不过条件不同，pchIndex是这里判断，传过来处理
	var pchIndex = e.detail.pchIndex;
	//已经处理标志，如果有多个相同id商品不同批号，在遍历中判断
	var isProcess = false;
	var kqysBz = localStorage.getItem("kqSpysBz");
	
	if (del != undefined) {
		first.item.spmxDataList.splice(del, 1);
	} else {
		if( pchIndex != undefined ){
			var it = first.item.spmxDataList[pchIndex];
			Vue.set(it, 'xssl', Number(item.xssl));
			Vue.set(it, 'xsdj', Number(item.xsdj));
			Vue.set(it, 'xsje', Number(item.xsje));
			Vue.set(it, 'spzhdj', Number(item.spzhdj));
			Vue.set(it, 'spzhje', Number(item.spzhje));
			Vue.set(it, 'dw', item.dw);
			Vue.set(it, 'dwMc', item.dwMc);
			Vue.set(it, 'mrJycgj', item.mrJycgj);
			Vue.set(it, 'xlhList', item.xlhList);
			Vue.set(it, 'scXlhList', item.scXlhList);  
			Vue.set(it, 'remarks', item.remarks);
			Vue.set(it, 'sl', item.sl);
			Vue.set(it, 'hsdj', item.hsdj);
			Vue.set(it, 'se', item.se);
			Vue.set(it, 'xscbdj', item.xscbdj);
			Vue.set(it, 'zpbz', item.zpbz);
			Vue.set(it, 'spzk', item.spzk);
			Vue.set(it, 'sjhj', item.sjhj);
			if (first.crkBz != '1' && first.isPchBz && it.kqpchBz === '1'){
				Vue.set(it, 'phId', item.phId);
				Vue.set(it, 'pch', item.pch);
				Vue.set(it, 'scrq', item.scrq);
				Vue.set(it, 'sxrq', item.sxrq);
			}
			for (var i = 0; i < first.baseXsmxExtList.length; i++) {
				Vue.set(it, first.baseXsmxExtList[i].name, item[first.baseXsmxExtList[i].name]);
			}
		} else {
			mui.each(first.item.spmxDataList, function(i, it) {
				if (it.spId == item.spId) {
					if (kqysBz == '1' && it.kqysBz == '1') {
						if (it.ys == item.ys) {
							Vue.set(it, 'xssl', Number(item.xssl));
							Vue.set(it, 'xsdj', Number(item.xsdj));
							Vue.set(it, 'xsje', Number(item.xsje));
							Vue.set(it, 'spzhdj', Number(item.spzhdj));
							Vue.set(it, 'spzhje', Number(item.spzhje));
							Vue.set(it, 'dw', item.dw);
							Vue.set(it, 'dwMc', item.dwMc);
							Vue.set(it, 'mrJycgj', item.mrJycgj);
							Vue.set(it, 'remarks', item.remarks);
							Vue.set(it, 'sl', item.sl);
							Vue.set(it, 'hsdj', item.hsdj);
							Vue.set(it, 'se', item.se);
							Vue.set(it, 'xscbdj', item.xscbdj);
							Vue.set(it, 'zpbz', item.zpbz);
							Vue.set(it, 'spzk', item.spzk);
							Vue.set(it, 'sjhj', item.sjhj);
							
							for (var i = 0; i < first.baseXsmxExtList.length; i++) {
								Vue.set(it, first.baseXsmxExtList[i].name, item[first.baseXsmxExtList[i].name]);
							}
							return;
						}
					} else if (first.crkBz != '1' && first.isPchBz && it.kqpchBz === '1') {
						if (isProcess) {
							return;
						}
						//获取原来的商品
						var tmpItem = first.item.spmxDataList[pchIndex];
						//获取原来的商品里面的批次号
						var temPch = tmpItem.pch;
						//如果是没有批次号情况下进的批次号商品详情
						if (temPch === undefined || temPch === null || temPch === "") {
							var hasEqual = false;
							var equalIndex = 0;
							mui.each(first.item.spmxDataList, function(equalI, equalIt) {
								//如果原商品中已经有同一批次号了，那么就把数据相加
								if (equalIt.pch === item.pch && item.pch !== undefined && item
									.pch !== null && item.pch !== "" && equalIt.spId == item.spId) {
									hasEqual = true;
									equalIndex = equalI;
								}
							});
							if (hasEqual) {
								//原来的商品列表有这个商品批号
								//获取已经存在相同批次号的商品,数量相加，单价，单位，折扣替换，其他在cal函数里计算
								var equalItem = first.item.spmxDataList[equalIndex];
								Vue.set(equalItem, 'xssl', formatSl(Number(equalItem.xssl) + Number(item
									.xssl)));
								Vue.set(equalItem, 'xsdj', Number(item.xsdj));
								Vue.set(equalItem, 'dw', item.dw);
								Vue.set(equalItem, 'dwMc', item.dwMc);
								Vue.set(equalItem, 'mrJycgj', item.mrJycgj);
								Vue.set(equalItem, 'remarks', item.remarks);
								Vue.set(equalItem, 'sl', item.sl);
								Vue.set(equalItem, 'spzk', item.spzk);
								Vue.set(equalItem, 'zpbz', item.zpbz);
								Vue.set(equalItem, 'hsdj', item.hsdj);
								//删除旧的无批号商品信息
								first.item.spmxDataList.splice(pchIndex, 1);
							} else {
								//原来的商品列表没有这个商品批号,这时就处理原数据
								Vue.set(tmpItem, 'xssl', Number(item.xssl));
								Vue.set(tmpItem, 'xsdj', Number(item.xsdj));
								Vue.set(tmpItem, 'xsje', Number(item.xsje));
								Vue.set(tmpItem, 'spzhdj', Number(item.spzhdj));
								Vue.set(tmpItem, 'spzhje', Number(item.spzhje));
								Vue.set(tmpItem, 'dw', item.dw);
								Vue.set(tmpItem, 'dwMc', item.dwMc);
								Vue.set(tmpItem, 'mrJycgj', item.mrJycgj);
								Vue.set(tmpItem, 'remarks', item.remarks);
								Vue.set(tmpItem, 'sl', item.sl);
								Vue.set(tmpItem, 'se', item.se);
								Vue.set(tmpItem, 'xscbdj', item.xscbdj);
								Vue.set(tmpItem, 'zpbz', item.zpbz);
								Vue.set(tmpItem, 'spzk', item.spzk);
								Vue.set(tmpItem, 'hsdj', item.hsdj);
								Vue.set(tmpItem, 'sjhj', item.sjhj);
								Vue.set(tmpItem, 'phId', item.phId);
								Vue.set(tmpItem, 'pch', item.pch);
								Vue.set(tmpItem, 'scrq', item.scrq);
								Vue.set(tmpItem, 'sxrq', item.sxrq);
							}
							isProcess = true;
						} else {
							//有批次号情况下进的批次号商品详情
							if (it.pch == item.pch) {
								Vue.set(it, 'xssl', Number(item.xssl));
								Vue.set(it, 'xsdj', Number(item.xsdj));
								Vue.set(it, 'xsje', Number(item.xsje));
								Vue.set(it, 'dw', item.dw);
								Vue.set(it, 'dwMc', item.dwMc);
								Vue.set(it, 'mrJycgj', item.mrJycgj);
								Vue.set(it, 'remarks', item.remarks);
								Vue.set(it, 'sl', item.sl);
								Vue.set(it, 'se', item.se);
								Vue.set(it, 'xscbdj', item.xscbdj);
								Vue.set(it, 'zpbz', item.zpbz);
								Vue.set(it, 'spzk', item.spzk);
								Vue.set(it, 'hsdj', item.hsdj);
								Vue.set(it, 'sjhj', item.sjhj);
								for (var i = 0; i < first.baseXsmxExtList.length; i++) {
									Vue.set(it, first.baseXsmxExtList[i].name, item[first.baseXsmxExtList[i].name]);
								}
								isProcess = true;
								return;
							}
						}

					} else {
						Vue.set(it, 'xssl', Number(item.xssl));
						Vue.set(it, 'xsdj', Number(item.xsdj));
						Vue.set(it, 'xsje', Number(item.xsje));
						Vue.set(it, 'spzhdj', Number(item.spzhdj));
						Vue.set(it, 'spzhje', Number(item.spzhje));
						Vue.set(it, 'dw', item.dw);
						Vue.set(it, 'dwMc', item.dwMc);
						Vue.set(it, 'mrJycgj', item.mrJycgj);
						Vue.set(it, 'xlhList', item.xlhList);
						Vue.set(it, 'scXlhList', item.scXlhList);
						Vue.set(it, 'remarks', item.remarks);
						Vue.set(it, 'sl', item.sl);
						Vue.set(it, 'hsdj', item.hsdj);
						Vue.set(it, 'se', item.se);
						Vue.set(it, 'xscbdj', item.xscbdj);
						Vue.set(it, 'zpbz', item.zpbz);
						Vue.set(it, 'spzk', item.spzk);
						Vue.set(it, 'sjhj', item.sjhj);
						for (var i = 0; i < first.baseXsmxExtList.length; i++) {
							Vue.set(it, first.baseXsmxExtList[i].name, item[first.baseXsmxExtList[i].name]);
						}
						return;
					}
				}
			});
		}
	}
	first.cal();
});

/*绑定扫码添加按钮*/
document.getElementById("stxm_btn").addEventListener("tap", function(e) {
	if (first.item.khId == '') {
		mui.toast(getMsg('客户不能为空，请选择！'));
		return;
	}
	if (first.item.ckId == '') {
		mui.toast(getMsg('仓库不能为空，请选择！'));
		return;
	}
	tzBarcode('xiaoshou_xz.html');
});

var spItem4Ys = null;
window.addEventListener('setYsList', function(e) {

	var ysList = e.detail.ysList;
	var spdata = new Array();
	mui.each(ysList, function(p, ys) {
		var row = {};
		mui.extend(row, spItem4Ys);
		row.ysId = ys.ysId;
		row.ys = ys.ysId;
		row.ysMc = ys.ysMc;
		row.xssl = ys.xssl;
		row.xsje = formatJe(Number(row.xssl) * Number(row.xsdj));
		row.spzk = 100;
		row.spzhdj = Number(row.spzk) / 100 * Number(row.xsdj);
		row.spzhje = Number(row.xsje) * Number(row.spzk) / 100;

		row.ysList = [];
		spdata.push(row);
	});

	var rows = new Array();
	mui.each(first.item.spmxDataList, function(index, item) {
		rows.push(mui.extend({}, item));
	});

	for (var i = 0; i < spdata.length; i++) {
		var emptyFlag = true;
		for (var j = 0; j < rows.length; j++) {
			if (rows[j].spId === spdata[i].spId) {
				if (rows[j].ys === spdata[i].ys) {
					rows[j].xssl = Number(rows[j].xssl) + Number(spdata[i].xssl);
					emptyFlag = false;
					break;
				}
			}
		}
		if (emptyFlag) {
			rows.push(spdata[i]); // 将被选中的行拼接进单据信息
		}
	}

	first.item.spmxDataList = rows;
	first.cal();
});

function selectSpxx4Barcode(barcode) {

	var xhSl = localStorage.getItem("xhSl");
	var params = {
		sptxm: barcode,
		ckId: first.item.ckId
	};

	var url = hurl + 'kcxx/findBySptxm';
	var yxfkcBz = localStorage.getItem("yxfkcBz");
	if (yxfkcBz === '1') {
		url = hurl + 'invSpxx/findBySptxm';
	}

	loafish.utils.ajax4Post(url, params, null, function(returnData) {
		if (returnData.id != null && returnData.id != '') {

			returnData.xssl = 1;
			if (first.isXlhBz && returnData.kqxlhBz === '1') {
				returnData.xssl = 0;
			}
			if (first.isPchBz && returnData.kqpchBz === '1') {
				returnData.xssl = 0;
			}
			returnData.dw = returnData.mrdw;
			returnData.dwMc = returnData.mrdwMc;
			returnData.xsdj = returnData.mrJyxsj;
			returnData.xsje = returnData.mrJyxsj;

			var hydj = first.item.khHydj;
			var hyxsj = null;
			if (returnData.hyFlag === '1' && hydj != null && hydj != '') {
				var hyStr = JSON.parse(returnData.hyStr);
				for (var i = 0; i < hyStr.length; i++) {
					if (hyStr[i].djId === hydj) {
						if (hyStr[i].hypfj == null || hyStr[i].hypfj == '' || hyStr[i].hypfj == 'null') {
							var hyzk = hyStr[i].hyzk;
							if (hyzk == null || hyzk == '' || hyzk == 'null') {
								hyzk = "100";
							}
							returnData.spzk = hyzk;
						} else {
							returnData.spzk = 100;
							returnData.xsdj = Number(hyStr[i].hypfj) * Number(returnData.fdwNum);
							returnData.xsje = returnData.xsdj;
							hyxsj = returnData.xsdj;
						}
						break;
					}
				}
			} else {
				returnData.spzk = 100;
			}

			var hyFlag = returnData.hyFlag;
			var mrscxsjBz = localStorage.getItem("mrscxsjBz");
			if (mrscxsjBz == '1') {
				if (returnData.scxsj == null) {
					if (hyFlag === '1' && hydj != null && hydj != '' && hyxsj != null) {
						//TODO
					} else {
						var sckqxsjBz = localStorage.getItem('sckqxsjBz');
						if (sckqxsjBz == '1') {
							returnData.xsdj = returnData.mrJyxsj;
						}
						if (sckqxsjBz == '2') {
							returnData.xsdj = returnData.mrJylsj;
						}
					}
				} else {
					returnData.xsdj = returnData.scxsj;
				}
			} else {
				if (hyFlag === '1' && hydj != null && hydj != '') {
					//TODO
				} else {
					returnData.xsdj = returnData.mrJyxsj;
				}
			}

			returnData.xsje = formatJe(Number(returnData.xssl) * Number(returnData.xsdj));
			returnData.spzhdj = formatJe(Number(returnData.spzk) / 100 * Number(returnData.xsdj));
			returnData.spzhje = formatJe(Number(returnData.xsje) * Number(returnData.spzk) / 100);

			if (first.isXhSlBz) {
				returnData.sl = xhSl;
				returnData.hsdj = formatDj(Number(returnData.xsdj) * (100 + Number(returnData.sl)) / 100);
				returnData.se = formatJe(Number(returnData.spzhje) * Number(returnData.sl) / 100);
				returnData.sjhj = formatJe(Number(returnData.hsdj) * Number(returnData.xssl) * Number(returnData.spzk) / 100);
			}

			var kqysBz = localStorage.getItem("kqSpysBz");
			if (kqysBz == '1' && returnData.kqysBz == '1') {
				var item = returnData;
				spItem4Ys = item;

				if (item.ysList == undefined) {
					item.ysList = [];
				}
				var extras = {
					item: item
				}
				var webview = plus.webview.create('../common/select_ys.html', 'select_ys.html', webview_style,
					extras);
				webview.addEventListener("titleUpdate", function() {
					webview.show("slide-in-right", 300);
				});
				return;
			}

			var list = [returnData];

			if (first.item.spmxDataList.length == 0) {
				first.item.spmxDataList = list;
				mui.each(first.item.spmxDataList, function(i, item) {
					item.xsje = Number(item.xssl) * Number(item.xsdj);
					item.spzhje = Number(item.xsje) * Number(item.spzk) / 100;
					
					//对扩展字段进行计算
					first.gsCal(item);
				});
			} else {
				if (first.crkBz != '1' && first.isPchBz && returnData.kqpchBz === '1') {
					returnData.xssl = 0;
					
					//对扩展字段进行计算
					first.gsCal(returnData);
					
					first.item.spmxDataList.push(returnData);
				} else {
					var spmxDataList = new Array();
					var flag = true; //同商品多批次时判断只增加一个数量

					//同商品累加标志
					var tspljBz = localStorage.getItem("tspljBz");
					if (tspljBz === '1') {
						//已经存的商品，只需要增加数量，并更新各种合计金额
						for (var i = 0; i < first.item.spmxDataList.length; i++) {
							var item = first.item.spmxDataList[i];
							var item2 = null;
							for (var j = 0; j < list.length; j++) {
								item2 = list[j];
								if (item.spId == item2.spId && flag) {
									item.xssl = Number(item.xssl) + Number(item2.xssl);
									item.xsje = Number(item.xssl) * Number(item.jyxsj);
									item.spzhdj = Number(item.spzk) / 100 * Number(item.xsdj);
									item.spzhje = Number(item.xsje) * Number(item.spzk) / 100;
									
									//对扩展字段进行计算
									first.gsCal(item);
									
									flag = false;
									break;
								}
							}
							spmxDataList.push(item);
						}
						
						//不存在的商品，追加在原商品之后
						for (var i = 0; i < list.length; i++) {
							var item2 = list[i];
							var item = null;
							var isExist = false;
						
							for (var j = 0; j < first.item.spmxDataList.length; j++) {
								var item = first.item.spmxDataList[j];
						
								if (item.spId == item2.spId) {
									isExist = true;
									break;
								}
							}
						
							if (!isExist) {
								item2.xsje = Number(item2.xssl) * Number(item2.jyxsj);
								item2.spzhdj = Number(item2.spzk) / 100 * Number(item2.xsdj);
								item2.spzhje = Number(item2.xsje) * Number(item2.spzk) / 100;
						
								//对扩展字段进行计算
								first.gsCal(item2);
								
								var pxfs = localStorage.getItem('djspPxfs');
								if(pxfs=='2'){
									spmxDataList.unshift(item2);
								}else{
									spmxDataList.push(item2);
								}
							}
						}
					} else {
						for (var i = 0; i < first.item.spmxDataList.length; i++) {
							var item = first.item.spmxDataList[i];
							
							//对扩展字段进行计算
							first.gsCal(item);
							
							spmxDataList.push(item);
						}
						
						var pxfs = localStorage.getItem('djspPxfs');
						if(pxfs=='2'){
							spmxDataList.unshift(returnData);
						}else{
							spmxDataList.push(returnData);
						}
					}

					first.item.spmxDataList = spmxDataList;
				}
			}

			first.cal();

		} else {
			mui.toast("未在库存中找到此条码！");
			playWarn();
		}
	});
}

/*扫码》添加商品*/
window.addEventListener('selectSpxx4Barcode', function(e) {
	selectSpxx4Barcode(e.detail.barcode);
});

window.addEventListener('selectSpxx4Xlh', function(e) {

	var xhSl = localStorage.getItem("xhSl");
	var xlh = e.detail.xlh;
	var params = {
		xlh: xlh,
		ckId: first.item.ckId
	};

	var url = hurl + 'kcxx/findBySpxlh';
	loafish.utils.ajax4Post(url, params, null, function(returnData) {
		if (returnData.id != null && returnData.id != '') {
			returnData.xssl = 1;
			returnData.sptxUrl = returnData.tpdz;
			returnData.dw = returnData.mrdw;
			returnData.dwMc = returnData.mrdwMc;
			returnData.xsdj = returnData.mrJyxsj;
			returnData.xsje = returnData.mrJyxsj;

			var hydj = first.item.khHydj;
			var hyxsj = null;
			if (returnData.hyFlag === '1' && hydj != null && hydj != '') {
				var hyStr = JSON.parse(returnData.hyStr);
				for (var i = 0; i < hyStr.length; i++) {
					if (hyStr[i].djId === hydj) {
						if (hyStr[i].hypfj == null || hyStr[i].hypfj == '' || hyStr[i].hypfj == 'null') {
							var hyzk = hyStr[i].hyzk;
							if (hyzk == null || hyzk == '' || hyzk == 'null') {
								hyzk = "100";
							}
							returnData.spzk = hyzk;
						} else {
							returnData.spzk = 100;
							returnData.xsdj = Number(hyStr[i].hypfj) * Number(returnData.fdwNum);
							returnData.xsje = returnData.xsdj;
							hyxsj = returnData.xsdj;
						}
						break;
					}
				}
			} else {
				returnData.spzk = 100;
			}

			var hyFlag = returnData.hyFlag;
			var mrscxsjBz = localStorage.getItem("mrscxsjBz");
			if (mrscxsjBz == '1') {
				if (returnData.scxsj == null) {
					if (hyFlag === '1' && hydj != null && hydj != '' && hyxsj != null) {
						//TODO
					} else {
						var sckqxsjBz = localStorage.getItem('sckqxsjBz');
						if (sckqxsjBz == '1') {
							returnData.xsdj = returnData.mrJyxsj;
						}
						if (sckqxsjBz == '2') {
							returnData.xsdj = returnData.mrJylsj;
						}
					}
				} else {
					returnData.xsdj = returnData.scxsj;
				}
			} else {
				if (hyFlag === '1' && hydj != null && hydj != '') {
					//TODO
				} else {
					returnData.xsdj = returnData.mrJyxsj;
				}
			}

			returnData.xsje = formatJe(Number(returnData.xssl) * Number(returnData.xsdj));
			returnData.spzhdj = formatJe(Number(returnData.spzk) / 100 * Number(returnData.xsdj));
			returnData.spzhje = formatJe(Number(returnData.xsje) * Number(returnData.spzk) / 100);
			
			//增加税率判断
			if(first.isXhSlBz) {
				returnData.sl = xhSl;
				returnData.hsdj=formatDj(Number(returnData.xsdj) * (100+Number(returnData.sl)) / 100);
				returnData.se = formatJe(Number(row.spzhje) * Number(row.sl) / 100);
				returnData.sjhj = formatJe(Number(row.hsdj) * Number(row.xssl) * Number(row.spzk) / 100);
			}

			var xlhObj = {
				xlh: xlh,
				kcmxId: returnData.kcmxId
			}

			if (first.item.spmxDataList.length == 0) {
				returnData.xlhList = [xlhObj];
				
				//对扩展字段进行计算
				first.gsCal(returnData);
				
				first.item.spmxDataList = [returnData];
			} else {
				var list = [returnData];
				var spmxDataList = new Array();
				var isExist4Spxx = false;
				var isExist4Xlh = false;

				//已经存的商品，只需要增加数量，并更新各种合计金额
				for (var i = 0; i < first.item.spmxDataList.length; i++) {
					var item = first.item.spmxDataList[i];
					var item2 = returnData;

					if (item.spId == item2.spId) {
						isExist4Spxx = true;

						mui.each(item.xlhList, function(ii, xlhItem) {
							if (xlhItem.xlh === xlh) {
								isExist4Xlh = true;
								return;
							}
						});

						if (!isExist4Xlh) {
							item.xlhList.push(xlhObj);
							item.xssl = Number(item.xssl) + 1;
							item.xsje = Number(item.xssl) * Number(item.xsdj);
							
							//对扩展字段进行计算
							first.gsCal(item);
						}
					}
					
					spmxDataList.push(item);
				}

				if (isExist4Xlh) {
					mui.toast("该序列号已被扫入（商品编号：" + returnData.spBh + "，名称：" + returnData.spMc + "），请核实！");
					return;
				}

				if (!isExist4Spxx) {
					returnData.xlhList = [xlhObj];
					
					//对扩展字段进行计算
					first.gsCal(returnData);
					
					var pxfs = localStorage.getItem('djspPxfs');
					if(pxfs=='2'){
						spmxDataList.unshift(returnData);
					}else{
						spmxDataList.push(returnData);
					}
				}

				first.item.spmxDataList = spmxDataList;
			}

			first.cal();
		} else {
			mui.toast("未找到相应商品，请核实！");
			playWarn();
		}
	});
});

/*回调函数--设置结算账户*/
window.addEventListener('setJszh', function(e) {
	first.item.jszh = e.detail.jszhId;
	first.item.jszhMc = e.detail.jszhMc;
})

window.addEventListener('setOrg', function(e) {
	first.item.orgId = e.detail.orgId;
	first.item.orgMc = e.detail.orgMc;
})

//绑定完成按钮
function save(shzt) {
	//如果为赠品要将价格单价和税额为0
	for (var i = 0; i < first.item.spmxDataList.length; i++) {
		if (first.item.spmxDataList[i].zpbz == "1") {
			first.item.spmxDataList[i].xsdj = 0;
			first.item.spmxDataList[i].se = 0;
			first.item.spmxDataList[i].xsje = 0.00;
			first.item.spmxDataList[i].xstc = 0.00;
		}
	}

	var params = {};
	mui.extend(params, first.item);
	params.shzt = shzt;
	params.spmxDataList = first.item.spmxDataList;
	params.shfs = second.item.shfs;
	if (params.shfs == '2') {
		params.shsj = second.item.shsj;
		params.shlxr = second.item.shlxr;
		params.shlxdh = second.item.shlxdh;
		params.shdz = second.item.shdz;
		params.wlgsmc = second.item.wlgsmc;
		params.shdh = second.item.shdh;
	}

	params.xsr = second.item.xsr;
	params.xsrMc = second.item.xsrMc;
	params.remarks = second.item.remarks;
	params.yhhje = footer.item.yhhje;

	var zzdj = [];
	mui.each(first.item.zzdjs, function(index, item) {
		zzdj.push(item.tpId)
	});
	params.zzdjs = zzdj.join('&');

	//1、表单验证
	if (params.khMc == '') {
		mui.toast('客户不能为空，请选择！');
		return;
	}

	if (params.djrq == '') {
		mui.toast('销售日期不能为空，请选择！');
		return;
	}
	var djrq = document.getElementById("djrq").validity;
	if (!djrq.valid) {
		mui.toast('销售日期格式不正确，请修正！');
		return;
	}
	if (params.ckMc == '') {
		mui.toast('出货仓库不能为空，请选择！');
		return;
	}
	if (params.ckrq == '') {
		mui.toast('出库日期不能为空，请选择！');
		return;
	}
	var ckrq = document.getElementById("ckrq").validity;
	if (!ckrq.valid) {
		mui.toast('出库日期格式不正确，请修正！');
		return;
	}
	
	if(mustArr.length > 0){
		var flag = false;
		for (var i = 0; i < mustArr.length; i++) {
			var item = mustArr[i];
			var lable = item.lable;
			var name = item.name;
			if ($.trim(params[name]) == '') {
				if(item.dataType == '3'){
					mui.toast(lable+"不能为空，请选择！");
				} else {
					mui.toast(lable+"不能为空，请填写！");
				}
				
				flag = true;
				break;
			}
		}
		if(flag){
			return;
		}
	}

	if (first.item.spmxDataList.length == 0) {
		mui.toast('请选择要销售的商品！');
		return;
	}

	var isFlag = false;
	mui.each(first.item.spmxDataList, function(index, item) {
		if (item.xssl == '' || item.xssl == 0) {
			isFlag = true;
			mui.toast('存在销售数量为0的商品，请修正！');
			return false;
		}
		if (first.crkBz !== '1' && first.isPchBz && item.kqpchBz === '1') {
			if (item.pch === undefined || item.pch === "" || item.pch === null) {
				isFlag = true;
				mui.toast('商品【' + item.spMc + '】批次号为空，请选择！');
				return false;
			}
		}
	})

	if (isFlag) {
		return false;
	}

	if (params.shfs === '2') {
		if (params.shsj == '') {
			mui.toast('送货时间不能为空，请选择！');
			return;
		}
		if (params.shlxr == '') {
			mui.toast('客户联系人不能为空，请填写！');
			return;
		}
		if (params.shlxdh == '') {
			mui.toast('送货联系电话不能为空，请填写！');
			return;
		}
		if (params.shdz == '') {
			mui.toast('送货联系地址不能为空，请填写！');
			return;
		}
	}

	//销价检测 和 现结同时开启
	if (first.xsjcBz && first.isXjBz) {
		var xsjcFlag = false;
		var tipMsg = '';
		mui.each(first.item.spmxDataList, function(index, item) {
			if (Number(item.xsdj) < Number(item.mrJycgj)) {
				xsjcFlag = true;
				tipMsg += item.spMc + '、'
			}
		});
		if (xsjcFlag) {
			tipMsg = tipMsg.substring(0, tipMsg.length - 1);
			
			var xsjcFs = localStorage.getItem('xsjcFs');
			if (xsjcFs === '2') {
				mui.alert("商品【" + tipMsg + "】销售价低于进货价，不允许下单！");
				return;
			} else {
				mui.confirm('商品【' + tipMsg + '】销售价低于进货价，是否提交？', '温馨提示', ['取消', '确定'], function(e) {
					if (e.index == 1) {
						if (first.item.jszh == '' || first.item.jszh == null || first.item.yfk == '' || first.item
							.yfk == null) {
							mui.confirm('您已启用现结，结算账户/现结款为空，是否继续提交？', '温馨提示', ['取消', '确定'], function(e) {
								if (e.index == 1) {
									saveXiaoShou(params);
								} else {
									return;
								}
							}, 'div')
						} else {
							var yfhqk = formatJe(first.item.yfhqk);
							if (Number(yfhqk) < 0) {
								mui.toast("现结(预付)款不能大于总计，请确认！");
								return;
							}
							saveXiaoShou(params);
						}
					} else {
						return;
					}
				}, 'div');
			}
		} else {
			if (first.item.jszh == '' || first.item.jszh == null || first.item.yfk == '' || first.item.yfk == null) {
				mui.confirm('您已启用现结，结算账户/现结款为空，是否继续提交？', '温馨提示', ['取消', '确定'], function(e) {
					if (e.index == 1) {
						saveXiaoShou(params);
					} else {
						return;
					}
				}, 'div')
			} else {
				var yfhqk = formatJe(first.item.yfhqk);
				if (Number(yfhqk) < 0) {
					mui.toast("现结(预付)款不能大于总计，请确认！");
					return;
				}
				saveXiaoShou(params);
			}
		}
		return;
	} else if (first.xsjcBz) {
		//销价检查
		var xsjcFlag = false;
		var tipMsg = '';
		mui.each(first.item.spmxDataList, function(index, item) {
			if (Number(item.xsdj) < Number(item.mrJycgj)) {
				xsjcFlag = true;
				tipMsg += item.spMc + ','
			}
		});
		if (xsjcFlag) {
			tipMsg = tipMsg.substring(0, tipMsg.length - 1);
			var xsjcFs = localStorage.getItem('xsjcFs');
			if (xsjcFs === '2') {
				mui.alert("商品【" + tipMsg + "】销售价低于进货价，不允许下单！");
				return;
			} else {
				mui.confirm('商品【' + tipMsg + '】销售价低于进货价！确定要继续完成吗？', '温馨提示', ['取消', '确定'], function(e) {
					if (e.index == 1) {
						saveXiaoShou(params);
					} else {
						return;
					}
				}, 'div');
			}
		} else {
			saveXiaoShou(params);
		}
		return;
	} else if (first.isXjBz) {
		//现结
		if (first.item.jszh == '' || first.item.jszh == null || first.item.yfk == '' || first.item.yfk == null) {
			mui.confirm('您已启用现结，结算账户/现结款为空，是否继续提交？', '温馨提示', ['取消', '确定'], function(e) {
				if (e.index == 1) {
					saveXiaoShou(params);
				} else {
					return;
				}
			}, 'div')
		} else {
			var yfhqk = formatJe(first.item.yfhqk);
			if (Number(yfhqk) < 0) {
				mui.toast("现结(预付)款不能大于总计，请确认！");
				return;
			}
			saveXiaoShou(params);
		}
		return;
	}
	saveXiaoShou(params);

}

//保存销售单信息
function saveXiaoShou(params) {
	var xyEd = first.item.xyEd;
	var flag = false;
	if (first.isXjBz) {
		flag = (xyEd !== null && xyEd !== undefined && xyEd !== '' && (Number(first.item.yhhje) + Number(first.item
			.ljqk) - Number(first.item.yfk) > Number(xyEd)));
	} else {
		flag = (xyEd !== null && xyEd !== undefined && xyEd !== '' && (Number(first.item.yhhje) + Number(first.item
			.ljqk) > Number(xyEd)));
	}
	if (flag) {
		var xyedFs = localStorage.getItem('xyedFs');
		if (xyedFs === '2') {
			mui.alert("客户信用额度已不足，不允许下单！");
			return;
		} else {
			mui.confirm('该客户信用额度已不足，是否继续提交？', '温馨提示', ['取消', '确定'], function(e) {
				if (e.index == 1) {
					saveXiaoShou1(params);
				} else {
					return;
				}
			}, 'div');
		}
	} else {
		saveXiaoShou1(params);
	}


}


function saveXiaoShou1(params) {
	//只允许点击一次完成，避免多次生成数据
	if (first.isFinish) {
		return;
	}
	first.isFinish = true;

	if (first.tag == "copy") {
		params.id = null;
		params.ddBh = null;
	}
	var url = hurl + 'xsdmx/save';

	loafish.utils.ajax4Post(url, params, "application/json", function(returnData) {

		if (returnData.success) {
			var data = returnData.data;

			first.item.id = data.id;
			first.item.djBh = data.djBh;

			var mainPage = plus.webview.getWebviewById("guanhuo/xiaoshou.html");
			mui.fire(mainPage, "queryXsd", {});

			//刷新待办事项
			var dbPage = plus.webview.getWebviewById("daiban.html");
			mui.fire(dbPage, "loadDbNum", {});
			if(params.shzt === '1'){
                mui.toast('操作成功！');
				//跳转至收打印单据页面
				var webview = plus.webview.create('xsSuccess.html', 'xsSuccess.html',
					webview_style, {
						item : first.item,
						spmxDataList : first.item.spmxDataList,
						showPrintBtn:footer.showPrintBtn
					});
					webview.show("slide-in-right", 300);
					_self.close();
					
			}else if (isUpdate) {
				mui.back = function() {
					if(mainPage!=null){
						mainPage.show();
					} else {
						plus.webview.currentWebview().close();
					}
				}
				mui.back();
				mui.toast('操作成功！');
			}else {
                mui.back();
                mui.toast('操作成功！');
			}

		} else {
			mui.toast(returnData.msg);
			first.isFinish = false;
		}
	});
}

function getCk() {
	var url = hurl + '/invCk/list';
	var params = {
		page: 1,
		rows: 1,
		kjckfw: '0',
		isLock: '0'
	};

	var kjckfwBz = localStorage.getItem('kjckfw');
	params.kjckfw = kjckfwBz;

	loafish.utils.ajax4Get(url, params, null, function(returnData) {
		var list = returnData.rows;
		if (list != null && list.length > 0) {
			var ck = list[0];
			first.item.ckId = ck.id;
			first.item.ckMc = ck.ckMc;
		}
	});
}


function getJszh() {
	var url = hurl + '/invJszh/queryAll';
	var params = {
		page: 1,
		rows: 1,
		khId: first.item.khId,
		khYsk: first.item.khYsk
	};

	loafish.utils.ajax4Get(url, params, null, function(returnData) {
		var list = returnData;
		if (list != null && list.length > 0) {
			var jszh = list[0];
			first.item.jszh = jszh.id;
			first.item.jszhMc = jszh.zhmc
		}
	});
}

var isUpdate = false;
var _self;
var mustArr = [];
mui.plusReady(function() {
	_self = plus.webview.currentWebview();
	list_xsr.isIos = mui.os.ios;

	mui.extend(first.item, _self.item);
	mui.extend(second.item, _self.item);
	mui.extend(footer.item, _self.item);
	first.tag = _self.tag;
	first.hasXtcsPermission();
	first.baseXsdExtList = JSON.parse(localStorage.getItem('baseXsdExtList'));
	if(first.baseXsdExtList == null){
		first.baseXsdExtList = [];
	}
	first.baseXsdExtList.forEach(function(base, index){
		if(base.mustFlag != null && base.mustFlag == '1'){
			mustArr.push({ lable : base.lable, name : base.name, dataType: base.dataType });
		}
	});
	
	first.baseXsmxExtList = JSON.parse(localStorage.getItem('baseXsmxExtList'));
	if(first.baseXsmxExtList == null){
		first.baseXsmxExtList = [];
	}
	
	first.cal();
	
	var showCbj = localStorage.getItem('zdycbjBz');
	first.zqglBz = localStorage.getItem("zqglBz");
	if (showCbj == '1') {
		first.showCbj = true;
	}
	var xsjcBz = localStorage.getItem('xsjcBz');
	if (xsjcBz == '1') {
		first.xsjcBz = true;
	}
	
	var kjxsdjBz = localStorage.getItem('kjxsdjBz');
	if (kjxsdjBz == '1') {
		first.isTxjgBz = true;
		footer.isTxjgBz = true;
	}

	first.showXlh = (localStorage.getItem('xlhBz') == '1' && scanModel == 'PHONE');

	if (first.item.id != null && first.item.id != '') {
		if (first.tag) {
			document.getElementById("title").innerText = getMsg("复制销售单");
			first.item.djrq = new Date().Format("yyyy-MM-dd");
			first.item.ckrq = new Date().Format("yyyy-MM-dd");
			second.item.shsj = new Date().Format("yyyy-MM-dd");
			first.item.shDate = null;

			mui.each(first.item.spmxDataList, function(index, item) {
				var ddwStr = JSON.parse(item.ddwStr);
				mui.each(ddwStr, function(i, dwStr) {
					if (item.dw == dwStr.dw) {
						if (dwStr.jycbj == null || dwStr.jycbj == '') {
							item.xscbdj = dwStr.jycgj;
						} else {
							item.xscbdj = dwStr.jycbj;
						}
					}
				})
			})

		} else {
			document.getElementById("title").innerText = getMsg("修改销售单");
		}
		isUpdate = true;

		if (first.item.khId == first.item.jszh) {
			first.item.jszhMc = '预收款（¥' + formatJe(first.item.khYsk) + ')';
		}
	} else {

		second.item.xsr = loafish.utils.getUserId();
		second.item.xsrMc = loafish.utils.getUserName();

		first.item.orgId = (localStorage.getItem('orgId'));
		first.item.orgMc = (localStorage.getItem('orgMc'));

		getCk();
		
		if(first.tag == 'geneXsd'){
			first.item.isFirst = false;
			getXsddMxData(first.item.dsdId);
		}

	}
	//没有jszh
	if (first.item.jszh == '') {
		getJszh();
	}
	first.showXsbm = (localStorage.getItem('dxsbmBz') == '1');

	if (scanModel == 'PDA') {
		pageInit()
		setTimeout(function() {
			pdaScan(function(barcode) {
				selectSpxx4Barcode(barcode);
			})
		}, 300);
	}

	//权限获取
	footer.menuList = getMenuList("guanhuo/xiaoshou.html");
	footer.hasPermission();
	
	first.isEnabledSplc4Xsd = localStorage.getItem("isEnabledSplc4Xsd");
	footer.isEnabledSplc4Xsd = localStorage.getItem("isEnabledSplc4Xsd");
});

function getXsddMxData(dsdId) {
	var url = hurl + 'xsdmx/query';

	var params = {
		dsdId: dsdId,
		tag: "geneXsd"
	}

	loafish.utils.ajax4Get(url, params, null, function(returnData) {
		var datalist = returnData.mxData;
		first.item.spmxDataList = datalist;
		first.cal();
	});
}

/**
 * 获取商品价格(主要为拿取上次销售价格)
 * @param {Object} khId
 * @param {Object} item
 */
function getScXsdj(spId, dwId, jyxsj, jylsj) {

	var url = hurl + "invSpxx/getSpjg";
	var params = {
		spId: spId,
		khId: first.item.khId,
		dwId: dwId
	};

	var spjg = null;
	var xscbdj = null;
	loafish.utils.ajax4Get(url, params, null, function(returnData) {
		if (returnData != null) {
			spjg = returnData.scxsj;
			xscbdj = returnData.xscbdj;
		}
	}, false);

	var sckqxsjBz = localStorage.getItem('sckqxsjBz');
	if (spjg == null && sckqxsjBz != '0') {
		if (sckqxsjBz == '1') {
			spjg = jyxsj;
		} else if (sckqxsjBz == '2') {
			spjg = jylsj;
		}
	}

	return {
		spjg: spjg,
		xscbdj: xscbdj
	};
}

mui('.mui-scroll-wrapper').scroll({})
