var tipMsg = '图片最多允许上传3张！！';
var tipTitle = '上传图片'; 
/*上传纸质单据*/
document.getElementById("zzdj_btn").addEventListener("tap", function(e) {
	var zzdjs = (mainVue.item.zzdjs).length + (mainVue.item.zzdjDataList).length;
	if(zzdjs >= 3) {
			mui.toast(tipMsg);
		return;
	}

	if(mui.os.plus) {
		var a = [{
			title: "拍照"
		}, {
			title: "从相册选择"
		}];

		plus.nativeUI.actionSheet({
			title: tipTitle,
			cancel: "取消",
			buttons: a
		}, function(b) { /*actionSheet 按钮点击事件*/
			switch(b.index) {
				case 0:
					break;
				case 1:
					getImage(); /*拍照*/
					break;
				case 2:
					galleryImg(); /*打开相册*/
					break;
				default:
					break;
			}
		})
	}
});

//拍照
function getImage() {
	var c = plus.camera.getCamera();
	c.captureImage(function(e) {
		plus.io.resolveLocalFileSystemURL(e, function(entry) {
			var s = entry.toLocalURL();
			var index = (mainVue.item.zzdjDataList).length;
			var str = '<div style="height: 64px; width: auto; float: left; margin-right: 15px;margin-top: -5px;">' +
				'<div style="height: 10px;margin-right: -10px;position: relative;float: right;">' +
				'<span class="mui-icon iconfont icon-shanchu1" style="font-size: 20px;color: red;background-color: #FFFFFF;' +
				'border-radius: 10px;" onclick="del_xzzzdj(' + index + ')"></span></div><div style="height: 64px;">' +
				'<img src="' + s + '" data-preview-src="" data-preview-group="1" /></div></div>';
			$("#xzzzdj").append(str);

			var tpmc = s.substring(s.lastIndexOf("/") + 1);

			var image = new Image();
			image.src = s;
			image.onload = function() {
				var imgData = getBase64Image(image);
				mainVue.item.zzdjDataList.push({
					tpmc: tpmc,
					tp4Base64: imgData,
					img: s
				});
			}

		}, function(e) {
			console.log("读取拍照文件错误：" + e.message);
		});
	}, function(s) {
		console.log("error" + s);
	})
}

//本地相册选择
function galleryImg() {
	plus.gallery.pick(function(e) {
		var index = (mainVue.item.zzdjDataList).length;
		var str = '<div style="height: 64px; width: auto; float: left; margin-right: 15px;margin-top: -5px;">' +
			'<div style="height: 10px;margin-right: -10px;position: relative;float: right;">' +
			'<span class="mui-icon iconfont icon-shanchu1" style="font-size: 20px;color: red;background-color: #FFFFFF;' +
			'border-radius: 10px;" onclick="del_xzzzdj(' + index + ')"></span></div><div style="height: 64px;">' +
			'<img src="' + e + '" data-preview-src="" data-preview-group="1" /></div></div>';
		$("#xzzzdj").append(str);
		var tpmc = e.substring(e.lastIndexOf("/") + 1);

		var image = new Image();
		image.src = e;
		image.onload = function() {
			var imgData = getBase64Image(image);
			mainVue.item.zzdjDataList.push({
				tpmc: tpmc,
				tp4Base64: imgData,
				img: e
			});
		}

	}, function(e) {
		//outSet( "取消选择图片" );
	}, {
		filter: "image"
	});

}

//将图片压缩转成base64
function getBase64Image(img) {
	var canvas = document.createElement("canvas");
	var width = img.width;
	var height = img.height;
	/*var screenWidth = plus.screen.resolutionWidth; //屏幕宽度
	
	if(width > screenWidth) {
		height = Math.round(height / width * screenWidth);
		width = screenWidth;
	}*/
	
	canvas.width = width; /*设置新的图片的宽度*/
	canvas.height = height; /*设置新的图片的长度*/
	var ctx = canvas.getContext("2d");
	ctx.drawImage(img, 0, 0, width, height); /*绘图*/
	var dataURL = canvas.toDataURL("image/png", 0.9);
	return dataURL.replace("data:image/png;base64,", "");
}

mui.plusReady(function() {
	var zzdjs = null;
	if(mainVue.item.id != null && mainVue.item.id != '') {
		if(mainVue.item !=null && mainVue.item.zzdjs!=null){
			zzdjs = mainVue.item.zzdjs
		}
	}

	initZzdj(zzdjs);
})

function initZzdj(zzdjs) {
	var str = "";
	mui.each(zzdjs, function(index, zzdj) {
		str += '<div style="height: 64px; width: auto; float: left; margin-right: 15px;margin-top: -5px;">' +
			'<div style="height: 10px;margin-right: -10px;position: relative;float: right;">' +
			'<span class="mui-icon iconfont icon-shanchu1" style="font-size: 20px;color: red;background-color: #FFFFFF;' +
			'border-radius: 10px;" onclick="del_zzdj(' + index + ')"></span></div><div style="height: 64px;">' +
			'<img src="' + zzdj.tpdz + '" data-preview-src="" data-preview-group="1" /></div></div>';
	});
	var zzdjDataList = mainVue.item.zzdjDataList;
	mui.each(zzdjDataList, function(index, item) {
		str += '<div style="height: 64px; width: auto; float: left; margin-right: 15px;margin-top: -5px;">' +
			'<div style="height: 10px;margin-right: -10px;position: relative;float: right;">' +
			'<span class="mui-icon iconfont icon-shanchu1" style="font-size: 20px;color: red;background-color: #FFFFFF;' +
			'border-radius: 10px;" onclick="del_xzzzdj(' + index + ')"></span></div><div style="height: 64px;">' +
			'<img src="' + item.img + '" data-preview-src="" data-preview-group="1" /></div></div>';
	});
	$("#xzzzdj").html(str);
}
/*删除加载图片*/
function del_zzdj(index) {
	mainVue.item.zzdjs.splice(index, 1);
	initZzdj(mainVue.item.zzdjs)
}
//删除选择的图片
function del_xzzzdj(index) {
	mainVue.item.zzdjDataList.splice(index, 1);
	initZzdj(mainVue.item.zzdjs)
}