var shares ;

/**
 * 1、更新分享服务(页面加载完成后必须要调用)
 */
function getShareSerivces(){
    plus.share.getServices( function(s){
        shares={};
        for(var i in s){
            var t=s[i];
            shares[t.id]=t;
        }
    }, function(e){
        mui.toast("获取分享服务列表失败："+e.message );
    } );
}

/**
 * 2、点击分享按钮触发的事件
 */
function doShareText(cotent){
	
	var ss = shares['weixin'];
	var shareBts=[
		{title:'微信朋友圈',s:ss,x:'WXSceneTimeline'},
		{title:'微信好友',s:ss,x:'WXSceneSession'}
	];
    
    // 弹出分享列表
    if(shareBts.length>0){
    	plus.nativeUI.actionSheet(
    		{title:'分享链接',cancel:'取消',buttons:shareBts},
    		function(e){
        		if(e.index>0) {
        			var sb = shareBts[e.index-1];
        			
				    var msg={extra:{scene:sb.x}};
			        msg.type="text",
			        msg.content = cotent;
			        msg.thumbs = ["_www/logo.png"];
			        msg.pictures = ["_www/logo.png"];
				    
				    // 发送分享
				    if ( sb.s.authenticated ) {
				        shareMessage(msg,sb.s);
				    } else {
				        sb.s.authorize( function(){
				                shareMessage(msg,sb.s);
				            },function(e){
				                alert("认证授权失败："+e.code+" - "+e.message);
				        	}
				        );
				    }
        			
        		}
    		}
    	);
    }else{
    	mui.alert('当前环境无法支持分享链接操作!');
    }
}

/**
 * 2、点击分享按钮触发的事件
 */
function doShareLink(href, title, cotent){
	
	var ss = shares['weixin'];
	var shareBts=[
		{title:'微信朋友圈',s:ss,x:'WXSceneTimeline'},
		{title:'微信好友',s:ss,x:'WXSceneSession'}
	];
    
    // 弹出分享列表
    if(shareBts.length>0){
    	plus.nativeUI.actionSheet(
    		{title:'分享链接',cancel:'取消',buttons:shareBts},
    		function(e){
        		if(e.index>0) {
        			var sb = shareBts[e.index-1];
        			
				    var msg={extra:{scene:sb.x}};
				    msg.type = "web",
			        msg.href = href;
			        msg.title = title;
			        msg.content = cotent;
			        msg.thumbs = ["_www/logo.png"];
			        msg.pictures = ["_www/logo.png"];
				    
				    // 发送分享
				    if ( sb.s.authenticated ) {
				        shareMessage(msg,sb.s);
				    } else {
				        sb.s.authorize( function(){
				                shareMessage(msg,sb.s);
				            },function(e){
				                alert("认证授权失败："+e.code+" - "+e.message);
				        	}
				        );
				    }
        			
        		}
    		}
    	);
    }else{
    	mui.alert('当前环境无法支持分享链接操作!');
    }
}

/**
 * 分享给微信朋友圈
 * @param {Object} href
 * @param {Object} title
 * @param {Object} cotent
 */
function doShareLink2WxPyq(href, title, cotent){
	
	var ss = shares['weixin'];
	var sb = {title:'微信朋友圈',s:ss,x:'WXSceneTimeline'};
	
    var msg={extra:{scene:sb.x}};
    msg.type="web",
    msg.href = href;
    msg.title = title;
    msg.content = cotent;
    msg.thumbs = ["_www/logo.png"];
    msg.pictures = ["_www/logo.png"];
    
    // 发送分享
    if ( sb.s.authenticated ) {
        shareMessage(msg,sb.s);
    } else {
        sb.s.authorize( function(){
                shareMessage(msg,sb.s);
            },function(e){
                alert("认证授权失败："+e.code+" - "+e.message);
        	}
        );
    }
    
}

/**
 * 分享给微信好友
 * @param {Object} href
 * @param {Object} title
 * @param {Object} cotent
 */
function doShareLink2WxHy(href, title, cotent){
	
	var ss = shares['weixin'];
    
	var sb = {title:'微信好友',s:ss,x:'WXSceneSession'};
	
    var msg={extra:{scene:sb.x}};
     msg.type="web",
    msg.href = href;
    msg.title = title;
    msg.content = cotent;
    msg.thumbs = ["_www/logo.png"];
    msg.pictures = ["_www/logo.png"];
    
    // 发送分享
    if ( sb.s.authenticated ) {
        shareMessage(msg,sb.s);
    } else {
        sb.s.authorize( function(){
                shareMessage(msg,sb.s);
            },function(e){
                alert("认证授权失败："+e.code+" - "+e.message);
        	}
        );
    }
		
}

/**
 * 分享图片
 * @param {JSON} sb 分享操作对象s.s为分享通道对象(plus.share.ShareService)
 */
function doSharePicture(filename){
	var ss = shares['weixin'];
	var shareBts=[
		{title:'微信朋友圈',s:ss,x:'WXSceneTimeline'},
		{title:'微信好友',s:ss,x:'WXSceneSession'}
	];
    
    // 弹出分享列表
    if(shareBts.length>0){
    	plus.nativeUI.actionSheet(
    		{title:'分享到',cancel:'取消',buttons:shareBts},
    		function(e){
        		if(e.index>0) {
        			var sb = shareBts[e.index-1];
        			
        			var msg={
        				extra:{scene:sb.x},
        				pictures: [filename]
        			};
        			 msg.type="image",
                    
                   	shareMessage(msg,sb.s);
        		}
        	}
    	);
    }else{
    	mui.alert('当前环境无法支持分享图片操作!');
    }
	
}
    
/**
   * 发送分享消息
   * @param {JSON} msg
   * @param {plus.share.ShareService} s
   */
function shareMessage(msg,s){
    
    s.send( msg, function(){
       mui.toast("分享到\""+s.description+"\"成功！ " );
    }, function(e){
       mui.toast( "分享到\""+s.description+"\"失败: "+JSON.stringify(e) );
    } );
}